更新日志
********


Python 下一版
=============

*发布日期: XXXX-XX-XX*


安全
----

* bpo-43434: Creating a "sqlite3.Connection" object now also produces
  a "sqlite3.connect" auditing event. Previously this event was only
  produced by "sqlite3.connect()" calls. Patch by Erlend E. Aasland.

* bpo-43472: Ensures interpreter-level audit hooks receive the
  "cpython.PyInterpreterState_New" event when called through the
  "_xxsubinterpreters" module.

* bpo-43075： 修复了 "urllib.request.AbstractBasicAuthHandler" 中的正
  则表达式拒绝服务（ReDoS）漏洞。易受 ReDoS 攻击的正则表达式在最坏情况
  下具有二次复杂度，并且在验证一个精心制作的无效 RFCs 时它会导致拒绝服
  务。这个 ReDoS 问题发生在客户端，需要远程攻击者控制 HTTP 服务器。


核心与内置
----------

* bpo-43105: Importlib now resolves relative paths when creating
  module spec objects from file locations.

* bpo-42924: Fix "bytearray" repetition incorrectly copying data from
  the start of the buffer, even if the data is offset within the
  buffer (e.g. after reassigning a slice at the start of the
  "bytearray" to a shorter byte string).


库
--

* bpo-43993: Update bundled pip to 21.1.1.

* bpo-43937: Fixed the "turtle" module working with non-default root
  window.

* bpo-43930: Update bundled pip to 21.1 and setuptools to 56.0.0

* bpo-43920: OpenSSL 3.0.0: "load_verify_locations()" now returns a
  consistent error message when cadata contains no valid certificate.

* bpo-43607: "urllib" can now convert Windows paths with "\\?\"
  prefixes into URL paths.

* bpo-43284: platform.win32_ver derives the windows version from
  sys.getwindowsversion().platform_version which in turn derives the
  version from kernel32.dll (which can be of a different version than
  Windows itself). Therefore change the platform.win32_ver to
  determine the version using the platform module's _syscmd_ver
  private function to return an accurate version.

* bpo-42248: [Enum] ensure exceptions raised in "_missing__" are
  released

* bpo-43799: OpenSSL 3.0.0: define "OPENSSL_API_COMPAT" 1.1.1 to
  suppress deprecation warnings. Python requires OpenSSL 1.1.1 APIs.

* bpo-43794: Add "ssl.OP_IGNORE_UNEXPECTED_EOF" constants (OpenSSL
  3.0.0)

* bpo-43789: OpenSSL 3.0.0: Don't call the password callback function
  a second time when first call has signaled an error condition.

* bpo-43788: The header files for "ssl" error codes are now OpenSSL
  version-specific. Exceptions will now show correct reason and
  library codes. The "make_ssl_data.py" script has been rewritten to
  use OpenSSL's text file with error codes.

* bpo-43655: "tkinter" dialog windows are now recognized as dialogs by
  window managers on macOS and X Window.

* bpo-43534: "turtle.textinput()" and "turtle.numinput()" create now a
  transient window working on behalf of the canvas window.

* bpo-43522: Fix problem with "hostname_checks_common_name". OpenSSL
  does not copy hostflags from *struct SSL_CTX* to *struct SSL*.

* bpo-42967: Allow "bytes" "separator" argument in
  "urllib.parse.parse_qs" and "urllib.parse.parse_qsl" when parsing
  "str" query strings. Previously, this raised a "TypeError".

* bpo-43176: Fixed processing of a dataclass that inherits from a
  frozen dataclass with no fields.  It is now correctly detected as an
  error.

* bpo-34463: Fixed discrepancy between "traceback" and the interpreter
  in formatting of SyntaxError with lineno not set ("traceback" was
  changed to match interpreter).

* bpo-41735: Fix thread locks in zlib module may go wrong in rare
  case. Patch by Ma Lin.

* bpo-26053: Fixed bug where the "pdb" interactive run command echoed
  the args from the shell command line, even if those have been
  overridden at the pdb prompt.

* bpo-36470: Fix dataclasses with "InitVar"s and "replace()". Patch by
  Claudiu Popa.

* bpo-28577: The hosts method on 32-bit prefix length IPv4Networks and
  128-bit prefix IPv6Networks now returns a list containing the single
  Address instead of an empty list.

* bpo-32745: Fix a regression in the handling of ctypes'
  "ctypes.c_wchar_p" type: embedded null characters would cause a
  "ValueError" to be raised. Patch by Zackery Spytz.


文档
----

* bpo-43959: The documentation on the PyContextVar C-API was
  clarified.

* bpo-43938: Update dataclasses documentation to express that
  FrozenInstanceError is derived from AttributeError.

* bpo-43739: Fixing the example code in Doc/extending/extending.rst to
  declare and initialize the pmodule variable to be of the right type.


测试
----

* bpo-43842: Fix a race condition in the SMTP test of test_logging.
  Don't close a file descriptor (socket) from a different thread while
  asyncore.loop() is polling the file descriptor. Patch by Victor
  Stinner.

* bpo-43811: Tests multiple OpenSSL versions on GitHub Actions. Use
  ccache to speed up testing.

* bpo-43791: OpenSSL 3.0.0: Disable testing of legacy protocols TLS
  1.0 and 1.1. Tests are failing with TLSV1_ALERT_INTERNAL_ERROR.


Windows
-------

* bpo-35306: Avoid raising errors from "pathlib.Path.exists()" when
  passed an invalid filename.

* bpo-38822: Fixed "os.stat()" failing on inaccessible directories
  with a trailing slash, rather than falling back to the parent
  directory's metadata. This implicitly affected "os.path.exists()"
  and "os.path.isdir()".

* bpo-26227: Fixed decoding of host names in "socket.gethostbyaddr()"
  and "socket.gethostbyname_ex()".

* bpo-43745: Actually updates Windows release to OpenSSL 1.1.1k.
  Earlier releases were mislabelled and actually included 1.1.1i
  again.

* bpo-43492: Upgrade Windows installer to use SQLite 3.35.5.


macOS
-----

* bpo-44009: Provide "python3.x-intel64" executable to allow reliably
  forcing macOS universal2 framework builds to run under Rosetta 2
  Intel-64 emulation on Apple Silicon Macs.  This can be useful for
  testing or when universal2 wheels are not yet available.

* bpo-41100: As of 3.8.10, Python now supports building and running on
  macOS 11 (Big Sur) and on Apple Silicon Macs (based on the "ARM64"
  architecture). A new universal build variant, "universal2", is also
  available to natively support both "ARM64" and "Intel 64" in one set
  of executables. This backport from Python 3.9 does not include
  support for "weaklinking"; to support a range of macOS versions,
  continue to target for and build on the oldest version in the range;
  for 3.8.x, the "universal2" variant is only useful on macOS 11 or
  later.

* bpo-43492: Update macOS installer to use SQLite 3.35.4.


IDLE
----

* bpo-43655: IDLE dialog windows are now recognized as dialogs by
  window managers on macOS and X Window.


C API
-----

* bpo-43962: _PyInterpreterState_IDIncref() now calls
  _PyInterpreterState_IDInitref() and always increments id_refcount.
  Previously, calling _xxsubinterpreters.get_current() could create an
  id_refcount inconsistency when a _xxsubinterpreters.InterpreterID
  object was deallocated. Patch by Victor Stinner.


Python 3.8.9 final
==================

*Release date: 2021-04-02*


安全
----

* bpo-42988: CVE-2021-3426: Remove the "getfile" feature of the
  "pydoc" module which could be abused to read arbitrary files on the
  disk (directory traversal vulnerability). Moreover, even source code
  of Python modules can contain sensitive data like passwords.
  Vulnerability reported by David Schwörer.

* bpo-43285: "ftplib" no longer trusts the IP address value returned
  from the server in response to the PASV command by default.  This
  prevents a malicious FTP server from using the response to probe
  IPv4 address and port combinations on the client network.

  Code that requires the former vulnerable behavior may set a
  "trust_server_pasv_ipv4_address" attribute on their "ftplib.FTP"
  instances to "True" to re-enable it.

* bpo-43439: Add audit hooks for "gc.get_objects()",
  "gc.get_referrers()" and "gc.get_referents()". Patch by Pablo
  Galindo.


核心与内置
----------

* bpo-43660: Fix crash that happens when replacing "sys.stderr" with a
  callable that can remove the object while an exception is being
  printed. Patch by Pablo Galindo.

* bpo-35883: Python no longer fails at startup with a fatal error if a
  command line argument contains an invalid Unicode character. The
  "Py_DecodeLocale()" function now escapes byte sequences which would
  be decoded as Unicode characters outside the [U+0000; U+10ffff]
  range.

* bpo-43406: Fix a possible race condition where "PyErr_CheckSignals"
  tries to execute a non-Python signal handler.


库
--

* bpo-35930: Raising an exception raised in a "future" instance will
  create reference cycles.

* bpo-43577: Fix deadlock when using "ssl.SSLContext" debug callback
  with "ssl.SSLContext.sni_callback()".

* bpo-43423: "subprocess.communicate()" no longer raises an IndexError
  when there is an empty stdout or stderr IO buffer during a timeout
  on Windows.

* bpo-27820: Fixed long-standing bug of smtplib.SMTP where doing AUTH
  LOGIN with initial_response_ok=False will fail.

  The cause is that SMTP.auth_login _always_ returns a password if
  provided with a challenge string, thus non-compliant with the
  standard for AUTH LOGIN.

  Also fixes bug with the test for smtpd.

* bpo-43399: Fix "ElementTree.extend" not working on iterators when
  using the Python implementation

* bpo-43316: The "python -m gzip" command line application now
  properly fails when detecting an unsupported extension. It exits
  with a non-zero exit code and prints an error message to stderr.

* bpo-43260: Fix TextIOWrapper can not flush internal buffer forever
  after very large text is written.

* bpo-42782: Fail fast in "shutil.move()" to avoid creating
  destination directories on failure.

* bpo-37193: Fixed memory leak in "socketserver.ThreadingMixIn"
  introduced in Python 3.7.


文档
----

* bpo-43199: Answer "Why is there no goto?" in the Design and History
  FAQ.

* bpo-43407: Clarified that a result from "time.monotonic()",
  "time.perf_counter()", "time.process_time()", or
  "time.thread_time()" can be compared with the result from any
  following call to the same function - not just the next immediate
  call.

* bpo-27646: Clarify that 'yield from <expr>' works with any iterable,
  not just iterators.

* bpo-36346: Update some deprecated unicode APIs which are documented
  as "will be removed in 4.0" to "3.12". See **PEP 623** for detail.


测试
----

* bpo-37945: Fix test_getsetlocale_issue1813() of test_locale: skip
  the test if "setlocale()" fails. Patch by Victor Stinner.

* bpo-41561: Add workaround for Ubuntu's custom OpenSSL security level
  policy.


构建
----

* bpo-43631: Update macOS, Windows, and CI to OpenSSL 1.1.1k.

* bpo-43617: Improve configure.ac: Check for presence of autoconf-
  archive package and remove our copies of M4 macros.


macOS
-----

* bpo-41837: Update macOS installer build to use OpenSSL 1.1.1j.


IDLE
----

* bpo-42225: Document that IDLE can fail on Unix either from
  misconfigured IP masquerage rules or failure displaying complex
  colored (non-ascii) characters.

* bpo-43283: Document why printing to IDLE's Shell is often slower
  than printing to a system terminal and that it can be made faster by
  pre-formatting a single string before printing.


Python 3.8.8 final
==================

*发布日期: 2021-02-19*

在 3.8.8 版本中没有新的更改。


Python 3.8.8 rc1
================

*发布日期: 2021-02-16*


安全
----

* bpo-42967: Fix web cache poisoning vulnerability by defaulting the
  query args separator to "&", and allowing the user to choose a
  custom separator.

* bpo-42938: 在计算 "ctypes.c_double" 和 "ctypes.c_longdouble" 值的表
  示形式时避免静态缓冲区。


核心与内置
----------

* bpo-42819: "readline": Explicitly disable bracketed paste in the
  interactive interpreter, even if it's set in the inputrc, is enabled
  by default (eg GNU Readline 8.1), or a user calls
  "readline.read_init_file()". The Python REPL has not implemented
  bracketed paste support. Also, bracketed mode writes the
  ""\x1b[?2004h"" escape sequence into stdout which causes test
  failures in applications that don't support it. It can still be
  explicitly enabled by calling "readline.parse_and_bind("set enable-
  bracketed-paste on")". Patch by Dustin Rodrigues.


库
--

* bpo-43108: 修复 "curses" 模块中的引用泄漏。由Pablo Galindo修正。

* bpo-42780: Fix os.set_inheritable() for O_PATH file descriptors on
  Linux.

* bpo-41748: Fix HTMLParser parsing rules for element attributes
  containing commas with spaces. Patch by Karl Dubost.

* bpo-42759: Fixed equality comparison of "tkinter.Variable" and
  "tkinter.font.Font". Objects which belong to different Tcl
  interpreters are now always different, even if they have the same
  name.

* bpo-23328: Allow / character in username, password fields on _PROXY
  envars.

* bpo-42681: Fixed range checks for color and pair numbers in
  "curses".

* bpo-42531: "importlib.resources.path()" now works for *package*s
  missing the optional "__file__" attribute (more specifically,
  packages whose "__spec__"".""origin" "is" "None").

* bpo-42388: Fix subprocess.check_output(..., input=None) behavior
  when text=True to be consistent with that of the documentation and
  universal_newlines=True.

* bpo-42384: Make pdb populate sys.path[0] exactly the same as regular
  python execution.

* bpo-42383: pdb修复: 之前的 pdb 在指定路径时如果使用了相对路径，并且
  当前路径发生改变后重启调试目标会失败的问题。

* bpo-42318: Fixed support of non-BMP characters in "tkinter" on
  macOS.

* bpo-42005: Fix CLI of "cProfile" and "profile" to catch
  "BrokenPipeError".

* bpo-41604: Don't decrement the reference count of the previous
  user_ptr when set_panel_userptr fails.

* bpo-26407: Unexpected errors in calling the "__iter__" method are no
  longer masked by "TypeError" in "csv.reader()",
  "csv.writer.writerow()" and "csv.writer.writerows()".

* bpo-39068: Fix initialization race condition in "a85encode()" and
  "b85encode()" in "base64". Patch by Brandon Stansbury.

* bpo-36589: The "curses.update_lines_cols()" function now returns
  "None" instead of "1" on success.

* bpo-33289: Correct call to "tkinter.colorchooser" to return RGB
  triplet of ints instead of floats.  Patch by Cheryl Sabella.


文档
----

* bpo-40304: Fix doc for type(name, bases, dict).  Patch by Boris
  Verkhovskiy and Éric Araujo.

* bpo-42811: Updated importlib.utils.resolve_name() doc to use
  __spec__.parent instead of __package__. (Thanks Yair Frid.)


测试
----

* bpo-42794: Update test_nntplib to use offical group name of
  news.aioe.org for testing. Patch by Dong-hee Na.

* bpo-40810: In "sqlite3", fix "CheckTraceCallbackContent" for SQLite
  pre 3.7.15.


构建
----

* bpo-29076: Add fish shell support to macOS installer.


Windows
-------

* bpo-41837: Updated Windows installer to include OpenSSL 1.1.1i

* bpo-42584: Upgrade Windows installer to use SQLite 3.34.0.


macOS
-----

* bpo-41837: Update macOS installer build to use OpenSSL 1.1.1i.

* bpo-42584: Update macOS installer to use SQLite 3.34.0.


IDLE
----

* bpo-43008: Make IDLE invoke "sys.excepthook()" in normal, 2-process
  mode. Patch by Ken Hilton.

* bpo-33065: Fix problem debugging user classes with __repr__ method.

* bpo-42508: Keep IDLE running on macOS.  Remove obsolete workaround
  that prevented running files with shortcuts when using new
  universal2 installers built on macOS 11.

* bpo-23544: Disable Debug=>Stack Viewer when user code is running or
  Debugger is active, to prevent hang or crash.  Patch by Zackery
  Spytz.

* bpo-32631: Finish zzdummy example extension module: make menu
  entries work; add docstrings and tests with 100% coverage.


工具/示例
---------

* bpo-42726: Fixed Python 3 compatibility issue with gdb/libpython.py
  handling of attribute dictionaries.


C API
-----

* bpo-43030: Fixed a compiler warning in "Py_UNICODE_ISSPACE()" on
  platforms with signed "wchar_t".

* bpo-40052: Fix an alignment build warning/error in function
  "PyVectorcall_Function()". Patch by Andreas Schneider, Antoine
  Pitrou and Petr Viktorin.


Python 3.8.7 final
==================

*Release date: 2020-12-21*


核心与内置
----------

* bpo-32381: 修复了在 Windows 上运行 ".pyc" 文件时的编码格式名称，现在
  "PyRun_SimpleFileExFlags()" 会使用正确的编码格式来编码文件名。

* bpo-42536: g一些内置和标准库类型现在会确保其内部结果元组总是会被 *垃
  圾回收器* 所追踪:

  * "collections.OrderedDict.items()"

  * "dict.items()"

  * "enumerate()"

  * "functools.reduce()"

  * "itertools.combinations()"

  * "itertools.combinations_with_replacement()"

  * "itertools.permutations()"

  * "itertools.product()"

  * "itertools.zip_longest()"

  * "zip()"

  之前，它们可能会被前一次垃圾回收取消追踪。 由 Brandt Bucher 提供补丁
  。


库
--

* bpo-42630: "tkinter" functions and constructors which need a default
  root window raise now "RuntimeError" with descriptive message
  instead of obscure "AttributeError" or "NameError" if it is not
  created yet or cannot be created automatically.

* bpo-42644: "logging.disable" will now validate the types and value
  of its parameter. It also now accepts strings representing the
  levels (as does "loging.setLevel") instead of only the numerical
  values.

* bpo-36541: Fixed lib2to3.pgen2 to be able to parse PEP-570
  positional only argument syntax.

* bpo-42375: subprocess module update for DragonFlyBSD support.

* bpo-39825: Windows: Change "sysconfig.get_config_var('EXT_SUFFIX')"
  to the expected full "platform_tag.extension" format. Previously it
  was hard-coded to ".pyd", now it is compatible with
  "distutils.sysconfig" and will result in something like
  ".cp38-win_amd64.pyd". This brings windows into conformance with the
  other platforms.

* bpo-39101: Fixed tests using IsolatedAsyncioTestCase from hanging on
  BaseExceptions.

* bpo-41907: fix "format()" behavior for "IntFlag"

* bpo-41889: Enum: fix regression involving inheriting a multiply-
  inherited enum

* bpo-41891: Ensure asyncio.wait_for waits for task completion

* bpo-40219: Lowered "tkinter.ttk.LabeledScale" dummy widget to
  prevent hiding part of the content label.

* bpo-40084: Fix "Enum.__dir__": dir(Enum.member) now includes
  attributes as well as methods.


文档
----

* bpo-17140: Add documentation for the
  "multiprocessing.pool.ThreadPool" class.


构建
----

* bpo-42604: Now all platforms use a value for the "EXT_SUFFIX" build
  variable derived from SOABI (for instance in freeBSD, "EXT_SUFFIX"
  is now ".cpython-310d.so" instead of ".so"). Previosuly only Linux,
  Mac and VxWorks were using a value for "EXT_SUFFIX" that included
  "SOABI".

* bpo-42598: Fix implicit function declarations in configure which
  could have resulted in incorrect configuration checks.  Patch
  contributed by Joshua Root.


工具/示例
---------

* bpo-42613: Fix "freeze.py" tool to use the prope config and library
  directories. Patch by Victor Stinner.


Python 3.8.7 release candidate 1
================================

*Release date: 2020-12-07*


安全
----

* bpo-42103: Prevented potential DoS attack via CPU and RAM exhaustion
  when processing malformed Apple Property List files in binary
  format.

* bpo-42051：模块 "plistlib" 不再接受 XML 属性列表文件中的实体声明（避
  免引发 XML 脆弱性）。此更改不应该影响用户使用，因为实体声明在常规属
  性列表文件中不被使用。

* bpo-40791: Add "volatile" to the accumulator variable in
  "hmac.compare_digest", making constant-time-defeating optimizations
  less likely.


核心与内置
----------

* bpo-41686: On Windows, the "SIGINT" event, "_PyOS_SigintEvent()", is
  now created even if Python is configured to not install signal
  handlers (if "PyConfig.install_signal_handlers" equals to 0, or
  "Py_InitializeEx(0)").

* bpo-42143: Fix handling of errors during creation of
  "PyFunctionObject", which resulted in operations on uninitialized
  memory. Patch by Yonatan Goldschmidt.

* bpo-41984: 垃圾回收器现在会跟踪所有用户定义类。 由 Brandt Bucher 修
  复。

* bpo-41909: Fixed stack overflow in "issubclass()" and "isinstance()"
  when getting the "__bases__" attribute leads to infinite recursion.

* bpo-41894: When loading a native module and a load failure occurs,
  prevent a possible UnicodeDecodeError when not running in a UTF-8
  locale by decoding the load error message using the current locale's
  encoding.


库
--

* bpo-17735: "inspect.findsource()" now raises "OSError" instead of
  "IndexError" when "co_lineno" of a code object is greater than the
  file length. This can happen, for example, when a file is edited
  after it was imported.  PR by Irit Katriel.

* bpo-42116: Fix handling of trailing comments by
  "inspect.getsource()".

* bpo-42482: "TracebackException" no longer holds a reference to the
  exception's traceback object. Consequently, instances of
  TracebackException for equivalent but non-equal exceptions now
  compare as equal.

* bpo-42406: We fixed an issue in "pickle.whichmodule" in which
  importing "multiprocessing" could change the how pickle identifies
  which module an object belongs to, potentially breaking the
  unpickling of those objects.

* bpo-42328: Fixed "tkinter.ttk.Style.map()". The function accepts now
  the representation of the default state as empty sequence (as
  returned by "Style.map()"). The structure of the result is now the
  same on all platform and does not depend on the value of
  "wantobjects".

* bpo-42014: The "onerror" callback from "shutil.rmtree" now receives
  correct function when "os.open" fails.

* bpo-42237: Fix "os.sendfile()" on illumos.

* bpo-42249: Fixed writing binary Plist files larger than 4 GiB.

* bpo-35455: On Solaris, "thread_time()" is now implemented with
  "gethrvtime()" because "clock_gettime(CLOCK_THREAD_CPUTIME_ID)" is
  not always available. Patch by Jakub Kulik.

* bpo-41754: webbrowser: Ignore *NotADirectoryError* when calling
  "xdg-settings".

* bpo-29566: "binhex.binhex()" consisently writes macOS 9 line
  endings.

* bpo-42183: Fix a stack overflow error for asyncio Task or Future
  repr().

  在 Task 或 Future 递归返回自身的情形下会导致栈溢出。

* bpo-42103: "InvalidFileException" and "RecursionError" are now the
  only errors caused by loading malformed binary Plist file
  (previously ValueError and TypeError could be raised in some
  specific cases).

* bpo-41491: plistlib: fix parsing XML plists with hexadecimal integer
  values

* bpo-32498: Clearer exception message when passing an argument of
  type bytes to "urllib.parse.unquote()".  This is only for 3.8; in
  3.9 and later this function accepts bytes inputs as well.  PR by
  Irit Katriel.

* bpo-42065: Fix an incorrectly formatted error from
  "_codecs.charmap_decode()" when called with a mapped value outside
  the range of valid Unicode code points. PR by Max Bernstein.

* bpo-41966: Fix pickling pure Python "datetime.time" subclasses.
  Patch by Dean Inwood.

* bpo-41976: Fixed a bug that was causing "ctypes.util.find_library()"
  to return "None" when triying to locate a library in an environment
  when gcc>=9 is available and "ldconfig" is not. Patch by Pablo
  Galindo

* bpo-41900: C14N 2.0 serialisation in xml.etree.ElementTree failed
  for unprefixed attributes when a default namespace was defined.

* bpo-41855: In "importlib.metadata", fix issue where multiple
  children can be returned from "FastPath.zip_children()". Backport of
  python-devs/importlib_metadata#117.

* bpo-41840: Fix a bug in the "symtable" module that was causing
  module-scope global variables to not be reported as both local and
  global. Patch by Pablo Galindo.

* bpo-41831: "str()" for the "type" attribute of the "tkinter.Event"
  object always returns now the numeric code returned by Tk instead of
  the name of the event type.

* bpo-41662: No longer override exceptions raised in "__len__()" of a
  sequence of parameters in "sqlite3" with "ProgrammingError".

* bpo-41662: Fixed crash when mutate list of parameters during
  iteration in "sqlite3".

* bpo-34215: Clarify the error message for
  "asyncio.IncompleteReadError" when "expected" is "None".

* bpo-41316: Fix the "tarfile" module to write only basename of TAR
  file to GZIP compression header.

* bpo-12800: Extracting a symlink from a tarball should succeed and
  overwrite the symlink if it already exists. The fix is to remove the
  existing file or symlink before extraction. Based on patch by Chris
  AtLee, Jeffrey Kintscher, and Senthil Kumaran.

* bpo-16936: Allow "ctypes.wintypes" to be imported on non-Windows
  systems.

* bpo-40592: "shutil.which()" now ignores empty entries in "PATHEXT"
  instead of treating them as a match.

* bpo-40492: Fix "--outfile" for "cProfile" / "profile" not writing
  the output file in the original directory when the program being
  profiled changes the working directory.  PR by Anthony Sottile.

* bpo-40105: ZipFile truncates files to avoid corruption when a
  shorter comment is provided in append ("a") mode. Patch by Jan
  Mazur.

* bpo-27321: Fixed KeyError exception when flattening an email to a
  string attempts to replace a non-existent Content-Transfer-Encoding
  header.

* bpo-32793: Fix a duplicated debug message when
  "smtplib.SMTP.connect()" is called.


文档
----

* bpo-42153: Fix the URL for the IMAP protocol documents.

* bpo-41910: 记录 "object.__eq__" 的默认实现。

* bpo-41774: In Programming FAQ "Sequences (Tuples/Lists)" section,
  add "How do you remove multiple items from a list".

* bpo-39416: Document some restrictions on the default string
  representations of numeric classes.


测试
----

* bpo-41473: Reenable test_gdb on gdb 9.2 and newer:
  https://bugzilla.redhat.com/show_bug.cgi?id=1866884 bug is fixed in
  gdb 10.1.

* bpo-42553: Fix "test_asyncio.test_call_later()" race condition:
  don't measure asyncio performance in the "call_later()" unit test.
  The test failed randomly on the CI.

* bpo-40754: Include "_testinternalcapi" module in Windows installer
  for test suite

* bpo-41739: Fix
  test_logging.test_race_between_set_target_and_flush(): the test now
  waits until all threads complete to avoid leaking running threads.

* bpo-41944: Tests for CJK codecs no longer call "eval()" on content
  received via HTTP.

* bpo-41939: Fix test_site.test_license_exists_at_url(): call
  "urllib.request.urlcleanup()" to reset the global
  "urllib.request._opener". Patch by Victor Stinner.

* bpo-41561: test_ssl: skip test_min_max_version_mismatch when TLS 1.0
  is not available

* bpo-41602: Add tests for SIGINT handling in the runpy module.

* bpo-41306: Fixed a failure in "test_tk.test_widgets.ScaleTest"
  happening when executing the test with Tk 8.6.10.


构建
----

* bpo-42398: Fix a race condition in "make regen-all" when make -jN
  option is used to run jobs in parallel. The clinic.py script now
  only use atomic write to write files. Moveover, generated files are
  now left unchanged if the content does not change, to not change the
  file modification time.


Windows
-------

* bpo-42120: Remove macro definition of "copysign" (to "_copysign") in
  headers.

* bpo-38439: Updates the icons for IDLE in the Windows Store package.

* bpo-41557: Update Windows installer to use SQLite 3.33.0.

* bpo-38324: Avoid Unicode errors when accessing certain locale data
  on Windows.


macOS
-----

* bpo-38443: The "--enable-universalsdk" and "--with-universal-archs"
  options for the configure script now check that the specified
  architectures can be used.

* bpo-41471: Ignore invalid prefix lengths in system proxy excludes.

* bpo-41557: Update macOS installer to use SQLite 3.33.0.


IDLE
----

* bpo-42426: Fix reporting offset of the RE error in searchengine.

* bpo-42415: Get docstrings for IDLE calltips more often by using
  inspect.getdoc.

* bpo-33987: Mostly finish using ttk widgets, mainly for editor,
  settings, and searches. Some patches by Mark Roseman.

* bpo-41775: Use 'IDLE Shell' as shell title

* bpo-40511: Typing opening and closing parentheses inside the
  parentheses of a function call will no longer cause unnecessary
  "flashing" off and on of an existing open call-tip, e.g. when typed
  in a string literal.

* bpo-38439: Add a 256×256 pixel IDLE icon to the Windows .ico file.
  Created by Andrew Clover. Remove the low-color gif variations from
  the .ico file.


C API
-----

* bpo-41986: "Py_FileSystemDefaultEncodeErrors" and "Py_UTF8Mode" are
  available again in limited API.


Python 3.8.6 final
==================

*Release date: 2020-09-23*


核心与内置
----------

* bpo-41525: The output of "python --help" contains now only ASCII
  characters.


库
--

* bpo-41817: fix "tkinter.EventType" Enum so all members are strings,
  and none are tuples

* bpo-41815: Fix SQLite3 segfault when backing up closed database.
  Patch contributed by Peter David McCormick.

* bpo-41517: fix bug allowing Enums to be extended via multiple
  inheritance

* bpo-39587: use the correct mix-in data type when constructing Enums

* bpo-41789: Honor "object" overrides in "Enum" class creation
  (specifically, "__str__", "__repr__", "__format__", and
  "__reduce_ex__").

* bpo-39651: Fix a race condition in the "call_soon_threadsafe()"
  method of "asyncio.ProactorEventLoop": do nothing if the self-pipe
  socket has been closed.

* bpo-41720: Fixed "turtle.Vec2D.__rmul__()" for arguments which are
  not int or float.

* bpo-39728: fix default "_missing_" so a duplicate "ValueError" is
  not set as the "__context__" of the original "ValueError"

* bpo-37479: When "Enum.__str__" is overridden in a derived class, the
  override will be used by "Enum.__format__" regardless of whether
  mixin classes are present.


文档
----

* bpo-35293: Fix RemovedInSphinx40Warning when building the
  documentation. Patch by Dong-hee Na.

* bpo-37149: Change Shipman tkinter doc link from archive.org to
  TkDocs. (The doc has been removed from the NMT server.)  The new
  link responds much faster and includes a short explanatory note.


测试
----

* bpo-41731: Make test_cmd_line_script pass with option '-vv'.


Windows
-------

* bpo-41744: Fixes automatic import of props file when using the Nuget
  package.


IDLE
----

* bpo-35764: Rewrite the Calltips doc section.

* bpo-40181: In calltips, stop reminding that '/' marks the end of
  positional-only arguments.


Python 3.8.6 release candidate 1
================================

*Release date: 2020-09-07*


核心与内置
----------

* bpo-41654: Fix a crash that occurred when destroying subclasses of
  "MemoryError". Patch by Pablo Galindo.

* bpo-41533: Free the stack allocated in "va_build_stack" if
  "do_mkstack" fails and the stack is not a "small_stack".

* bpo-38156: 正确地处理 "PyOS_StdioReadline" 中 EOF 之后的中断。


库
--

* bpo-41696: Fix handling of debug mode in "asyncio.run()". This
  allows setting "PYTHONASYNCIODEBUG" or "-X dev" to enable asyncio
  debug mode when using "asyncio.run()".

* bpo-39010: Restarting a "ProactorEventLoop" on Windows no longer
  logs spurious "ConnectionResetErrors".

* bpo-41609: The pdb whatis command correctly reports instance methods
  as 'Method' rather than 'Function'.

* bpo-32751: When cancelling the task due to a timeout,
  "asyncio.wait_for()" will now wait until the cancellation is
  complete also in the case when *timeout* is <= 0, like it does with
  positive timeouts.

* bpo-37658: "asyncio.wait_for()" now properly handles races between
  cancellation of itself and the completion of the wrapped awaitable.

* bpo-40782: Change the method
  asyncio.AbstractEventLoop.run_in_executor to not be a coroutine.

* bpo-41520: Fix "codeop" regression that prevented turning compile
  warnings into errors.

* bpo-41503: Fixed a race between setTarget and flush in
  logging.handlers.MemoryHandler.

* bpo-41497: 在 dis 模块中修复潜在的 UnicodeDecodeError。

* bpo-41490: 更新 "ensurepip" 以安装 pip 20.2.1 和 setuptools 49.2.1。

* bpo-41467: 在 Windows 上，修复 asyncio "recv_into()" 当套接字/管道被
  关闭时的返回值 ("BrokenPipeError")：返回 "0" 而不是空字节串 ("b''")
  。

* bpo-41425: 让 tkinter 文档示例可运行。

* bpo-41384: 当传给 tkinter.OptionMenu 的选项未知时引发 TclError 而不
  是 TypeError。

* bpo-38731: 修复了 "py_compile" 模块命令行界面下的 "NameError"。

* bpo-41364: 减少 "uuid" 的导入开销。

* bpo-41344: Prevent creating "shared_memory.SharedMemory" objects
  with "size=0".

* bpo-40726: 处理在 "ast.increment_lineno()" 上 "end_lineno" 为 "None"
  的情况。

* bpo-31122: ssl.wrap_socket() now raises ssl.SSLEOFError rather than
  OSError when peer closes connection during TLS negotiation

* bpo-33660: Fix pathlib.PosixPath to resolve a relative path located
  on the root directory properly.


文档
----

* bpo-41624: Fix the signature of "typing.Coroutine".

* bpo-40204: Enable Sphinx 3.2 "c_allow_pre_v3" option and disable
  "c_warn_on_allowed_pre_v3" option to make the documentation
  compatible with Sphinx 2 and Sphinx 3.

* bpo-41045: 添加了 关于f-strings调试功能的文档.

* bpo-41314: 将``from __future__ import annotations`` 的默认值由 "4.0"
  变更到``3.10`` (参考 PEP 563的变更).

* bpo-39883: Make code, examples, and recipes in the Python
  documentation be licensed under the more permissive BSD0 license in
  addition to the existing Python 2.0 license.


Windows
-------

* bpo-41492: 修复了UAC提示的描述.

* bpo-40741: 更新 Windows 版本以支持 SQLite 3.32.3.


IDLE
----

* bpo-41468: 改进IDIE运行错误信息 (也许用户永远都看不到).

* bpo-41373: Save files loaded with no line ending, as when blank, or
  different line endings, by setting its line ending to the system
  default. Fix regression in 3.8.4 and 3.9.0b4.


C API
-----

* bpo-41524: Fix bug in PyOS_mystrnicmp and PyOS_mystricmp that
  incremented pointers beyond the end of a string.


Python 3.8.5 final
==================

*Release date: 2020-07-20*


安全
----

* bpo-41304: Fixes "python3x._pth" being ignored on Windows, caused by
  the fix for bpo-29778 (CVE-2020-15801).

* bpo-39603: Prevent http header injection by rejecting control
  characters in http.client.putrequest(...).


核心与内置
----------

* bpo-41295: Resolve a regression in CPython 3.8.4 where defining
  "__setattr__" in a multi-inheritance setup and calling up the
  hierarchy chain could fail if builtins/extension types were involved
  in the base types.


库
--

* bpo-41288: Unpickling invalid NEWOBJ_EX opcode with the C
  implementation raises now UnpicklingError instead of crashing.

* bpo-39017: Avoid infinite loop when reading specially crafted TAR
  files using the tarfile module (CVE-2019-20907).


文档
----

* bpo-37703: Updated Documentation to comprehensively elaborate on the
  behaviour of gather.cancel()


构建
----

* bpo-41302: Enable building Python 3.8 with libmpdec-2.5.0 to ease
  maintenance for Linux distributions. Patch by Felix Yan.


macOS
-----

* bpo-40741: Update macOS installer to use SQLite 3.32.3.


IDLE
----

* bpo-41300: Save files with non-ascii chars. Fix regression released
  in 3.9.0b4 and 3.8.4.


Python 3.8.4 final
==================

*Release date: 2020-07-13*


安全
----

* bpo-41162: Audit hooks are now cleared later during finalization to
  avoid missing events.

* bpo-29778: Ensure "python3.dll" is loaded from correct locations
  when Python is embedded (CVE-2020-15523).


核心与内置
----------

* bpo-41247: Always cache the running loop holder when running
  "asyncio.set_running_loop".

* bpo-41252: Fix incorrect refcounting in _ssl.c's
  "_servername_callback()".

* bpo-41218: Python 3.8.3 had a regression where compiling with
  ast.PyCF_ALLOW_TOP_LEVEL_AWAIT would aggressively mark list
  comprehension with CO_COROUTINE. Now only list comprehension making
  use of async/await will tagged as so.

* bpo-41175: Guard against a NULL pointer dereference within
  bytearrayobject triggered by the "bytearray() + bytearray()"
  operation.

* bpo-39960: The "hackcheck" that prevents sneaking around a type's
  __setattr__() by calling the superclass method was rewritten to
  allow C implemented heap types.


库
--

* bpo-41235: Fix the error handling in
  "ssl.SSLContext.load_dh_params()".

* bpo-41193: The "write_history()" atexit function of the readline
  completer now ignores any "OSError" to ignore error if the
  filesystem is read-only, instead of only ignoring
  "FileNotFoundError" and "PermissionError".

* bpo-41043: Fixed the use of "glob()" in the stdlib: literal part of
  the path is now always correctly escaped.

* bpo-39384: Fixed email.contentmanager to allow set_content() to set
  a null string.


IDLE
----

* bpo-37765: Add keywords to module name completion list.  Rewrite
  Completions section of IDLE doc.

* bpo-41152: The encoding of "stdin", "stdout" and "stderr" in IDLE is
  now always UTF-8.


Python 3.8.4 release candidate 1
================================

*Release date: 2020-06-29*


安全
----

* bpo-41004: The __hash__() methods of  ipaddress.IPv4Interface and
  ipaddress.IPv6Interface incorrectly generated constant hash values
  of 32 and 128 respectively. This resulted in always causing hash
  collisions. The fix uses hash() to generate hash values for the
  tuple of (address, mask length, network address).

* bpo-39073: Disallow CR or LF in email.headerregistry.Address
  arguments to guard against header injection attacks.


核心与内置
----------

* bpo-41094: Fix decoding errors with audit when open files with non-
  ASCII names on non-UTF-8 locale.

* bpo-41056: Fixes a reference to deallocated stack space during
  startup when constructing sys.path involving a relative symlink when
  code was supplied via -c.  (discovered via Coverity)

* bpo-35975: Stefan Behnel reported that cf_feature_version is used
  even when PyCF_ONLY_AST is not set. This is against the intention
  and against the documented behavior, so it's been fixed.

* bpo-40957: Fix refleak in _Py_fopen_obj() when PySys_Audit() fails

* bpo-40870: Raise "ValueError" when validating custom AST's where the
  constants "True", "False" and "None" are used within a "ast.Name"
  node.

* bpo-40826: Fix GIL usage in "PyOS_Readline()": lock the GIL to set
  an exception and pass the Python thread state when checking if there
  is a pending signal.

* bpo-40824: Unexpected errors in calling the "__iter__" method are no
  longer masked by "TypeError" in the "in" operator and functions
  "contains()", "indexOf()" and "countOf()" of the "operator" module.

* bpo-40663: Correctly generate annotations where parentheses are
  omitted but required (e.g: "Type[(str, int, *other))]".


库
--

* bpo-41138: Fixed the "trace" module CLI for Python source files with
  non-UTF-8 encoding.

* bpo-31938: Fix default-value signatures of several functions in the
  "select" module - by Anthony Sottile.

* bpo-41068: Fixed reading files with non-ASCII names from ZIP archive
  directly after writing them.

* bpo-41058: "pdb.find_function()" now correctly determines the source
  file encoding.

* bpo-41056: Fix a NULL pointer dereference within the ssl module
  during a MemoryError in the keylog callback. (discovered by
  Coverity)

* bpo-41048: "mimetypes.read_mime_types()" function reads the rule
  file using UTF-8 encoding, not the locale encoding. Patch by
  Srinivas Reddy Thatiparthy.

* bpo-40448: "ensurepip" now disables the use of "pip" cache when
  installing the bundled versions of "pip" and "setuptools".  Patch by
  Krzysztof Konopko.

* bpo-40855: The standard deviation and variance functions in the
  statistics module were ignoring their mu and xbar arguments.

* bpo-40807: Stop codeop._maybe_compile, used by
  code.InteractiveInterpreter (and IDLE). from from emitting each
  warning three times.

* bpo-40834: Fix truncate when sending str object
  with_xxsubinterpreters.channel_send.

* bpo-38488: Update ensurepip to install pip 20.1.1 and setuptools
  47.1.0.

* bpo-40767: "webbrowser" now properly finds the default browser in
  pure Wayland systems by checking the WAYLAND_DISPLAY environment
  variable. Patch contributed by Jérémy Attali.

* bpo-40795: "ctypes" module: If ctypes fails to convert the result of
  a callback or if a ctypes callback function raises an exception,
  sys.unraisablehook is now called with an exception set. Previously,
  the error was logged into stderr by "PyErr_Print()".

* bpo-30008: Fix "ssl" code to be compatible with OpenSSL 1.1.x builds
  that use "no-deprecated" and "--api=1.1.0".

* bpo-40614: "ast.parse()" will not parse self documenting expressions
  in f-strings when passed "feature_version" is less than "(3, 8)".

* bpo-40626: Add h5 file extension as MIME Type application/x-hdf5, as
  per HDF Group recommendation for HDF5 formatted data files. Patch
  contributed by Mark Schwab.

* bpo-25872: "linecache" could crash with a "KeyError" when accessed
  from multiple threads. Fix by Michael Graczyk.

* bpo-40597: If text content lines are longer than
  policy.max_line_length, always use a content-encoding to make sure
  they are wrapped.

* bpo-40515: The "ssl" and "hashlib" modules now actively check that
  OpenSSL is build with thread support. Python 3.7.0 made thread
  support mandatory and no longer works safely with a no-thread
  builds.

* bpo-13097: "ctypes" now raises an "ArgumentError" when a callback is
  invoked with more than 1024 arguments.

* bpo-40457: The ssl module now support OpenSSL builds without TLS 1.0
  and 1.1 methods.

* bpo-39830: Add "zipfile.Path" to "__all__" in the "zipfile" module.

* bpo-40025: Raise TypeError when _generate_next_value_ is defined
  after members. Patch by Ethan Onstott.

* bpo-39244: Fixed "multiprocessing.context.get_all_start_methods" to
  properly return the default method first on macOS.

* bpo-39040: Fix parsing of invalid mime headers parameters by
  collapsing whitespace between encoded words in a bare-quote-string.

* bpo-35714: "struct.error" is now raised if there is a null character
  in a "struct" format string.

* bpo-36290: AST nodes are now raising "TypeError" on conflicting
  keyword arguments. Patch contributed by Rémi Lapeyre.

* bpo-29620: "assertWarns()" no longer raises a "RuntimeException"
  when accessing a module's "__warningregistry__" causes importation
  of a new module, or when a new module is imported in another thread.
  Patch by Kernc.

* bpo-34226: Fix "cgi.parse_multipart" without content_length. Patch
  by Roger Duran


测试
----

* bpo-41085: Fix integer overflow in the "array.array.index()" method
  on 64-bit Windows for index larger than "2**31".

* bpo-38377: On Linux, skip tests using multiprocessing if the current
  user cannot create a file in "/dev/shm/" directory. Add the
  "skip_if_broken_multiprocessing_synchronize()" function to the
  "test.support" module.

* bpo-41009: Fix use of
  "support.require_{linux|mac|freebsd}_version()" decorators as class
  decorator.

* bpo-41003: Fix "test_copyreg" when "numpy" is installed:
  "test.pickletester" now saves/restores warnings filters when
  importing "numpy", to ignore filters installed by "numpy".

* bpo-40964: Disable remote "imaplib" tests, host cyrus.andrew.cmu.edu
  is blocking incoming connections.

* bpo-40055: distutils.tests now saves/restores warnings filters to
  leave them unchanged. Importing tests imports docutils which imports
  pkg_resources which adds a warnings filter.

* bpo-34401: Make test_gdb properly run on HP-UX. Patch by Michael
  Osipov.


构建
----

* bpo-40204: Pin Sphinx version to 2.3.1 in "Doc/Makefile".

* bpo-40653: Move _dirnameW out of HAVE_SYMLINK to fix a potential
  compiling issue.


Windows
-------

* bpo-41074: Fixed support of non-ASCII names in functions
  "msilib.OpenDatabase()" and "msilib.init_database()" and non-ASCII
  SQL in method "msilib.Database.OpenView()".

* bpo-40164: Updates Windows OpenSSL to 1.1.1g

* bpo-39631: Changes the registered MIME type for ".py" files on
  Windows to "text/x-python" instead of "text/plain".

* bpo-40677: Manually define IO_REPARSE_TAG_APPEXECLINK in case some
  old Windows SDK doesn't have it.

* bpo-40650: Include winsock2.h in pytime.c for timeval.

* bpo-39148: Add IPv6 support to "asyncio" datagram endpoints in
  ProactorEventLoop. Change the raised exception for unknown address
  families to ValueError as it's not coming from Windows API.


macOS
-----

* bpo-39580: Avoid opening Finder window if running installer from the
  command line. Patch contributed by Rick Heil.

* bpo-41100: Fix configure error when building on macOS 11. Note that
  the current Python release was released shortly after the first
  developer preview of macOS 11 (Big Sur); there are other known
  issues with building and running on the developer preview. Big Sur
  is expected to be fully supported in a future bugfix release of
  Python 3.8.x and with 3.9.0.

* bpo-41005: fixed an XDG settings issue not allowing macos to open
  browser in webbrowser.py

* bpo-40741: Update macOS installer to use SQLite 3.32.2.


IDLE
----

* bpo-41144: Make Open Module open a special module such as os.path.

* bpo-39885: Make context menu Cut and Copy work again when right-
  clicking within a selection.

* bpo-40723: Make test_idle pass when run after import.


工具/示例
---------

* bpo-40479: Update multissltest helper to test with latest OpenSSL
  1.0.2, 1.1.0, 1.1.1, and 3.0.0-alpha.

* bpo-40163: Fix multissltest tool. OpenSSL has changed download URL
  for old releases. The multissltest tool now tries to download from
  current and old download URLs.


Python 3.8.3 final
==================

*Release date: 2020-05-13*


核心与内置
----------

* bpo-40527: Fix command line argument parsing: no longer write errors
  multiple times into stderr.

* bpo-40417: Fix imp module deprecation warning when
  PyImport_ReloadModule is called. Patch by Robert Rouhani.

* bpo-39562: The constant values of future flags in the "__future__"
  module are updated in order to prevent collision with compiler
  flags. Previously "PyCF_ALLOW_TOP_LEVEL_AWAIT" was clashing with
  "CO_FUTURE_DIVISION".


库
--

* bpo-40559: Fix possible memory leak in the C implementation of
  "asyncio.Task".

* bpo-40355: Improve error reporting in "ast.literal_eval()" in the
  presence of malformed "ast.Dict" nodes instead of silently ignoring
  any non-conforming elements. Patch by Curtis Bucher.

* bpo-40459: "platform.win32_ver()" now produces correct *ptype*
  strings instead of empty strings.

* bpo-40398: "typing.get_args()" now always returns an empty tuple for
  special generic aliases.


文档
----

* bpo-40561: Provide docstrings for webbrowser open functions.

* bpo-39435: Fix an incorrect signature for "pickle.loads()" in the
  docs


Windows
-------

* bpo-40458: Increase reserved stack space to prevent overflow crash
  on Windows.


C API
-----

* bpo-40412: Nullify inittab_copy during finalization, preventing
  future interpreter initializations in an embedded situation from
  crashing. Patch by Gregory Szorc.


Python 3.8.3 release candidate 1
================================

*发布日期: 2020-04-29*


安全
----

* bpo-40121: Fixes audit events raised on creating a new socket.

* bpo-38576: Disallow control characters in hostnames in http.client,
  addressing CVE-2019-18348. Such potentially malicious header
  injection URLs now cause a InvalidURL to be raised.

* bpo-39503: CVE-2020-8492: The "AbstractBasicAuthHandler" class of
  the "urllib.request" module uses an inefficient regular expression
  which can be exploited by an attacker to cause a denial of service.
  Fix the regex to prevent the catastrophic backtracking.
  Vulnerability reported by Ben Caller and Matt Schwager.


核心与内置
----------

* bpo-20526: Fix "PyThreadState_Clear()". "PyThreadState.frame" is a
  borrowed reference, not a strong reference: "PyThreadState_Clear()"
  must not call "Py_CLEAR(tstate->frame)".

* bpo-39965: Correctly raise "SyntaxError" if *await* is used inside
  non-async functions and "PyCF_ALLOW_TOP_LEVEL_AWAIT" is set (like in
  the asyncio REPL). Patch by Pablo Galindo.

* bpo-39562: Allow executing asynchronous comprehensions on the top
  level when the "PyCF_ALLOW_TOP_LEVEL_AWAIT" flag is given. Patch by
  Batuhan Taskaya.

* bpo-38894: Fix a bug that was causing incomplete results when
  calling "pathlib.Path.glob" in the presence of symlinks that point
  to files where the user does not have read access. Patch by Pablo
  Galindo and Matt Wozniski.

* bpo-39871: Fix a possible "SystemError" in
  "math.{atan2,copysign,remainder}()" when the first argument cannot
  be converted to a "float". Patch by Zackery Spytz.

* bpo-39776: Fix race condition where threads created by
  PyGILState_Ensure() could get a duplicate id.

  This affects consumers of tstate->id like the contextvar caching
  machinery, which could return invalid cached objects under heavy
  thread load (observed in embedded scenarios).

* bpo-39778: Fixed a crash due to incorrect handling of weak
  references in "collections.OrderedDict" classes. Patch by Pablo
  Galindo.

* bpo-39520: Fix unparsing of ext slices with no items ("foo[:,]").
  Patch by Batuhan Taskaya.

* bpo-22490: Don't leak environment variable "__PYVENV_LAUNCHER__"
  into the interpreter session on macOS.


库
--

* bpo-40138: Fix the Windows implementation of "os.waitpid()" for exit
  code larger than "INT_MAX >> 8". The exit status is now interpreted
  as an unsigned number.

* bpo-39942: Set "__main__" as the default module name when "__name__"
  is missing in "typing.TypeVar". Patch by Weipeng Hong.

* bpo-40330: In "ShareableList.__setitem__()", check the size of a new
  string item after encoding it to utf-8, not before.

* bpo-40287: Fixed "SpooledTemporaryFile.seek()" to return the
  position.

* bpo-40260: Ensure "modulefinder" uses "io.open_code()" and respects
  coding comments.

* bpo-40196: Fix a bug in the "symtable" module that was causing
  incorrectly report global variables as local. Patch by Pablo
  Galindo.

* bpo-40126: Fixed reverting multiple patches in unittest.mock.
  Patcher's "__exit__()" is now never called if its "__enter__()" is
  failed. Returning true from "__exit__()" silences now the exception.

* bpo-40089: Fix threading._after_fork(): if fork was not called by a
  thread spawned by threading.Thread, threading._after_fork() now
  creates a _MainThread instance for _main_thread, instead of a
  _DummyThread instance.

* bpo-39503: "AbstractBasicAuthHandler" of "urllib.request" now parses
  all WWW-Authenticate HTTP headers and accepts multiple challenges
  per header: use the realm of the first Basic challenge.

* bpo-40014: Fix "os.getgrouplist()": if "getgrouplist()" function
  fails because the group list is too small, retry with a larger group
  list. On failure, the glibc implementation of "getgrouplist()" sets
  "ngroups" to the total number of groups. For other implementations,
  double the group list size.

* bpo-40016: In re docstring, clarify the relationship between inline
  and argument compile flags.

* bpo-39953: Update internal table of OpenSSL error codes in the "ssl"
  module.

* bpo-39360: Ensure all workers exit when finalizing a
  "multiprocessing.Pool" implicitly via the module finalization
  handlers of multiprocessing. This fixes a deadlock situation that
  can be experienced when the Pool is not properly finalized via the
  context manager or a call to "multiprocessing.Pool.terminate". Patch
  by Batuhan Taskaya and Pablo Galindo.

* bpo-39652: The column name found in "sqlite3.Cursor.description" is
  now truncated on the first '[' only if the PARSE_COLNAMES option is
  set.

* bpo-39915: Ensure "unittest.mock.AsyncMock.await_args_list" has call
  objects in the order of awaited arguments instead of using
  "unittest.mock.Mock.call_args" which has the last value of the call.
  Patch by Karthikeyan Singaravelan.

* bpo-38662: The "ensurepip" module now invokes "pip" via the "runpy"
  module. Hence it is no longer tightly coupled with the internal API
  of the bundled "pip" version, allowing easier updates to a newer
  "pip" version both internally and for distributors.

* bpo-39916: More reliable use of "os.scandir()" in "Path.glob()". It
  no longer emits a ResourceWarning when interrupted.

* bpo-39850: "multiprocessing" now supports abstract socket addresses
  (if abstract sockets are supported in the running platform). Patch
  by Pablo Galindo.

* bpo-39828: Fix "json.tool" to catch "BrokenPipeError". Patch by
  Dong-hee Na.

* bpo-13487: Avoid a possible *"RuntimeError: dictionary changed size
  during iteration"* from "inspect.getmodule()" when it tried to loop
  through "sys.modules".

* bpo-39794: Add --without-decimal-contextvar build option.  This
  enables a thread-local rather than a coroutine local context.

* bpo-39769: The "compileall.compile_dir()" function's *ddir*
  parameter and the compileall command line flag "-d" no longer write
  the wrong pathname to the generated pyc file for submodules beneath
  the root of the directory tree being compiled.  This fixes a
  regression introduced with Python 3.5.

* bpo-39517: Fix runpy.run_path() when using pathlike objects

* bpo-39764: Fix AttributeError when calling get_stack on a
  PyAsyncGenObject Task

* bpo-30566: Fix "IndexError" when trying to decode an invalid string
  with punycode codec.

* bpo-39667: Correct performance degradation in "zipfile.Path" as
  found in zipp 3.0. While retaining compatibility, this change
  discourages the use of "zipfile.Path.open" due to the signature
  change in Python 3.9. For compatibility across Python 3.8 and later
  versions, consider using "zipp.Path" on Python 3.8.x and earlier.

* bpo-39548: Fix handling of header in
  "urllib.request.AbstractDigestAuthHandler" when the optional "qop"
  parameter is not present.

* bpo-38971: Open issue in the BPO indicated a desire to make the
  implementation of codecs.open() at parity with io.open(), which
  implements a try/except to assure file stream gets closed before an
  exception is raised.

* bpo-38410: Properly handle "sys.audit()" failures in
  "sys.set_asyncgen_hooks()". Based on patch by Zackery Spytz.

* bpo-36541: lib2to3 now recognizes named assignment expressions (the
  walrus operator, ":=")

* bpo-31758: Prevent crashes when using an uninitialized
  "_elementtree.XMLParser" object. Patch by Oren Milman.


文档
----

* bpo-27635: The pickle documentation incorrectly claimed that
  "__new__" isn't called by default when unpickling.

* bpo-39879: Updated 数据模型 docs to include "dict()" insertion order
  preservation. Patch by Furkan Onder and Samy Lahfa.

* bpo-39868: Updated the Language Reference for **PEP 572**.

* bpo-13790: Change 'string' to 'specification' in format doc.

* bpo-17422: The language reference no longer restricts default class
  namespaces to dicts only.

* bpo-39530: Fix misleading documentation about mixed-type numeric
  comparisons.

* bpo-39718: Update "token" documentation to reflect additions in
  Python 3.8

* bpo-39677: Changed operand name of **MAKE_FUNCTION** from *argc* to
  *flags* for module "dis"

* bpo-38387: Document "PyDoc_STRVAR" macro in the C-API reference.


测试
----

* bpo-40436: test_gdb and test.pythoninfo now check gdb command exit
  code.

* bpo-40162: Update Travis CI configuration to OpenSSL 1.1.1f.

* bpo-40146: Update OpenSSL to 1.1.1f in Azure Pipelines.

* bpo-40019: test_gdb now skips tests if it detects that gdb failed to
  read debug information because the Python binary is optimized.

* bpo-27807: "test_site.test_startup_imports()" is now skipped if a
  path of "sys.path" contains a ".pth" file.

* bpo-39793: Use the same domain when testing "make_msgid". Patch by
  Batuhan Taskaya.

* bpo-1812: Fix newline handling in doctest.testfile when loading from
  a package whose loader has a get_data method. Patch by Peter Donis.

* bpo-37957: test.regrtest now can receive a list of test patterns to
  ignore (using the -i/--ignore argument) or a file with a list of
  patterns to ignore (using the --ignore-file argument). Patch by
  Pablo Galindo.

* bpo-38502: test.regrtest now uses process groups in the
  multiprocessing mode (-jN command line option) if process groups are
  available: if "os.setsid()" and "os.killpg()" functions are
  available.


构建
----

* bpo-38360: Support single-argument form of macOS -isysroot flag.

* bpo-40204: Pin Sphinx version to 1.8.2 in "Doc/Makefile".

* bpo-40158: Fix CPython MSBuild Properties in NuGet Package
  (build/native/python.props)

* bpo-38527: Fix configure check on Solaris for "float word ordering":
  sometimes, the correct "grep" command was not being used. Patch by
  Arnon Yaari.


Windows
-------

* bpo-40164: Updates Windows to OpenSSL 1.1.1f

* bpo-39930: Ensures the required "vcruntime140.dll" is included in
  install packages.

* bpo-39847: Avoid hang when computer is hibernated whilst waiting for
  a mutex (for lock-related objects from "threading") around 49-day
  uptime.

* bpo-38597: "distutils" will no longer statically link
  "vcruntime140.dll" when a redistributable version is unavailable.
  All future releases of CPython will include a copy of this DLL to
  ensure distributed extensions can continue to load.

* bpo-38380: Update Windows builds to use SQLite 3.31.1

* bpo-39789: Update Windows release build machines to Visual Studio
  2019 (MSVC 14.2).

* bpo-34803: Package for nuget.org now includes repository reference
  and bundled icon image.


macOS
-----

* bpo-40164: Update macOS installer builds to use OpenSSL 1.1.1g.

* bpo-38380: Update macOS builds to use SQLite 3.31.1


IDLE
----

* bpo-27115: For 'Go to Line', use a Query box subclass with IDLE
  standard behavior and improved error checking.

* bpo-39885: Since clicking to get an IDLE context menu moves the
  cursor, any text selection should be and now is cleared.

* bpo-39852: Edit "Go to line" now clears any selection, preventing
  accidental deletion. It also updates Ln and Col on the status bar.

* bpo-39781: Selecting code context lines no longer causes a jump.

* bpo-38439: Add a 256×256 pixel IDLE icon to support more modern
  environments. Created by Andrew Clover. Delete the unused macOS
  idle.icns icon file.

* bpo-38689: IDLE will no longer freeze when inspect.signature fails
  when fetching a calltip.


工具/示例
---------

* bpo-40179: Fixed translation of "#elif" in Argument Clinic.

* bpo-36184: Port python-gdb.py to FreeBSD. python-gdb.py now checks
  for "take_gil" function name to check if a frame tries to acquire
  the GIL, instead of checking for "pthread_cond_timedwait" which is
  specific to Linux and can be a different condition than the GIL.

* bpo-39889: Fixed "unparse.py" for extended slices containing a
  single element (e.g. "a[i:j,]"). Remove redundant tuples when index
  with a tuple (e.g. "a[i, j]").


C API
-----

* bpo-35370: If "PySys_Audit()" fails in "PyEval_SetProfile()" or
  "PyEval_SetTrace()", log the error as an unraisable exception.

* bpo-39884: "PyDescr_NewMethod()" and "PyCFunction_NewEx()" now
  include the method name in the SystemError "bad call flags" error
  message to ease debug.

* bpo-38643: "PyNumber_ToBase()" now raises a "SystemError" instead of
  crashing when called with invalid base.

* bpo-38913: Fixed segfault in "Py_BuildValue()" called with a format
  containing "#" and undefined PY_SSIZE_T_CLEAN whwn an exception is
  set.


Python 3.8.2 正式版
===================

*发布日期: 2020-02-24*


核心与内置
----------

* bpo-39382: Fix a use-after-free in the single inheritance path of
  "issubclass()", when the "__bases__" of an object has a single
  reference, and so does its first item. Patch by Yonatan Goldschmidt.

* bpo-39427: Document all possibilities for the "-X" options in the
  command line help section. Patch by Pablo Galindo.


库
--

* bpo-39649: Remove obsolete check for "__args__" in
  bdb.Bdb.format_stack_entry.

* bpo-39681: Fix a regression where the C pickle module wouldn't allow
  unpickling from a file-like object that doesn't expose a readinto()
  method.

* bpo-39546: Fix a regression in "ArgumentParser" where
  "allow_abbrev=False" was ignored for long options that used a prefix
  character other than "-".

* bpo-39432: Implement PEP-489 algorithm for non-ascii "PyInit_..."
  symbol names in distutils to make it export the correct init symbol
  also on Windows.


文档
----

* bpo-17422: The language reference now specifies restrictions on
  class namespaces. Adapted from a patch by Ethan Furman.

* bpo-39572: Updated documentation of "total" flag of TypeDict.

* bpo-39654: In pyclbr doc, update 'class' to 'module' where
  appropriate and add readmodule comment. Patch by Hakan Çelik.


IDLE
----

* bpo-39663: Add tests for pyparse find_good_parse_start().


Python 3.8.2 rc2
================

*发布日期:: 2020-02-17*


安全
----

* bpo-39184: Add audit events to functions in "fcntl", "msvcrt", "os",
  "resource", "shutil", "signal" and "syslog".


核心与内置
----------

* bpo-39619: Enable use of "os.chroot()" on HP-UX systems.

* bpo-39606: Fix regression caused by fix for bpo-39386, that
  prevented calling "aclose" on an async generator that had already
  been closed or exhausted.

* bpo-39453: Fixed a possible crash in "list.__contains__()" when a
  list is changed during comparing items. Patch by Dong-hee Na.

* bpo-39219: Syntax errors raised in the tokenizer now always set
  correct "text" and "offset" attributes.


库
--

* bpo-27657: The original fix for bpo-27657, "Fix urlparse() with
  numeric paths" (GH-16839) included in 3.8.1, inadvertently
  introduced a behavior change that broke several third-party packages
  relying on the original undefined parsing behavior. The change is
  reverted in 3.8.2, restoring the behavior of 3.8.0 and earlier
  releases.

* bpo-39474: Fixed starting position of AST for expressions like
  "(a)(b)", "(a)[b]" and "(a).b".

* bpo-21016: The "pydoc" and "trace" modules now use the "sysconfig"
  module to get the path to the Python standard library, to support
  uncommon installation path like "/usr/lib64/python3.9/" on Fedora.
  Patch by Jan Matějek.

* bpo-39595: Improved performance of zipfile.Path for files with a
  large number of entries. Also improved performance and fixed minor
  issue as published with importlib_metadata 1.5.


IDLE
----

* bpo-39600: In the font configuration window, remove duplicated font
  names.


Python 3.8.2 rc1
================

*发布日期:: 2020-02-10*


安全
----

* bpo-39401: Avoid unsafe load of "api-ms-win-core-path-l1-1-0.dll" at
  startup on Windows 7.

* bpo-39184: Add audit events to command execution functions in os and
  pty modules.


核心与内置
----------

* bpo-39579: Change the ending column offset of "Attribute" nodes
  constructed in "ast_for_dotted_name" to point at the end of the
  current node and not at the end of the last "NAME" node.

* bpo-39510: Fix segfault in "readinto()" method on closed
  BufferedReader.

* bpo-39492: Fix a reference cycle in the C Pickler that was
  preventing the garbage collection of deleted, pickled objects.

* bpo-39421: Fix possible crashes when operating with the functions in
  the "heapq" module and custom comparison operators.

* bpo-39386: Prevent double awaiting of async iterator.

* bpo-39235: Fix AST end location for lone generator expression in
  function call, e.g. f(i for i in a).

* bpo-39209: Correctly handle multi-line tokens in interactive mode.
  Patch by Pablo Galindo.

* bpo-39216: Fix constant folding optimization for positional only
  arguments - by Anthony Sottile.

* bpo-39215: Fix "SystemError" when nested function has annotation on
  positional-only argument - by Anthony Sottile.

* bpo-38588: Fix possible crashes in dict and list when calling
  "PyObject_RichCompareBool()".

* bpo-38610: Fix possible crashes in several list methods by holding
  strong references to list elements when calling
  "PyObject_RichCompareBool()".


库
--

* bpo-39590: Collections.deque now holds strong references during
  deque.__contains__ and deque.count, fixing crashes.

* bpo-38149: "sys.audit()" is now called only once per call of
  "glob.glob()" and "glob.iglob()".

* bpo-39450: Striped whitespace from docstring before returning it
  from "unittest.case.shortDescription()".

* bpo-39493: Mark "typing.IO.closed" as a property

* bpo-39485: Fix a bug in "unittest.mock.create_autospec()" that would
  complain about the wrong number of arguments for custom descriptors
  defined in an extension module returning functions.

* bpo-39082: Allow AsyncMock to correctly patch static/class methods

* bpo-39430: Fixed race condition in lazy imports in "tarfile".

* bpo-39390: Fixed a regression with the "ignore" callback of
  "shutil.copytree()". The argument types are now str and List[str]
  again.

* bpo-39389: Write accurate compression level metadata in "gzip"
  archives, rather than always signaling maximum compression.

* bpo-39274: "bool(fraction.Fraction)" now returns a boolean even if
  (numerator != 0) does not return a boolean (ex: numpy number).

* bpo-39297: Improved performance of importlib.metadata distribution
  discovery and resilients to inaccessible sys.path entries
  (importlib_metadata v1.4.0).

* bpo-39242: Updated the Gmane domain from news.gmane.org to
  news.gmane.io which is used for examples of "NNTP" news reader
  server and nntplib tests.

* bpo-38907: In http.server script, restore binding to IPv4 on
  Windows.

* bpo-39152: Fix ttk.Scale.configure([name]) to return configuration
  tuple for name or all options.  Giovanni Lombardo contributed part
  of the patch.

* bpo-39198: If an exception were to be thrown in
  "Logger.isEnabledFor" (say, by asyncio timeouts or stopit) , the
  "logging" global lock may not be released appropriately, resulting
  in deadlock.  This change wraps that block of code with
  "try...finally" to ensure the lock is released.

* bpo-39191: Perform a check for running loop before starting a new
  task in "loop.run_until_complete()" to fail fast; it prevents the
  side effect of new task spawning before exception raising.

* bpo-38871: Correctly parenthesize filter-based statements that
  contain lambda expressions in mod:"lib2to3". Patch by Dong-hee Na.

* bpo-39142: A change was made to logging.config.dictConfig to avoid
  converting instances of named tuples to ConvertingTuple. It's
  assumed that named tuples are too specialised to be treated like
  ordinary tuples; if a user of named tuples requires ConvertingTuple
  functionality, they will have to implement that themselves in their
  named tuple class.

* bpo-39129: Fix import path for "asyncio.TimeoutError"

* bpo-39057: "urllib.request.proxy_bypass_environment()" now ignores
  leading dots and no longer ignores a trailing newline.

* bpo-39056: Fixed handling invalid warning category in the -W option.
  No longer import the re module if it is not needed.

* bpo-39055: "base64.b64decode()" with "validate=True" raises now a
  binascii.Error if the input ends with a single "\n".

* bpo-39033: Fix "NameError" in "zipimport". Patch by Karthikeyan
  Singaravelan.

* bpo-38878: Fixed __subclasshook__ of "os.PathLike" to return a
  correct result upon inheritence. Patch by Bar Harel.

* bpo-35182: Fixed "Popen.communicate()" subsequent call crash when
  the child process has already closed any piped standard stream, but
  still continues to be running. Patch by Andriy Maletsky.

* bpo-38473: Use signature from inner mock for autospecced methods
  attached with "unittest.mock.attach_mock()". Patch by Karthikeyan
  Singaravelan.

* bpo-38293: Add "copy.copy()" and "copy.deepcopy()" support to
  "property()" objects.


文档
----

* bpo-39153: Clarify refcounting semantics for the following
  functions: - PyObject_SetItem - PyMapping_SetItemString -
  PyDict_SetItem - PyDict_SetItemString

* bpo-39392: Explain that when filling with turtle, overlap regions
  may be left unfilled.

* bpo-39381: Mention in docs that "asyncio.get_event_loop()"
  implicitly creates new event loop only if called from the main
  thread.

* bpo-38918: Add an entry for "__module__" in the "function" &
  "method" sections of the inspect docs types and members table

* bpo-3530: In the "ast" module documentation, fix a misleading
  "NodeTransformer" example and add advice on when to use the
  "fix_missing_locations" function.


测试
----

* bpo-39502: Skip test_zipfile.test_add_file_after_2107() if
  "time.localtime()" fails with "OverflowError". It is the case on AIX
  6.1 for example.

* bpo-38546: Fix test_ressources_gced_in_workers() of
  test_concurrent_futures: explicitly stop the manager to prevent
  leaking a child process running in the background after the test
  completes.


构建
----

* bpo-39144: The ctags and etags build targets both include
  Modules/_ctypes and Python standard library source files.


Windows
-------

* bpo-39439: Honor the Python path when a virtualenv is active on
  Windows.

* bpo-39393: Improve the error message when attempting to load a DLL
  with unresolved dependencies.

* bpo-38883: "home()" and "expanduser()" on Windows now prefer
  "USERPROFILE" and no longer use "HOME", which is not normally set
  for regular user accounts. This makes them again behave like
  "os.path.expanduser()", which was changed to ignore "HOME" in 3.8,
  see bpo-36264.

* bpo-39185: The build.bat script has additional options for very-
  quiet output (-q) and very-verbose output (-vv)


IDLE
----

* bpo-30780: Add remaining configdialog tests for buttons and
  highlights and keys tabs.

* bpo-39388: IDLE Settings Cancel button now cancels pending changes

* bpo-39050: Make IDLE Settings dialog Help button work again.

* bpo-34118: Tag memoryview, range, and tuple as classes, the same as
  list, etcetera, in the library manual built-in functions list.

* bpo-38792: Close an IDLE shell calltip if a "KeyboardInterrupt" or
  shell restart occurs.  Patch by Zackery Spytz.

* bpo-32989: Add tests for editor newline_and_indent_event method.
  Remove dead code from pyparse find_good_parse_start method.


Python 3.8.1 正式版
===================

*发布日期: 2019-12-18*


核心与内置
----------

* bpo-39080: Fix the value of *end_col_offset* for Starred Expression
  AST nodes when they are among the elements in the *args* attribute
  of Call AST nodes.

* bpo-39031: When parsing an "elif" node, lineno and col_offset of the
  node now point to the "elif" keyword and not to its condition,
  making it consistent with the "if" node. Patch by Lysandros
  Nikolaou.

* bpo-39008: "PySys_Audit()" now requires "Py_ssize_t" to be used for
  size arguments in the format string, regardless of whether
  "PY_SSIZE_T_CLEAN" was defined at include time.


库
--

* bpo-39022: Update importlib.metadata to include improvements from
  importlib_metadata 1.3 including better serialization of EntryPoints
  and improved documentation for custom finders.

* bpo-38811: Fix an unhandled exception in "pathlib" when "os.link()"
  is missing. Patch by Toke Høiland-Jørgensen.

* bpo-36406: Handle namespace packages in "doctest". Patch by
  Karthikeyan Singaravelan.


测试
----

* bpo-38546: Multiprocessing and concurrent.futures tests now stop the
  resource tracker process when tests complete.


Windows
-------

* bpo-39007: Add auditing events to functions in "winreg".


macOS
-----

* bpo-38295: Prevent failure of test_relative_path in test_py_compile
  on macOS Catalina.


IDLE
----

* bpo-38944: Escape key now closes IDLE completion windows.  Patch by
  Johnny Najera.

* bpo-38943: Fix IDLE autocomplete windows not always appearing on
  some systems. Patch by Johnny Najera.


Python 3.8.1 rc1
================

*发布日期: 2019-12-09*


安全
----

* bpo-38945: Newline characters have been escaped when performing uu
  encoding to prevent them from overflowing into to content section of
  the encoded file. This prevents malicious or accidental modification
  of data during the decoding process.

* bpo-37228: Due to significant security concerns, the *reuse_address*
  parameter of "asyncio.loop.create_datagram_endpoint()" is no longer
  supported. This is because of the behavior of "SO_REUSEADDR" in UDP.
  For more details, see the documentation for
  "loop.create_datagram_endpoint()". (Contributed by Kyle Stanley,
  Antoine Pitrou, and Yury Selivanov in bpo-37228.)

* bpo-38722: "runpy" now uses "io.open_code()" to open code files.
  Patch by Jason Killen.

* bpo-38804: Fixes a ReDoS vulnerability in "http.cookiejar". Patch by
  Ben Caller.

* bpo-38622: Add additional audit events for the "ctypes" module.

* bpo-38418: 修复 "os.system()" 的审计事件被命名为 "os.system" 。


核心与内置
----------

* bpo-38673: In REPL mode, don't switch to PS2 if the line starts with
  comment or whitespace. Based on work by Batuhan Taşkaya.

* bpo-38922: Calling "replace" on a code object now raises the
  "code.__new__" audit event.

* bpo-38920: Add audit hooks for when "sys.excepthook()" and
  "sys.unraisablehook()" are invoked

* bpo-38892: Improve documentation for audit events table and
  functions.

* bpo-38707: "MainThread.native_id" is now correctly reset in child
  processes spawned using "multiprocessing.Process", instead of
  retaining the parent's value.

* bpo-38640: Fixed a bug in the compiler that was causing to raise in
  the presence of break statements and continue statements inside
  always false while loops. Patch by Pablo Galindo.

* bpo-38535: 修复了装饰器中不带参数调用的AST节点的行号和列偏移量。

* bpo-38525: 修复了使用空 "dict" 对象的反向迭代器时的分段错误。由
  Dong-hee Na 和 Inada Naoki 补丁修复

* bpo-35409: Ignore GeneratorExit exceptions when throwing an
  exception into the aclose coroutine of an asynchronous generator.


库
--

* bpo-39006: Fix asyncio when the ssl module is missing: only check
  for ssl.SSLSocket instance if the ssl module is available.

* bpo-38708: Fix a potential IndexError in email parser when parsing
  an empty msg-id.

* bpo-38698: Add a new "InvalidMessageID" token to email parser to
  represent invalid Message-ID headers.  Also, add defects when there
  is remaining value after parsing the header.

* bpo-38979: Return class from "ContextVar.__class_getitem__" to
  simplify subclassing.

* bpo-38986: Make repr of C accelerated TaskWakeupMethWrapper the same
  as of pure Python version.

* bpo-38529: Drop too noisy asyncio warning about deletion of a stream
  without explicit ".close()" call.

* bpo-38634: The "readline" module now detects if Python is linked to
  libedit at runtime on all platforms.  Previously, the check was only
  done on macOS.

* bpo-33684: Fix "json.tool" failed to read a JSON file with non-ASCII
  characters when locale encoding is not UTF-8.

* bpo-38698: Prevent UnboundLocalError to pop up in parse_message_id

  parse_message_id() was improperly using a token defined inside an
  exception handler, which was raising "UnboundLocalError" on parsing
  an invalid value. Patch by Claudiu Popa.

* bpo-26730: Fix "SpooledTemporaryFile.rollover()" might corrupt the
  file when it is in text mode. Patch by Serhiy Storchaka.

* bpo-38668: Calling func:"shutil.copytree" to copy a directory tree
  from one directory to another subdirectory resulted in an endless
  loop and a RecursionError. A fix was added to consume an iterator
  and create the list of the entries to be copied, avoiding the
  recursion for newly created directories. Patch by Bruno P.
  Kinoshita.

* bpo-37838: "typing.get_type_hints()" properly handles functions
  decorated with "functools.wraps()".

* bpo-38859: AsyncMock now returns StopAsyncIteration on the exaustion
  of a side_effects iterable. Since PEP-479 its Impossible to raise a
  StopIteration exception from a coroutine.

* bpo-38857: AsyncMock fix for return values that are awaitable types.
  This also covers side_effect iterable values that happend to be
  awaitable, and wraps callables that return an awaitable type. Before
  these awaitables were being awaited instead of being returned as is.

* bpo-38821: Fix unhandled exceptions in "argparse" when
  internationalizing error messages for arguments with "nargs" set to
  special (non-integer) values. Patch by Federico Bond.

* bpo-38820: Make Python compatible with OpenSSL 3.0.0.
  "ssl.SSLSocket.getpeercert()" no longer returns IPv6 addresses with
  a trailing new line.

* bpo-38807: Update "TypeError" messages for "os.path.join()" to
  include "os.PathLike" objects as acceptable input types.

* bpo-38785: Prevent asyncio from crashing if parent "__init__" is not
  called from a constructor of object derived from "asyncio.Future".

* bpo-38723: "pdb" now uses "io.open_code()" to trigger auditing
  events.

* bpo-27805: Allow opening pipes and other non-seekable files in
  append mode with "open()".

* bpo-38686: Added support for multiple "qop" values in
  "urllib.request.AbstractDigestAuthHandler".

* bpo-38334: 修复了在加密的 "zipfile.ZipExtFile" 上向后搜索的问题。

* bpo-34679: asynci.ProactorEventLoop.close() 现在仅调用主线程中的
  signal.set_wakeup_fd()

* bpo-31202: "pathlib.WindowsPath.glob()" 的结果现在与文本部分的式样匹
  配。

* bpo-38521: Fixed erroneous equality comparison in
  statistics.NormalDist().

* bpo-38478: Fixed a bug in "inspect.signature.bind()" that was
  causing it to fail when handling a keyword argument with same name
  as positional-only parameter. Patch by Pablo Galindo.

* bpo-33604: Fixed "hmac.new" and "hmac.HMAC" to raise TypeError
  instead of ValueError when the digestmod parameter, now required in
  3.8, is omitted. Also clarified the hmac module documentation and
  docstrings.

* bpo-38422: Clarify docstrings of pathlib suffix(es)

* bpo-36993: Improve error reporting for corrupt zip files with bad
  zip64 extra data. Patch by Daniel Hillier.

* bpo-36820: Break cycle generated when saving an exception in
  socket.py, codeop.py and dyld.py as they keep alive not only the
  exception but user objects through the "__traceback__" attribute.
  Patch by Mario Corchero.

* bpo-34776: Fix dataclasses to support forward references in type
  annotations

* bpo-33348: lib2to3 now recognizes expressions after "*" and "**"
  like in "f(*[] or [])".

* bpo-27657: Fix urllib.parse.urlparse() with numeric paths. A string
  like "path:80" is no longer parsed as a path but as a scheme
  ("path") and a path ("80").


文档
----

* bpo-38816: Provides more details about the interaction between
  "fork()" and CPython's runtime, focusing just on the C-API.  This
  includes cautions about where "fork()" should and shouldn't be
  called.

* bpo-38351: Modernize "email" examples from %-formatting to
  f-strings.

* bpo-38778: Document the fact that "RuntimeError" is raised if
  "os.fork()" is called in a subinterpreter.

* bpo-38592: Add Brazilian Portuguese to the language switcher at
  Python Documentation website.


测试
----

* bpo-38547: Fix test_pty: if the process is the session leader,
  closing the master file descriptor raises a SIGHUP signal: simply
  ignore SIGHUP when running the tests.

* bpo-38992: Fix a test for "math.fsum()" that was failing due to
  constant folding.

* bpo-38965: Fix test_faulthandler on GCC 10. Use the "volatile"
  keyword in "faulthandler._stack_overflow()" to prevent tail call
  optimization on any compiler, rather than relying on compiler
  specific pragma.

* bpo-38875: test_capi: trashcan tests now require the test "cpu"
  resource.

* bpo-38841: Skip asyncio
  test_create_datagram_endpoint_existing_sock_unix on platforms
  lacking a functional bind() for named unix domain sockets.

* bpo-38669: Raise "TypeError" when passing target as a string with
  "unittest.mock.patch.object()".

* bpo-35998: Fix a race condition in
  test_asyncio.test_start_tls_server_1(). Previously, there was a race
  condition between the test main() function which replaces the
  protocol and the test ServerProto protocol which sends ANSWER once
  it gets HELLO. Now, only the test main() function is responsible to
  send data, ServerProto no longer sends data.


构建
----

* bpo-37404: "asyncio" now raises "TyperError" when calling
  incompatible methods with an "ssl.SSLSocket" socket.  Patch by Ido
  Michael.

* bpo-38809: On Windows, build scripts will now recognize and use
  python.exe from an active virtual env.

* bpo-38684: Fix _hashlib build when Blake2 is disabled, but OpenSSL
  supports it.

* bpo-37415: Fix stdatomic.h header check for ICC compiler: the ICC
  implementation lacks atomic_uintptr_t type which is needed by
  Python.


Windows
-------

* bpo-33125: Add support for building and releasing Windows ARM64
  packages.

* bpo-38589: Fixes HTML Help shortcut when Windows is not installed to
  C drive

* bpo-38453: Ensure ntpath.realpath() correctly resolves relative
  paths.

* bpo-38519: Restores the internal C headers that were missing from
  the nuget.org and Microsoft Store packages.

* bpo-38492: 删除 pythonw.exe 依赖的 Microsoft C++ 执行库。


macOS
-----

* bpo-37931: Fixed a crash on OSX dynamic builds that occurred when
  re-initializing the posix module after a Py_Finalize if the
  environment had changed since the previous "import posix". Patch by
  Benoît Hudson.


IDLE
----

* bpo-38862: 'Strip Trailing Whitespace' on the Format menu removes
  extra newlines at the end of non-shell files.

* bpo-26353: Stop adding newline when saving an IDLE shell window.

* bpo-38636: Fix IDLE Format menu tab toggle and file indent width.
  These functions (default shortcuts Alt-T and Alt-U) were mistakenly
  disabled in 3.7.5 and 3.8.0.

* bpo-4630: Add an option to toggle IDLE's cursor blink for shell,
  editor, and output windows.  See Settings, General, Window
  Preferences, Cursor Blink. Patch by Zackery Spytz.

* bpo-38598: Do not try to compile IDLE shell or output windows


C API
-----

* bpo-37633: Re-export some function compatibility wrappers for macros
  in "pythonrun.h".

* bpo-38540: Fixed possible leak in "PyArg_Parse()" and similar
  functions for format units ""es#"" and ""et#"" when the macro
  "PY_SSIZE_T_CLEAN" is not defined.

* bpo-36389: The "_PyObject_CheckConsistency()" function is now also
  available in release mode. For example, it can be used to debug a
  crash in the "visit_decref()" function of the GC.


Python 3.8.0 正式版
===================

*发布日期: 2019-10-14*


核心与内置
----------

* bpo-38469: Fixed a bug where the scope of named expressions was not
  being resolved correctly in the presence of the *global* keyword.
  Patch by Pablo Galindo.

* bpo-38379: When cyclic garbage collection (gc) runs finalizers that
  resurrect unreachable objects, the current gc run ends, without
  collecting any cyclic trash.  However, the statistics reported by
  "collect()" and "get_stats()" claimed that all cyclic trash found
  was collected, and that the resurrected objects were collected.
  Changed the stats to report that none were collected.


库
--

* bpo-38449: Revert GH-15522, which introduces a regression in
  "mimetypes.guess_type()" due to improper handling of filenames as
  urls.

* bpo-38431: Fix "__repr__" method for "dataclasses.InitVar" to
  support typing objects, patch by Samuel Colvin.

* bpo-38109: Add missing "stat.S_IFDOOR", "stat.S_IFPORT",
  "stat.S_IFWHT", "stat.S_ISDOOR()", "stat.S_ISPORT()", and
  "stat.S_ISWHT()" values to the Python implementation of "stat".

* bpo-38405: Nested subclasses of "typing.NamedTuple" are now
  pickleable.

* bpo-38332: Prevent "KeyError" thrown by "_encoded_words.decode()"
  when given an encoded-word with invalid content-type encoding from
  propagating all the way to "email.message.get()".

* bpo-38341: Add "smtplib.SMTPNotSupportedError" to the "smtplib"
  exported names.

* bpo-13153: OS native encoding is now used for converting between
  Python strings and Tcl objects.  This allows to display, copy and
  paste to clipboard emoji and other non-BMP characters.  Converting
  strings from Tcl to Python and back now never fails (except
  MemoryError).


文档
----

* bpo-38294: Add list of no-longer-escaped chars to re.escape
  documentation.


测试
----

* bpo-37531: On timeout, regrtest no longer attempts to call
  "popen.communicate()" again: it can hang until all child processes
  using stdout and stderr pipes completes. Kill the worker process and
  ignores its output. Change also the faulthandler timeout of the main
  process from 1 minute to 5 minutes, for Python slowest buildbots.


Windows
-------

* bpo-38344: Fix error message in activate.bat.

* bpo-38359: Ensures "pyw.exe" launcher reads correct registry key.

* bpo-38355: Fixes "ntpath.realpath" failing on "sys.executable".


IDLE
----

* bpo-36698: IDLE no longer fails when write non-encodable characters
  to stderr.  It now escapes them with a backslash, as the regular
  Python interpreter. Added the "errors" field to the standard
  streams.


工具/示例
---------

* bpo-38118: Update Valgrind suppression file to ignore a false alarm
  in "PyUnicode_Decode()" when using GCC builtin strcmp().

* bpo-38347: pathfix.py: Assume all files that end on '.py' are Python
  scripts when working recursively.


C API
-----

* bpo-38395: Fix a crash in "weakref.proxy" objects due to incorrect
  lifetime management when calling some associated methods that may
  delete the last reference to object being referenced by the proxy.
  Patch by Pablo Galindo.


Python 3.8.0 rc1
================

*发布日期: 2019-10-01*


安全
----

* bpo-38243: 在将文档页渲染为 HTML 时会对
  "xmlrpc.server.DocXMLRPCServer" 的服务器标题进行转义。 （由 Dong-hee
  Na 在 bpo-38243 中贡献。）

* bpo-38174: 将厂商化的 expat 库版本更新至 2.2.8，这解决了
  CVE-2019-15903。

* bpo-37764: 修复了 email._header_value_parser.get_unstructured 在邮件
  头不包含末尾空格，以及在其包含无效的已编码字等特定情况下进入无限循环
  的问题。 由 Ashwin Ramaswami 贡献补丁。


核心与内置
----------

* bpo-38006: Fix a bug due to the interaction of weakrefs and the
  cyclic garbage collector. We must clear any weakrefs in garbage in
  order to prevent their callbacks from executing and causing a crash.

* bpo-38317: Fix warnings options priority: "PyConfig.warnoptions" has
  the highest priority, as stated in the **PEP 587**.

* bpo-36871: 改进了 mock 的 assert_has_calls 和 assert_has_awaits 方法
  的错误处理。 修复了一个漏洞，它会在将预期的调用绑定到 mock 的规格时
  静默接收所遇到的任何错误，从而产生误导性的错误输出。

* bpo-38236: Python now dumps path configuration if it fails to import
  the Python codecs of the filesystem and stdio encodings.

* bpo-38013: Allow to call "async_generator_athrow().throw(...)" even
  for non-started async generator helper. It fixes annoying warning at
  the end of "asyncio.run()" call.

* bpo-38124: Fix an off-by-one error in PyState_AddModule that could
  cause out-of-bounds memory access.

* bpo-38005: 修复InterpreterID 和 ChannelID的创建和对比.

* bpo-37994: Fixed silencing arbitrary errors if an attribute lookup
  fails in several sites. Only AttributeError should be silenced.

* bpo-37990: Fix elapsed time in gc stats was not printed correctly.
  This bug was a regression in 3.8b4.

* bpo-37966: The implementation of "is_normalized()" has been greatly
  sped up on strings that aren't normalized, by implementing the full
  normalization-quick-check algorithm from the Unicode standard.

* bpo-20490: Improve import error message for partially initialized
  module on circular "from" imports - by Anthony Sottile.

* bpo-37409: Ensure explicit relative imports from interactive
  sessions and scripts (having no parent package) always raise
  ImportError, rather than treating the current module as the package.
  Patch by Ben Lewis.

* bpo-37619: When adding a wrapper descriptor from one class to a
  different class (for example, setting "__add__ = str.__add__" on an
  "int" subclass), an exception is correctly raised when the operator
  is called.

* bpo-30773: Prohibit parallel running of aclose() / asend() /
  athrow(). Fix ag_running to reflect the actual running status of the
  AG.


库
--

* bpo-38319: 修复 套接字 和 shutil 模块中使用的sendfile() 在 32-bit 架
  构上会产生 OverflowError for files >= 2GiB . (补丁由Giampaolo Rodola
  提供)

* bpo-38242: 回滚新的 asyncio Streams API

* bpo-38019: Correctly handle pause/resume reading of closed asyncio
  unix pipe.

* bpo-38163: Child mocks will now detect their type as either
  synchronous or asynchronous, asynchronous child mocks will be
  AsyncMocks and synchronous child mocks will be either MagicMock or
  Mock (depending on their parent type).

* bpo-38161: Removes _AwaitEvent from AsyncMock.

* bpo-38216: Allow the rare code that wants to send invalid http
  requests from the "http.client" library a way to do so.  The fixes
  for bpo-30458 led to breakage for some projects that were relying on
  this ability to test their own behavior in the face of bad requests.

* bpo-38108: Any synchronous magic methods on an AsyncMock now return
  a MagicMock. Any asynchronous magic methods on a MagicMock now
  return an AsyncMock.

* bpo-38248: asyncio: Fix inconsistent immediate Task cancellation

* bpo-38237: The arguments for the builtin pow function are more
  descriptive. They can now also be passed in as keywords.

* bpo-38191: Constructors of "NamedTuple" and "TypedDict" types now
  accept arbitrary keyword argument names, including "cls", "self",
  "typename", "_typename", "fields" and "_fields".  Passing positional
  arguments by keyword is deprecated.

* bpo-38185: Fixed case-insensitive string comparison in "sqlite3.Row"
  indexing.

* bpo-38136: Changes AsyncMock call count and await count to be two
  different counters. Now await count only counts when a coroutine has
  been awaited, not when it has been called, and vice-versa. Update
  the documentation around this.

* bpo-37828: Fix default mock name in
  "unittest.mock.Mock.assert_called()" exceptions. Patch by Abraham
  Toriz Cruz.

* bpo-38175: Fix a memory leak in comparison of "sqlite3.Row" objects.

* bpo-33936: _hashlib no longer calls obsolete OpenSSL initialization
  function with OpenSSL 1.1.0+.

* bpo-34706: Preserve subclassing in inspect.Signature.from_callable.

* bpo-38153: Names of hashing algorithms frome OpenSSL are now
  normalized to follow Python's naming conventions. For example
  OpenSSL uses sha3-512 instead of sha3_512 or blake2b512 instead of
  blake2b.

* bpo-38115: Fix a bug in dis.findlinestarts() where it would return
  invalid bytecode offsets. Document that a code object's co_lnotab
  can contain invalid bytecode offsets.

* bpo-38148: Add slots to "asyncio" transport classes, which can
  reduce memory usage.

* bpo-36991: Fixes a potential incorrect AttributeError exception
  escaping ZipFile.extract() in some unsupported input error
  situations.

* bpo-38134: Remove obsolete copy of PBKDF2_HMAC_fast. All supported
  OpenSSL versions contain a fast implementation.

* bpo-38132: The OpenSSL hashlib wrapper uses a simpler
  implementation. Several Macros and pointless caches are gone. The
  hash name now comes from OpenSSL's EVP. The algorithm name stays the
  same, except it is now always lower case.

* bpo-38008: Fix parent class check in protocols to correctly identify
  the module that provides a builtin protocol, instead of assuming
  they all come from the "collections.abc" module

* bpo-37405: Fixed regression bug for socket.getsockname() for non-
  CAN_ISOTP AF_CAN address family sockets by returning a 1-tuple
  instead of string.

* bpo-38121: Update parameter names on functions in importlib.metadata
  matching the changes in the 0.22 release of importlib_metadata.

* bpo-38110: The os.closewalk() implementation now uses the libc
  fdwalk() API on platforms where it is available.

* bpo-38093: Fixes AsyncMock so it doesn't crash when used with
  AsyncContextManagers or AsyncIterators.

* bpo-37488: Add warning to "datetime.utctimetuple()",
  "datetime.utcnow()" and "datetime.utcfromtimestamp()" .

* bpo-38086: Update importlib.metadata with changes from
  importlib_metadata 0.21.

* bpo-37251: Remove "__code__" check in AsyncMock that incorrectly
  evaluated function specs as async objects but failed to evaluate
  classes with "__await__" but no "__code__" attribute defined as
  async objects.

* bpo-38037: Fix reference counters in the "signal" module.

* bpo-38066: Hide internal asyncio.Stream methods: feed_eof(),
  feed_data(), set_exception() and set_transport().

* bpo-38059: inspect.py now uses sys.exit() instead of exit()

* bpo-37953: In "typing", improved the "__hash__" and "__eq__" methods
  for "ForwardReferences".

* bpo-38026: Fixed "inspect.getattr_static()" used "isinstance" while
  it should avoid dynamic lookup.

* bpo-38010: In "importlib.metadata" sync with "importlib_metadata"
  0.20, clarifying behavior of "files()" and fixing issue where only
  one requirement was returned for "requires()" on "dist-info"
  packages.

* bpo-38006: weakref.WeakValueDictionary defines a local remove()
  function used as callback for weak references. This function was
  created with a closure. Modify the implementation to avoid the
  closure.

* bpo-34410: Fixed a crash in the "tee()" iterator when re-enter it.
  RuntimeError is now raised in this case.

* bpo-37140: Fix a ctypes regression of Python 3.8. When a
  ctypes.Structure is passed by copy to a function, ctypes internals
  created a temporary object which had the side effect of calling the
  structure finalizer (__del__) twice. The Python semantics requires a
  finalizer to be called exactly once. Fix ctypes internals to no
  longer call the finalizer twice.

* bpo-37972: Subscripts to the "unittest.mock.call" objects now
  receive the same chaining mechanism as any other custom attributes,
  so that the following usage no longer raises a "TypeError":

  call().foo().__getitem__('bar')

  Patch by blhsing

* bpo-22347: Update mimetypes.guess_type to allow proper parsing of
  URLs with only a host name. Patch by Dong-hee Na.

* bpo-37885: venv: Don't generate unset variable warning on
  deactivate.

* bpo-37785: Fix xgettext warnings in "argparse".

* bpo-11953: Completing WSA* error codes in "socket".

* bpo-37424: Fixes a possible hang when using a timeout on
  "subprocess.run()" while capturing output.  If the child process
  spawned its own children or otherwise connected its stdout or stderr
  handles with another process, we could hang after the timeout was
  reached and our child was killed when attempting to read final
  output from the pipes.

* bpo-37212: "unittest.mock.call()" now preserves the order of keyword
  arguments in repr output. Patch by Karthikeyan Singaravelan.

* bpo-37305: Add .webmanifest -> application/manifest+json to list of
  recognized file types and content type headers

* bpo-21872: Fix "lzma": module decompresses data incompletely. When
  decompressing a FORMAT_ALONE format file, and it doesn't have the
  end marker, sometimes the last one to dozens bytes can't be output.
  Patch by Ma Lin.

* bpo-37206: Default values which cannot be represented as Python
  objects no longer improperly represented as "None" in function
  signatures.

* bpo-12144: Ensure cookies with "expires" attribute are handled in
  "CookieJar.make_cookies()".

* bpo-31163: pathlib.Path instance's rename and replace methods now
  return the new Path instance.

* bpo-25068: "urllib.request.ProxyHandler" now lowercases the keys of
  the passed dictionary.

* bpo-21315: Email headers containing RFC2047 encoded words are parsed
  despite the missing whitespace, and a defect registered. Also
  missing trailing whitespace after encoded words is now registered as
  a defect.

* bpo-36250: Ignore "ValueError" from "signal" with "interaction" in
  non-main thread.

* bpo-35168: "shlex.shlex.punctuation_chars" is now a read-only
  property.

* bpo-20504: Fixes a bug in "cgi" module when a multipart/form-data
  request has no "Content-Length" header.

* bpo-34519: Add additional aliases for HP Roman 8. Patch by Michael
  Osipov.


文档
----

* bpo-26868: Fix example usage of "PyModule_AddObject()" to properly
  handle errors.

* bpo-36797: Fix a dead link in the distutils API Reference.

* bpo-37977: Warn more strongly and clearly about pickle insecurity

* bpo-37937: Mention "frame.f_trace" in "sys.settrace()" docs.

* bpo-36260: Add decompression pitfalls to zipfile module
  documentation.

* bpo-36960: Restructured the "datetime" docs in the interest of
  making them more user-friendly and improving readability. Patch by
  Brad Solomon.

* bpo-23460: The documentation for decimal string formatting using the
  ":g" specifier has been updated to reflect the correct exponential
  notation cutoff point. Original patch contributed by Tuomas Suutari.

* bpo-35803: Document and test that "tempfile" functions may accept a
  *path-like object* for the "dir" argument.  Patch by Anthony
  Sottile.

* bpo-33944: Added a note about the intended use of code in .pth
  files.

* bpo-34293: Fix the Doc/Makefile regarding PAPER environment variable
  and PDF builds


测试
----

* bpo-38239: Fix test_gdb for Link Time Optimization (LTO) builds.

* bpo-38275: test_ssl now handles disabled TLS/SSL versions better.
  OpenSSL's crypto policy and run-time settings are recognized and
  tests for disabled versions are skipped. Tests also accept more TLS
  minimum_versions for platforms that override OpenSSL's default with
  strict settings.

* bpo-38271: The private keys for test_ssl were encrypted with 3DES in
  traditional PKCS#5 format. 3DES and the digest algorithm of PKCS#5
  are blocked by some strict crypto policies. Use PKCS#8 format with
  AES256 encryption instead.

* bpo-38270: test.support now has a helper function to check for
  availibility of a hash digest function. Several tests are refactored
  avoid MD5 and use SHA256 instead. Other tests are marked to use MD5
  and skipped when MD5 is disabled.

* bpo-37123: Multiprocessing test test_mymanager() now also expects
  -SIGTERM, not only exitcode 0. BaseManager._finalize_manager() sends
  SIGTERM to the manager process if it takes longer than 1 second to
  stop, which happens on slow buildbots.

* bpo-38212: Multiprocessing tests: increase
  test_queue_feeder_donot_stop_onexc() timeout from 1 to 60 seconds.

* bpo-38117: 使用OpenSSL 1.1.1d进行测试

* bpo-37531: Enhance regrtest multiprocess timeout: write a message
  when killing a worker process, catch popen.kill() and popen.wait()
  exceptions, put a timeout on the second call to popen.communicate().

* bpo-37876: Add tests for ROT-13 codec.

* bpo-37252: Fix assertions in "test_close" and
  "test_events_mask_overflow" devpoll tests.

* bpo-34001: Make test_ssl pass with LibreSSL. LibreSSL handles
  minimum and maximum TLS version differently than OpenSSL.

* bpo-36919: Make "test_source_encoding.test_issue2301" implementation
  independent. The test will work now for both CPython and IronPython.

* bpo-34596: Fallback to a default reason when "unittest.skip()" is
  uncalled. Patch by Naitree Zhu.


构建
----

* bpo-38301: In Solaris family, we must be sure to use "-D_REENTRANT".
  Patch by Jesús Cea Avión.

* bpo-36210: Update optional extension module detection for AIX.
  ossaudiodev and spwd are not applicable for AIX, and are no longer
  reported as missing. 3rd-party packaging of ncurses (with ASIS
  support) conflicts with officially supported AIX curses library, so
  configure AIX to use libcurses.a. However, skip trying to build
  _curses_panel.

  patch by M Felt

* bpo-36002: Locate "llvm-profdata" and "llvm-ar" binaries using
  "AC_PATH_TOOL" rather than "AC_PATH_TARGET_TOOL".

* bpo-37936: The ".gitignore" file systematically keeps "rooted", with
  a non-trailing slash, all the rules that are meant to apply to files
  in a specific place in the repo.  Previously, when the intended file
  to ignore happened to be at the root of the repo, we'd most often
  accidentally also ignore files and directories with the same name
  anywhere in the tree.

* bpo-37936: The ".gitignore" file no longer applies to any files that
  are in fact tracked in the Git repository.  Patch by Greg Price.


Windows
-------

* bpo-38117: 将绑定的OpenSSL更新到1.1.1d

* bpo-38092: Reduce overhead when using multiprocessing in a Windows
  virtual environment.

* bpo-38133: Allow py.exe launcher to locate installations from the
  Microsoft Store and improve display of active virtual environments.

* bpo-38114: The "pip.ini" is no longer included in the Nuget package.

* bpo-36634: "os.cpu_count()" now returns active processors rather
  than maximum processors.

* bpo-36634: venv activate.bat now works when the existing variables
  contain double quote characters.

* bpo-38081: Prevent error calling "os.path.realpath()" on "'NUL'".

* bpo-38087: Fix case sensitivity in test_pathlib and test_ntpath.

* bpo-38088: Fixes distutils not finding vcruntime140.dll with only
  the v142 toolset installed.

* bpo-37283: Ensure command-line and unattend.xml setting override
  previously detected states in Windows installer.

* bpo-38030: Fixes "os.stat()" failing for block devices on Windows

* bpo-38020: Fixes potential crash when calling "os.readlink()" (or
  indirectly through "realpath()") on a file that is not a supported
  link.

* bpo-37705: Improve the implementation of "winerror_to_errno()".

* bpo-37702: Fix memory leak on Windows in creating an SSLContext
  object or running urllib.request.urlopen('https://...').

* bpo-37445: Include the "FORMAT_MESSAGE_IGNORE_INSERTS" flag in
  "FormatMessageW()" calls.

* bpo-37380: Don't collect unfinished processes with
  "subprocess._active" on Windows to cleanup later. Patch by Ruslan
  Kuprieiev.

* bpo-32587: Make "winreg.REG_MULTI_SZ" support zero-length strings.


macOS
-----

* bpo-38117: 在MacOS安装程序中将OpenSSL更新为1.1.1d。

* bpo-38089: Move Azure Pipelines to latest VM versions and make macOS
  tests optional


IDLE
----

* bpo-35379: When exiting IDLE, catch any AttributeError.  One happens
  when EditorWindow.close is called twice.  Printing a traceback, when
  IDLE is run from a terminal, is useless and annoying.

* bpo-38183: To avoid problems, test_idle ignores the user config
  directory. It no longer tries to create or access .idlerc or any
  files within. Users must run IDLE to discover problems with saving
  settings.

* bpo-38077: IDLE no longer adds 'argv' to the user namespace when
  initializing it.  This bug only affected 3.7.4 and 3.8.0b2 to
  3.8.0b4.

* bpo-38041: Shell restart lines now fill the window width, always
  start with '=', and avoid wrapping unnecessarily. The line will
  still wrap if the included file name is long relative to the width.

* bpo-35771: To avoid occasional spurious test_idle failures on slower
  machines, increase the "hover_delay" in test_tooltip.

* bpo-37902: Add mousewheel scrolling for IDLE module, path, and stack
  browsers. Patch by George Zhang.


工具/示例
---------

* bpo-37803: pdb's "--help" and "--version" long options now work.

* bpo-37064: Add option -k to pathscript.py script: preserve shebang
  flags. Add option -a to pathscript.py script: add flags.


C API
-----

* bpo-38234: "Py_SetPath()" now sets "sys.executable" to the program
  full path ("Py_GetProgramFullPath()") rather than to the program
  name ("Py_GetProgramName()").

* bpo-38234: Python ignored arguments passed to "Py_SetPath()",
  "Py_SetPythonHome()" and "Py_SetProgramName()": fix Python
  initialization to use specified arguments.

* bpo-38205: The "Py_UNREACHABLE()" macro now calls "Py_FatalError()".

* bpo-37879: Fix subtype_dealloc to suppress the type decref when the
  base type is a C heap type


Python 3.8.0 beta 4
===================

*发布日期: 2019-08-29*


安全
----

* bpo-34155: Fix parsing of invalid email addresses with more than one
  "@" (e.g. a@b@c.com.) to not return the part before 2nd "@" as valid
  email address. Patch by maxking & jpic.


核心与内置
----------

* bpo-37947: Adjust correctly the recursion level in the symtable
  generation for named expressions. Patch by Pablo Galindo.

* bpo-37830: Fixed compilation of "break" and "continue" in the
  "finally" block when the corresponding "try" block contains "return"
  with a non-constant value.

* bpo-32912: Reverted bpo-32912: emitting "SyntaxWarning" instead of
  "DeprecationWarning" for invalid escape sequences in string and
  bytes literals.

* bpo-37757: **PEP 572**: As described in the PEP, assignment
  expressions now raise "SyntaxError" when their interaction with
  comprehension scoping results in an ambiguous target scope.

  The "TargetScopeError" subclass originally proposed by the PEP has
  been removed in favour of just raising regular syntax errors for the
  disallowed cases.

* bpo-36311: Decoding bytes objects larger than 2GiB is faster and no
  longer fails when a multibyte characters spans a chunk boundary.

* bpo-37433: Fix "SyntaxError" indicator printing too many spaces for
  multi-line strings - by Anthony Sottile.

* bpo-20523: "pdb.Pdb" supports ~/.pdbrc in Windows 7. Patch by Tim
  Hopper and Dan Lidral-Porter.


库
--

* bpo-37834: Prevent shutil.rmtree exception when built on non-Windows
  system without fd system call support, like older versions of macOS.

* bpo-37965: Fix C compiler warning caused by
  distutils.ccompiler.CCompiler.has_function.

* bpo-37960: "repr()" of buffered and text streams now silences only
  expected exceptions when get the value of "name" and "mode"
  attributes.

* bpo-37951: Most features of the subprocess module now work again in
  subinterpreters. Only *preexec_fn* is restricted in subinterpreters.

* bpo-36205: Fix the rusage implementation of time.process_time() to
  correctly report the sum of the system and user CPU time.

* bpo-37950: Fix "ast.dump()" when call with incompletely initialized
  node.

* bpo-34679: Restores instantiation of Windows IOCP event loops from
  the non-main thread.

* bpo-36917: Add default implementation of the
  "ast.NodeVisitor.visit_Constant()" method which emits a deprecation
  warning and calls corresponding methody "visit_Num()",
  "visit_Str()", etc.

* bpo-37798: Update test_statistics.py to verify that the statistics
  module works well for both C and Python implementations. Patch by
  Dong-hee Na

* bpo-26589: Added a new status code to the http module: 451
  UNAVAILABLE_FOR_LEGAL_REASONS

* bpo-37915: Fix a segmentation fault that appeared when comparing
  instances of "datetime.timezone" and "datetime.tzinfo" objects.
  Patch by Pablo Galindo.

* bpo-37868: Fix dataclasses.is_dataclass when given an instance that
  never raises AttributeError in __getattr__.  That is, an object that
  returns something for __dataclass_fields__ even if it's not a
  dataclass.

* bpo-37811: Fix "socket" module's "socket.connect(address)" function
  being unable to establish connection in case of interrupted system
  call. The problem was observed on all OSes which "poll(2)" system
  call can take only non-negative integers and -1 as a timeout value.

* bpo-21131: Fix "faulthandler.register(chain=True)" stack.
  faulthandler now allocates a dedicated stack of "SIGSTKSZ*2" bytes,
  instead of just "SIGSTKSZ" bytes. Calling the previous signal
  handler in faulthandler signal handler uses more than "SIGSTKSZ"
  bytes of stack memory on some platforms.

* bpo-37798: Add C fastpath for statistics.NormalDist.inv_cdf() Patch
  by Dong-hee Na

* bpo-37819: Add Fraction.as_integer_ratio() to match the
  corresponding methods in bool, int, float, and decimal.

* bpo-37810: Fix "difflib" "?" hint in diff output when dealing with
  tabs.  Patch by Anthony Sottile.

* bpo-37772: In "zipfile.Path", when adding implicit dirs, ensure that
  ancestral directories are added and that duplicates are excluded.

* bpo-28292: Mark calendar.py helper functions as being private.  The
  follows PEP 8 guidance to maintain the style conventions in the
  module and it addresses a known case of user confusion.

* bpo-18049: Add definition of THREAD_STACK_SIZE for AIX in
  Python/thread_pthread.h The default thread stacksize caused crashes
  with the default recursion limit Patch by M Felt

* bpo-37738: Fix the implementation of curses "addch(str,
  color_pair)": pass the color pair to "setcchar()", instead of always
  passing 0 as the color pair.

* bpo-37723: Fix performance regression on regular expression parsing
  with huge character sets. Patch by Yann Vaginay.

* bpo-32178: Fix IndexError in "email" package when trying to parse
  invalid address fields starting with ":".

* bpo-37685: Fixed comparisons of "datetime.timedelta" and
  "datetime.timezone".

* bpo-37695: Correct "curses.unget_wch()" error message.  Patch by
  Anthony Sottile.

* bpo-37354: Make Activate.ps1 Powershell script static to allow for
  signing it.

* bpo-37664: Update wheels bundled with ensurepip (pip 19.2.3 and
  setuptools 41.2.0)

* bpo-37642: Allowed the pure Python implementation of
  "datetime.timezone" to represent sub-minute offsets close to minimum
  and maximum boundaries, specifically in the ranges (23:59, 24:00)
  and (-23:59, 24:00). Patch by Ngalim Siregar

* bpo-16970: Adding a value error when an invalid value in passed to
  nargs Patch by Robert Leenders

* bpo-37587: Make json.loads faster for long strings. (Patch by Marco
  Paolini)

* bpo-18378: Recognize "UTF-8" as a valid value for LC_CTYPE in
  locale._parse_localename.

* bpo-37531: "python3 -m test -jN --timeout=TIMEOUT" now kills a
  worker process if it runs longer than *TIMEOUT* seconds.

* bpo-37482: Fix serialization of display name in originator or
  destination address fields with both encoded words and special
  chars.

* bpo-37372: Fix error unpickling datetime.time objects from Python 2
  with seconds>=24. Patch by Justin Blanchard.

* bpo-37085: Add the optional Linux SocketCAN Broadcast Manager
  constants, used as flags to configure the BCM behaviour, in the
  socket module.  Patch by Karl Ding.

* bpo-36871: Ensure method signature is used instead of constructor
  signature of a class while asserting mock object against method
  calls. Patch by Karthikeyan Singaravelan.

* bpo-36582: Fix "UserString.encode()" to correctly return "bytes"
  rather than a "UserString" instance.

* bpo-34775: Division handling of PurePath now returns NotImplemented
  instead of raising a TypeError when passed something other than an
  instance of str or PurePath. Patch by Roger Aiudi.


文档
----

* bpo-37979: Added a link to dateutil.parser.isoparse in the
  datetime.fromisoformat documentation. Patch by Paul Ganssle

* bpo-37759: Beginning edits to Whatsnew 3.8

* bpo-37726: Stop recommending getopt in the tutorial for command line
  argument parsing and promote argparse.

* bpo-37256: Fix wording of arguments for "Request" in
  "urllib.request"

* bpo-37004: In the documentation for difflib, a note was added
  explicitly warning that the results of SequenceMatcher's ratio
  method may depend on the order of the input strings.

* bpo-36487: Make C-API docs clear about what the "main" interpreter
  is.


测试
----

* bpo-37805: Add tests for json.dump(..., skipkeys=True). Patch by
  Dong-hee Na.


构建
----

* bpo-37707: Mark some individual tests to skip when --pgo is used.
  The tests marked increase the PGO task time significantly and likely
  don't help improve optimization of the final executable.


Windows
-------

* bpo-37549: "os.dup()" no longer fails for standard streams on
  Windows 7.

* bpo-1311: The "nul" file on Windows now returns True from "exists()"
  and a valid result from "os.stat()" with "S_IFCHR" set.

* bpo-9949: Enable support for following symlinks in "os.realpath()".

* bpo-37834: Treat all name surrogate reparse points on Windows in
  "os.lstat()" and other reparse points as regular files in
  "os.stat()".

* bpo-36266: Add the module name in the formatted error message when
  DLL load fail happens during module import in
  "_PyImport_FindSharedFuncptrWindows()". Patch by Srinivas Nyayapati.

* bpo-25172: Trying to import the "crypt" module on Windows will
  result in an "ImportError" with a message explaining that the module
  isn't supported on Windows. On other platforms, if the underlying
  "_crypt" module is not available, the ImportError will include a
  message explaining the problem.

* bpo-37778: Fixes the icons used for file associations to the
  Microsoft Store package.

* bpo-37734: Fix use of registry values to launch Python from
  Microsoft Store app.

* bpo-28269: Replace use of "strcasecmp()" for the system function
  "_stricmp()". Patch by Minmin Gong.


macOS
-----

* bpo-18049: Increase the default stack size of threads from 5MB to
  16MB on macOS, to match the stack size of the main thread. This
  avoids crashes on deep recursion in threads.


IDLE
----

* bpo-37824: Properly handle user input warnings in IDLE shell. Cease
  turning SyntaxWarnings into SyntaxErrors.

* bpo-37929: IDLE Settings dialog now closes properly when there is no
  shell window.

* bpo-37849: Fixed completions list appearing too high or low when
  shown above the current line.

* bpo-36419: Refactor IDLE autocomplete and improve testing.

* bpo-37748: Reorder the Run menu.  Put the most common choice, Run
  Module, at the top.


工具/示例
---------

* bpo-37942: Improve ArgumentClinic converter for floats.

* bpo-37034: Argument Clinic now uses the argument name on errors with
  keyword-only argument instead of their position. Patch contributed
  by Rémi Lapeyre.


C API
-----

* bpo-36763: Options added by "PySys_AddXOption()" are now handled the
  same way than "PyConfig.xoptions" and command line "-X" options.

* bpo-37926: Fix a crash in "PySys_SetArgvEx(0, NULL, 0)".


Python 3.8.0 beta 3
===================

*发布日期: 2019-07-29*


安全
----

* bpo-37461: Fix an infinite loop when parsing specially crafted email
  headers. Patch by Abhilash Raj.


核心与内置
----------

* bpo-37593: Swap the positions of the *posonlyargs* and *args*
  parameters in the constructor of "ast.parameters" nodes.

* bpo-36974: Implemented separate vectorcall functions for every
  calling convention of builtin functions and methods. This improves
  performance for calls.


库
--

* bpo-37697: Syncronize "importlib.metadata" with importlib_metadata
  0.19, improving handling of EGG-INFO files and fixing a crash when
  entry point names contained colons.

* bpo-37691: Let math.dist() accept coordinates as sequences (or
  iterables) rather than just tuples.

* bpo-37664: Update wheels bundled with ensurepip (pip 19.2.1 and
  setuptools 41.0.1)

* bpo-36324: Make internal attributes for statistics.NormalDist()
  private.

* bpo-37491: Fix "IndexError" when parsing email headers with
  unexpectedly ending bare-quoted string value. Patch by Abhilash Raj.

* bpo-37579: Return "NotImplemented" in Python implementation of
  "__eq__" for "timedelta" and "time" when the other object being
  compared is not of the same type to match C implementation. Patch by
  Karthikeyan Singaravelan.

* bpo-21478: Record calls to parent when autospecced object is
  attached to a mock using "unittest.mock.attach_mock()". Patch by
  Karthikeyan Singaravelan.

* bpo-37502: pickle.loads() no longer raises TypeError when the
  buffers argument is set to None

* bpo-37520: Correct behavior for zipfile.Path.parent when the path
  object identifies a subdirectory.

* bpo-18374: Fix the ".col_offset" attribute of nested "ast.BinOp"
  instances which had a too large value in some situations.

* bpo-37421: Fix "multiprocessing.util.get_temp_dir()" finalizer:
  clear also the 'tempdir' configuration of the current process, so
  next call to "get_temp_dir()" will create a new temporary directory,
  rather than reusing the removed temporary directory.

* bpo-37481: The distutils "bdist_wininst" command is deprecated in
  Python 3.8, use "bdist_wheel" (wheel packages) instead.

* bpo-26967: An "ArgumentParser" with "allow_abbrev=False" no longer
  disables grouping of short flags, such as "-vv", but only disables
  abbreviation of long flags as documented. Patch by Zac Hatfield-
  Dodds.

* bpo-37347: "sqlite3.Connection.create_aggregate()",
  "sqlite3.Connection.create_function()",
  "sqlite3.Connection.set_authorizer()",
  "sqlite3.Connection.set_progress_handler()"
  "sqlite3.Connection.set_trace_callback()" methods lead to segfaults
  if some of these methods are called twice with an equal object but
  not the same. Now callbacks are stored more carefully. Patch by
  Aleksandr Balezin.

* bpo-36564: Fix infinite loop in email header folding logic that
  would be triggered when an email policy's max_line_length is not
  long enough to include the required markup and any values in the
  message. Patch by Paul Ganssle


文档
----

* bpo-32910: Remove implementation-specific behaviour of how venv's
  Deactivate works.

* bpo-37284: Add a brief note to indicate that any new
  "sys.implementation" required attributes must go through the PEP
  process.

* bpo-30088: Documented that "mailbox.Maildir" constructor doesn't
  attempt to verify the maildir folder layout correctness. Patch by
  Sviatoslav Sydorenko.

* bpo-37521: Fix "importlib" examples to insert any newly created
  modules via importlib.util.module_from_spec() immediately into
  sys.modules instead of after calling loader.exec_module().

  Thanks to Benjamin Mintz for finding the bug.

* bpo-37456: Slash ('/') is now part of syntax.

* bpo-37487: Fix PyList_GetItem index description to include 0.

* bpo-37149: Replace the dead link to the Tkinter 8.5 reference by
  John Shipman, New Mexico Tech, with a link to the archive.org copy.

* bpo-37478: Added possible exceptions to the description of
  os.chdir().


测试
----

* bpo-37558: Fix test_shared_memory_cleaned_after_process_termination
  name handling

* bpo-37526: Add "test.support.catch_threading_exception()": context
  manager catching "threading.Thread" exception using
  "threading.excepthook()".

* bpo-37421: test_concurrent_futures now explicitly stops the
  ForkServer instance if it's running.

* bpo-37421: multiprocessing tests now stop the ForkServer instance if
  it's running: close the "alive" file descriptor to ask the server to
  stop and then remove its UNIX address.


构建
----

* bpo-36044: Reduce the number of unit tests run for the PGO
  generation task.  This speeds up the task by a factor of about 15x.
  Running the full unit test suite is slow.  This change may result in
  a slightly less optimized build since not as many code branches will
  be executed.  If you are willing to wait for the much slower build,
  the old behavior can be restored using './configure [..]
  PROFILE_TASK="-m test --pgo-extended"'. We make no guarantees as to
  which PGO task set produces a faster build. Users who care should
  run their own relevant benchmarks as results can depend on the
  environment, workload, and compiler tool chain.


Windows
-------

* bpo-37672: Switch Windows Store package's pip to use bundled
  "pip.ini" instead of "PIP_USER" variable.


IDLE
----

* bpo-37692: Improve highlight config sample with example shell
  interaction and better labels for shell elements.

* bpo-37628: Settings dialog no longer expands with font size.

* bpo-37627: Initialize the Customize Run dialog with the command line
  arguments most recently entered before.  The user can optionally
  edit before submitting them.

* bpo-33610: Fix code context not showing the correct context when
  first toggled on.

* bpo-37530: Optimize code context to reduce unneeded background
  activity. Font and highlight changes now occur along with text
  changes instead of after a random delay.

* bpo-27452: Cleanup "config.py" by inlining "RemoveFile" and
  simplifying the handling of "file" in "CreateConfigHandlers".

* bpo-17535: Add optional line numbers for IDLE editor windows.
  Windows open without line numbers unless set otherwise in the
  General tab of the configuration dialog.

* bpo-26806: To compensate for stack frames added by IDLE and avoid
  possible problems with low recursion limits, add 30 to limits in the
  user code execution process.  Subtract 30 when reporting recursion
  limits to make this addition mostly transparent.

* bpo-36390: Gather Format menu functions into format.py.  Combine
  paragraph.py, rstrip.py, and format methods from editor.py.


工具/示例
---------

* bpo-37675: 2to3 now works when run from a zipped standard library.


Python 3.8.0 beta 2
===================

*发布日期: 2019-07-04*


安全
----

* bpo-37363: Adds audit events for the range of supported run commands
  (see 命令行与环境).

* bpo-37463: ssl.match_hostname() no longer accepts IPv4 addresses
  with additional text after the address and only quad-dotted notation
  without trailing whitespaces. Some inet_aton() implementations
  ignore whitespace and all data after whitespace, e.g. '127.0.0.1
  whatever'.

* bpo-37363: Adds audit events for "ensurepip", "ftplib", "glob",
  "imaplib", "nntplib", "pdb", "poplib", "shutil", "smtplib",
  "sqlite3", "subprocess", "telnetlib", "tempfile" and "webbrowser",
  as well as "os.listdir()", "os.scandir()" and "breakpoint()".

* bpo-37364: "io.open_code()" is now used when reading ".pth" files.

* bpo-34631: 在Windows安装程序中将OpenSSL更新为1.1.1c


核心与内置
----------

* bpo-37467: Fix "sys.excepthook()" and "PyErr_Display()" if a
  filename is a bytes string. For example, for a SyntaxError exception
  where the filename attribute is a bytes string.

* bpo-37417: "bytearray.extend()" now correctly handles errors that
  arise during iteration. Patch by Brandt Bucher.

* bpo-24214: Improved support of the surrogatepass error handler in
  the UTF-8 and UTF-16 incremental decoders.

* bpo-35224: Reverse evaluation order of key: value in dict
  comprehensions as proposed in PEP 572. I.e. in "{k: v for ...}", "k"
  will be evaluated before "v".

* bpo-37316: Fix the "PySys_Audit()" call in "mmap.mmap".

* bpo-37269: Fix a bug in the peephole optimizer that was not treating
  correctly constant conditions with binary operators. Patch by Pablo
  Galindo.

* bpo-37213: Handle correctly negative line offsets in the peephole
  optimizer. Patch by Pablo Galindo.

* bpo-37219: Remove errorneous optimization for empty set differences.

* bpo-36922: Slot functions optimize any callable with
  "Py_TPFLAGS_METHOD_DESCRIPTOR" instead of only instances of
  "function".

* bpo-36974: The slot "tp_vectorcall_offset" is inherited
  unconditionally to support "super().__call__()" when the base class
  uses vectorcall.

* bpo-37160: "threading.get_native_id()" now also supports NetBSD.

* bpo-37077: Add "threading.get_native_id()" support for AIX. Patch by
  M. Felt


库
--

* bpo-37440: http.client now enables TLS 1.3 post-handshake
  authentication for default context or if a cert_file is passed to
  HTTPSConnection.

* bpo-37437: Update vendorized expat version to 2.2.7.

* bpo-37428: SSLContext.post_handshake_auth = True no longer sets
  SSL_VERIFY_POST_HANDSHAKE verify flag for client connections.
  Although the option is documented as ignored for clients, OpenSSL
  implicitly enables cert chain validation when the flag is set.

* bpo-37420: "os.sched_setaffinity()" now correctly handles errors
  that arise during iteration over its "mask" argument. Patch by
  Brandt Bucher.

* bpo-37412: The "os.getcwdb()" function now uses the UTF-8 encoding
  on Windows, rather than the ANSI code page: see **PEP 529** for the
  rationale. The function is no longer deprecated on Windows.

* bpo-29412: Fix IndexError in parsing a header value ending
  unexpectedly. Patch by Abhilash Raj.

* bpo-36546: The *dist* argument for statistics.quantiles() is now
  positional only. The current name doesn't reflect that the argument
  can be either a dataset or a distribution.  Marking the parameter as
  positional avoids confusion and makes it possible to change the name
  later.

* bpo-37394: Fix a bug that was causing the "queue" module to fail if
  the accelerator module was not available. Patch by Pablo Galindo.

* bpo-33972: Email with single part but content-type set to
  "multipart/*" doesn't raise AttributeError anymore.

* bpo-37280: Use threadpool for reading from file for sendfile
  fallback mode.

* bpo-37279: Fix asyncio sendfile support when sendfile sends extra
  data in fallback mode.

* bpo-19865: "ctypes.create_unicode_buffer()" now also supports non-
  BMP characters on platforms with 16-bit "wchar_t" (for example,
  Windows and AIX).

* bpo-37210: Allow pure Python implementation of "pickle" to work even
  when the C "_pickle" module is unavailable.

* bpo-35922: Fix "RobotFileParser.crawl_delay()" and
  "RobotFileParser.request_rate()" to return "None" rather than raise
  "AttributeError" when no relevant rule is defined in the robots.txt
  file.  Patch by Rémi Lapeyre.

* bpo-35766: Change the format of feature_version to be a (major,
  minor) tuple.

* bpo-36607: Eliminate "RuntimeError" raised by "asyncio.all_tasks()"
  if internal tasks weak set is changed by another thread during
  iteration.

* bpo-18748: "_pyio.IOBase" destructor now does nothing if getting the
  "closed" attribute fails to better mimick "_io.IOBase" finalizer.

* bpo-36402: Fix a race condition at Python shutdown when waiting for
  threads. Wait until the Python thread state of all non-daemon
  threads get deleted (join all non-daemon threads), rather than just
  wait until non-daemon Python threads complete.

* bpo-34886: Fix an unintended ValueError from "subprocess.run()" when
  checking for conflicting "input" and "stdin" or "capture_output" and
  "stdout" or "stderr" args when they were explicitly provided but
  with "None" values within a passed in "**kwargs" dict rather than as
  passed directly by name. Patch contributed by Rémi Lapeyre.

* bpo-37173: The exception message for "inspect.getfile()" now
  correctly reports the passed class rather than the builtins module.

* bpo-37178: Give math.perm() a one argument form that means the same
  as math.factorial().

* bpo-37178: For math.perm(n, k), let k default to n, giving the same
  result as factorial.

* bpo-37163: Deprecated passing "obj" argument of
  "dataclasses.replace()" as keyword argument.

* bpo-37165: Converted _collections._count_elements to use the
  Argument Clinic.

* bpo-34767: Do not always create a "collections.deque" in
  "asyncio.Lock".

* bpo-37158: Speed-up statistics.fmean() by switching from a function
  to a generator.

* bpo-37150: "argparse._ActionsContainer.add_argument" now throws
  error, if someone accidentally pass FileType class object instead of
  instance of FileType as "type" argument

* bpo-35621: Support running asyncio subprocesses when execution event
  loop in a thread on UNIX.

* bpo-36520: Lengthy email headers with UTF-8 characters are now
  properly encoded when they are folded. Patch by Jeffrey Kintscher.

* bpo-30835: Fixed a bug in email parsing where a message with invalid
  bytes in content-transfer-encoding of a multipart message can cause
  an AttributeError. Patch by Andrew Donnellan.

* bpo-35805: Add parser for Message-ID header and add it to default
  HeaderRegistry. This should prevent folding of Message-ID using RFC
  2048 encoded words.

* bpo-35070: posix.getgrouplist() now works correctly when the user
  belongs to NGROUPS_MAX supplemental groups. Patch by Jeffrey
  Kintscher.

* bpo-32627: Fix compile error when "_uuid" headers conflicting
  included.

* bpo-11122: Distutils won't check for rpmbuild in specified paths
  only.

* bpo-4963: Fixed non-deterministic behavior related to mimetypes
  extension mapping and module reinitialization.


文档
----

* bpo-34903: Documented that in "datetime.datetime.strptime()", the
  leading zero in some two-digit formats is optional. Patch by Mike
  Gleen.


测试
----

* bpo-37421: test_distutils.test_build_ext() is now able to remove the
  temporary directory on Windows: don't import the newly built C
  extension ("xx") in the current process, but test it in a separated
  process.

* bpo-37421: test_concurrent_futures now cleans up multiprocessing to
  remove immediately temporary directories created by
  multiprocessing.util.get_temp_dir().

* bpo-37421: test_winconsoleio doesn't leak a temporary file anymore:
  use tempfile.TemporaryFile() to remove it when the test completes.

* bpo-37421: multiprocessing tests now explicitly call
  "_run_finalizers()" to immediately remove temporary directories
  created by tests.

* bpo-37199: Fix test failures when IPv6 is unavailable or disabled.

* bpo-37335: Remove no longer necessary code from c locale coercion
  tests

* bpo-37421: Fix test_shutil to no longer leak temporary files.

* bpo-37411: Fix test_wsgiref.testEnviron() to no longer depend on the
  environment variables (don't fail if "X" variable is set).

* bpo-37400: Fix test_os.test_chown(): use os.getgroups() rather than
  grp.getgrall() to get groups. Rename also the test to
  test_chown_gid().

* bpo-37359: Add --cleanup option to python3 -m test to remove
  "test_python_*" directories of previous failed jobs. Add "make
  cleantest" to run "python3 -m test --cleanup".

* bpo-37362: test_gdb no longer fails if it gets an "unexpected"
  message on stderr: it now ignores stderr. The purpose of test_gdb is
  to test that python-gdb.py commands work as expected, not to test
  gdb.

* bpo-35998: Avoid TimeoutError in test_asyncio:
  test_start_tls_server_1()

* bpo-37278: Fix test_asyncio ProactorLoopCtrlC: join the thread to
  prevent leaking a running thread and leaking a reference.

* bpo-37261: Fix "test.support.catch_unraisable_exception()": its
  __exit__() method now ignores unraisable exception raised when
  clearing its "unraisable" attribute.

* bpo-37169: Rewrite "_PyObject_IsFreed()" unit tests.

* bpo-37153: "test_venv.test_mutiprocessing()" now explicitly calls
  "pool.terminate()" to wait until the pool completes.

* bpo-28009: Modify the test_uuid logic to test when a program is
  available AND can be used to obtain a MACADDR as basis for an UUID.
  Patch by M. Felt


构建
----

* bpo-37189: Many "PyRun_XXX()" functions like "PyRun_String()" were
  no longer exported in "libpython38.dll" by mistake. Export them
  again to fix the ABI compatibiliy.


Windows
-------

* bpo-10945: 正式取消对在非Windows系统上创建 bdist_wininst 安装程序的
  支持。

* bpo-37369: Fixes path for "sys.executable" when running from the
  Microsoft Store.

* bpo-37351: Removes libpython38.a from standard Windows distribution.

* bpo-35360: 更新 Windows 构建以使用 SQLite 3.28.0.

* bpo-37267: On Windows, "os.dup()" no longer creates an inheritable
  fd when handling a character file.

* bpo-36779: Ensure "time.tzname" is correct on Windows when the
  active code page is set to CP_UTF7 or CP_UTF8.


macOS
-----

* bpo-34602: Avoid test suite failures on macOS by no longer calling
  resource.setrlimit to increase the process stack size limit at
  runtime. The runtime change is no longer needed since the
  interpreter is being built with a larger default stack size.

* bpo-35360: 更新macOS安装程序以使用SQLite 3.28.0.

* bpo-34631: 在MacOS安装程序中将OpenSSL更新为1.1.1c。


IDLE
----

* bpo-37325: Fix tab focus traversal order for help source and custom
  run dialogs.

* bpo-37321: Both subprocess connection error messages now refer to
  the 'Startup failure' section of the IDLE doc.

* bpo-37177: Properly 'attach' search dialogs to their main window so
  that they behave like other dialogs and do not get hidden behind
  their main window.

* bpo-37039: Adjust "Zoom Height" to individual screens by momemtarily
  maximizing the window on first use with a particular screen.
  Changing screen settings may invalidate the saved height.  While a
  window is maximized, "Zoom Height" has no effect.

* bpo-35763: Make calltip reminder about '/' meaning positional-only
  less obtrusive by only adding it when there is room on the first
  line.

* bpo-5680: Add 'Run... Customized' to the Run menu to run a module
  with customized settings.  Any 'command line arguments' entered are
  added to sys.argv. One can suppress the normal Shell main module
  restart.


C API
-----

* bpo-36763: Add "PyConfig_SetWideStringList()" function.

* bpo-28805: The "METH_FASTCALL" calling convention has been
  documented.

* bpo-37221: "tp_print" is put back at the end of the "PyTypeObject"
  structure to restore support for old code (in particular generated
  by Cython) setting "tp_print = 0". Note that "tp_print" will be
  removed entirely in Python 3.9.

* bpo-37221: The new function "PyCode_NewWithPosOnlyArgs()" allows to
  create code objects like "PyCode_New()", but with an extra
  *posonlyargcount* parameter for indicating the number of positonal-
  only arguments.

* bpo-37215: Fix dtrace issue introduce by bpo-36842

* bpo-37191: Python.h does not need compiler support for intermingled
  declarations (GCC's "-Wdeclaration-after-statement"), which were
  added in 3.8.0 Beta 1. Note that in Python 3.9, intermingled
  declarations will be needed again.

* bpo-37170: Fix the cast on error in
  "PyLong_AsUnsignedLongLongMask()".


Python 3.8.0 beta 1
===================

*发布日期: 2019-06-04*


安全
----

* bpo-35907: CVE-2019-9948: Avoid file reading by disallowing "local-
  file://" and "local_file://" URL schemes in "URLopener().open()" and
  "URLopener().retrieve()" of "urllib.request".

* bpo-33529: Prevent fold function used in email header encoding from
  entering infinite loop when there are too many non-ASCII characters
  in a header.

* bpo-33164: Updated blake2 implementation which uses secure memset
  implementation provided by platform.


核心与内置
----------

* bpo-35814: Allow unpacking in the right hand side of annotated
  assignments. In particular, "t: Tuple[int, ...] = x, y, *z" is now
  allowed.

* bpo-37126: All structseq objects are now tracked by the garbage
  collector. Patch by Pablo Galindo.

* bpo-37122: Make the *co_argcount* attribute of code objects
  represent the total number of positional arguments (including
  positional-only arguments). The value of *co_posonlyargcount* can be
  used to distinguish which arguments are positional only, and the
  difference (*co_argcount* - *co_posonlyargcount*) is the number of
  positional-or-keyword arguments. Patch by Pablo Galindo.

* bpo-20092: Constructors of "int", "float" and "complex" will now use
  the "__index__()" special method, if available and the corresponding
  method "__int__()", "__float__()" or "__complex__()" is not
  available.

* bpo-37087: Add native thread ID (TID) support to OpenBSD.

* bpo-26219: Implemented per opcode cache mechanism and "LOAD_GLOBAL"
  instruction use it. "LOAD_GLOBAL" is now about 40% faster.
  Contributed by Yury Selivanov, and Inada Naoki.

* bpo-37072: Fix crash in PyAST_FromNodeObject() when flags is NULL.

* bpo-37029: Freeing a great many small objects could take time
  quadratic in the number of arenas, due to using linear search to
  keep "obmalloc.c"'s list of usable arenas sorted by order of number
  of free memory pools. This is accomplished without search now,
  leaving the worst-case time linear in the number of arenas.  For
  programs where this quite visibly matters (typically with more than
  100 thousand small objects alive simultaneously), this can greatly
  reduce the time needed to release their memory.

* bpo-26423: Fix possible overflow in "wrap_lenfunc()" when
  "sizeof(long) < sizeof(Py_ssize_t)" (e.g., 64-bit Windows).

* bpo-37050: Improve the AST for "debug" f-strings, which use '=' to
  print out the source of the expression being evaluated.  Delete
  expr_text from the FormattedValue node, and instead use a Constant
  string node (possibly merged with adjacent constant expressions
  inside the f-string).

* bpo-22385: The "bytes.hex", "bytearray.hex", and "memoryview.hex"
  methods as well as the "binascii.hexlify" and "b2a_hex" functions
  now have the ability to include an optional separator between hex
  bytes.  This functionality was inspired by MicroPython's hexlify
  implementation.

* bpo-26836: Add "os.memfd_create()".

* bpo-37032: Added new "replace()" method to the code type
  ("types.CodeType").

* bpo-37007: Implement "socket.if_nameindex()",
  "socket.if_nametoindex()", and "socket.if_indextoname()" on Windows.

* bpo-36829: "PyErr_WriteUnraisable()" now creates a traceback object
  if there is no current traceback. Moreover, call
  "PyErr_NormalizeException()" and "PyException_SetTraceback()" to
  normalize the exception value. Ignore any error.

* bpo-36878: Only accept text after "# type: ignore" if the first
  character is ASCII. This is to disallow things like "# type:
  ignoreé".

* bpo-36878: Store text appearing after a "# type: ignore" comment in
  the AST. For example a type ignore like "# type: ignore[E1000]" will
  have the string ""[E1000]"" stored in its AST node.

* bpo-2180: Treat line continuation at EOF as a "SyntaxError" by
  Anthony Sottile.

* bpo-36907: Fix a crash when calling a C function with a keyword dict
  ("f(**kwargs)") and changing the dict "kwargs" while that function
  is running.

* bpo-36946: Fix possible signed integer overflow when handling
  slices.

* bpo-36826: Add NamedExpression kind support to ast_unparse.c

* bpo-1875: A "SyntaxError" is now raised if a code blocks that will
  be optimized away (e.g. if conditions that are always false)
  contains syntax errors. Patch by Pablo Galindo.

* bpo-36027: Allow computation of modular inverses via three-argument
  "pow": the second argument is now permitted to be negative in the
  case where the first and third arguments are relatively prime.

* bpo-36861: Update the Unicode database to version 12.1.0.

* bpo-28866: Avoid caching attributes of classes which type defines
  mro() to avoid a hard cache invalidation problem.

* bpo-36851: The "FrameType" stack is now correctly cleaned up if the
  execution ends with a return and the stack is not empty.

* bpo-34616: The "compile()" builtin functions now support the
  "ast.PyCF_ALLOW_TOP_LEVEL_AWAIT" flag,  which allow to compile
  sources that  contains top-level "await", "async with" or "async
  for". This is useful to evaluate async-code from with an already
  async functions; for example in a custom REPL.

* bpo-36842: Implement PEP 578, adding sys.audit, io.open_code and
  related APIs.

* bpo-27639: Correct return type for UserList slicing operations.
  Patch by Michael Blahay, Erick Cervantes, and vaultah

* bpo-36737: Move PyRuntimeState.warnings into per-interpreter state
  (via "module state").

* bpo-36793: Removed "__str__" implementations from builtin types
  "bool", "int", "float", "complex" and few classes from the standard
  library. They now inherit "__str__()" from "object".

* bpo-36817: Add a "=" feature f-strings for debugging. This can
  precede "!s", "!r", or "!a". It produces the text of the expression,
  followed by an equal sign, followed by the repr of the value of the
  expression. So "f'{3*9+15=}'" would be equal to the string
  "'3*9+15=42'".  If "=" is specified, the default conversion is set
  to "!r", unless a format spec is given, in which case the formatting
  behavior is unchanged, and __format__ will be used.

* bpo-24048: Save the live exception during import.c's
  "remove_module()".

* bpo-27987: pymalloc returns memory blocks aligned by 16 bytes,
  instead of 8 bytes, on 64-bit platforms to conform x86-64 ABI.
  Recent compilers assume this alignment more often. Patch by Inada
  Naoki.

* bpo-36601: A long-since-meaningless check for "getpid() == main_pid"
  was removed from Python's internal C signal handler.

* bpo-36594: Fix incorrect use of "%p" in format strings. Patch by
  Zackery Spytz.

* bpo-36045: builtins.help() now prefixes "async" for async functions

* bpo-36084: Add native thread ID (TID) to threading.Thread objects
  (supported platforms: Windows, FreeBSD, Linux, macOS)

* bpo-36035: Added fix for broken symlinks in combination with pathlib

* bpo-35983: Added new trashcan macros to deal with a double
  deallocation that could occur when the "tp_dealloc" of a subclass
  calls the "tp_dealloc" of a base class and that base class uses the
  trashcan mechanism. Patch by Jeroen Demeyer.

* bpo-20602: Do not clear "sys.flags" and "sys.float_info" during
  shutdown. Patch by Zackery Spytz.

* bpo-26826: Expose "copy_file_range()" as a low level API in the "os"
  module.

* bpo-32388: Remove cross-version binary compatibility requirement in
  tp_flags.

* bpo-31862: Port binascii to PEP 489 multiphase initialization. Patch
  by Marcel Plch.


库
--

* bpo-37128: Added "math.perm()".

* bpo-37120: Add SSLContext.num_tickets to control the number of
  TLSv1.3 session tickets.

* bpo-12202: Fix the error handling in
  "msilib.SummaryInformation.GetProperty()". Patch by Zackery Spytz.

* bpo-26835: The fcntl module now contains file sealing constants for
  sealing of memfds.

* bpo-29262: Add "get_origin()" and "get_args()" introspection helpers
  to "typing" module.

* bpo-12639: "msilib.Directory.start_component()" no longer fails if
  *keyfile* is not "None".

* bpo-36999: Add the "asyncio.Task.get_coro()" method to publicly
  expose the tasks's coroutine object.

* bpo-35246: Make "asyncio.create_subprocess_exec()" accept path-like
  arguments.

* bpo-35279: Change default *max_workers* of "ThreadPoolExecutor" from
  "cpu_count() * 5" to "min(32, cpu_count() + 4))".  Previous value
  was unreasonably large on many cores machines.

* bpo-37076: "_thread.start_new_thread()" now logs uncaught exception
  raised by the function using "sys.unraisablehook()", rather than
  "sys.excepthook()", so the hook gets access to the function which
  raised the exception.

* bpo-33725: On macOS, the "multiprocessing" module now uses *spawn*
  start method by default.

* bpo-37054: Fix destructor "_pyio.BytesIO" and "_pyio.TextIOWrapper":
  initialize their "_buffer" attribute as soon as possible (in the
  class body), because it's used by "__del__()" which calls "close()".

* bpo-37058: PEP 544: Add "Protocol" and "@runtime_checkable" to the
  "typing" module.

* bpo-36933: The functions "sys.set_coroutine_wrapper" and
  "sys.get_coroutine_wrapper" that were deprecated and marked for
  removal in 3.8 have been removed.

* bpo-37047: Handle late binding and attribute access in
  "unittest.mock.AsyncMock" setup for autospeccing. Document newly
  implemented async methods in "unittest.mock.MagicMock".

* bpo-37049: PEP 589: Add "TypedDict" to the "typing" module.

* bpo-37046: PEP 586: Add "Literal" to the "typing" module.

* bpo-37045: PEP 591: Add "Final" qualifier and "@final" decorator to
  the "typing" module.

* bpo-37035: Don't log OSError based exceptions if a fatal error has
  occurred in asyncio transport. Peer can generate almost any OSError,
  user cannot avoid these exceptions by fixing own code. Errors are
  still propagated to user code, it's just logging them is pointless
  and pollute asyncio logs.

* bpo-37001: "symtable.symtable()" now accepts the same input types
  for source code as the built-in "compile()" function. Patch by Dino
  Viehland.

* bpo-37028: Implement asyncio REPL

* bpo-37027: Return safe to use proxy socket object from
  transport.get_extra_info('socket')

* bpo-32528: Make asyncio.CancelledError a BaseException.

  This will address the common mistake many asyncio users make: an
  "except Exception" clause breaking Tasks cancellation.

  In addition to this change, we stop inheriting asyncio.TimeoutError
  and asyncio.InvalidStateError from their concurrent.futures.*
  counterparts. There's no point for these exceptions to share the
  inheritance chain.

* bpo-1230540: Add a new "threading.excepthook()" function which
  handles uncaught "threading.Thread.run()" exception. It can be
  overridden to control how uncaught "threading.Thread.run()"
  exceptions are handled.

* bpo-36996: Handle "unittest.mock.patch()" used as a decorator on
  async functions.

* bpo-37008: Add support for calling "next()" with the mock resulting
  from "unittest.mock.mock_open()"

* bpo-27737: Allow whitespace only header encoding in "email.header" -
  by Batuhan Taskaya

* bpo-36969: PDB command "args" now  display positional only
  arguments. Patch contributed by Rémi Lapeyre.

* bpo-36969: PDB command "args" now  display keyword only arguments.
  Patch contributed by Rémi Lapeyre.

* bpo-36983: Add missing names to "typing.__all__": "ChainMap",
  "ForwardRef", "OrderedDict" - by Anthony Sottile.

* bpo-36972: Add SupportsIndex protocol to the typing module to allow
  type checking to detect classes that can be passed to "hex()",
  "oct()" and "bin()".

* bpo-32972: Implement "unittest.IsolatedAsyncioTestCase" to help
  testing asyncio-based code.

* bpo-36952: "fileinput.input()" and "fileinput.FileInput" **bufsize**
  argument has been removed (was deprecated and ignored since Python
  3.6), and as a result the **mode** and **openhook** arguments have
  been made keyword-only.

* bpo-36952: Starting with Python 3.3, importing ABCs from
  "collections" is deprecated, and import should be done from
  "collections.abc". Still being able to import from "collections" was
  marked for removal in 3.8, but has been delayed to 3.9;
  documentation and "DeprecationWarning" clarified.

* bpo-36949: Implement __repr__ for WeakSet objects.

* bpo-36948: Fix "NameError" in "urllib.request.URLopener.retrieve()".
  Patch by Karthikeyan Singaravelan.

* bpo-33524: Fix the folding of email header when the max_line_length
  is 0 or None and the header contains non-ascii characters.
  Contributed by Licht Takeuchi (@Licht-T).

* bpo-24564: "shutil.copystat()" now ignores "errno.EINVAL" on
  "os.setxattr()" which may occur when copying files on filesystems
  without extended attributes support.

  Original patch by Giampaolo Rodola, updated by Ying Wang.

* bpo-36888: Python child processes can now access the status of their
  parent process using multiprocessing.process.parent_process

* bpo-36921: Deprecate "@coroutine" for sake of "async def".

* bpo-25652: Fix bug in "__rmod__" of "UserString" - by Batuhan
  Taskaya.

* bpo-36916: Remove a message about an unhandled exception in a task
  when writer.write() is used without await and writer.drain() fails
  with an exception.

* bpo-36889: Introduce "asyncio.Stream" class that merges
  "asyncio.StreamReader" and "asyncio.StreamWriter" functionality.
  "asyncio.Stream" can work in readonly, writeonly and readwrite
  modes. Provide "asyncio.connect()", "asyncio.connect_unix()",
  "asyncio.connect_read_pipe()" and "asyncio.connect_write_pipe()"
  factories to open "asyncio.Stream" connections. Provide
  "asyncio.StreamServer" and "UnixStreamServer" to serve servers with
  asyncio.Stream API. Modify "asyncio.create_subprocess_shell()" and
  "asyncio.create_subprocess_exec()" to use "asyncio.Stream" instead
  of deprecated "StreamReader" and "StreamWriter". Deprecate
  "asyncio.StreamReader" and "asyncio.StreamWriter". Deprecate usage
  of private classes, e.g. "asyncio.FlowControlMixing" and
  "asyncio.StreamReaderProtocol" outside of asyncio package.

* bpo-36845: Added validation of integer prefixes to the construction
  of IP networks and interfaces in the ipaddress module.

* bpo-23378: Add an extend action to argparser.

* bpo-36867: Fix a bug making a SharedMemoryManager instance and its
  parent process use two separate resource_tracker processes.

* bpo-23896: Adds a grammar to lib2to3.pygram that contains exec as a
  function not as statement.

* bpo-36895: The function "time.clock()" was deprecated in 3.3 in
  favor of "time.perf_counter()" and marked for removal in 3.8, it has
  removed.

* bpo-35545: Fix asyncio discarding IPv6 scopes when ensuring hostname
  resolutions internally

* bpo-36887: Add new function "math.isqrt()" to compute integer square
  roots.

* bpo-34632: Introduce the "importlib.metadata" module with
  (provisional) support for reading metadata from third-party
  packages.

* bpo-36878: When using "type_comments=True" in "ast.parse", treat "#
  type: ignore" followed by a non-alphanumeric character and then
  arbitrary text as a type ignore, instead of requiring nothing but
  whitespace or another comment. This is to permit formations such as
  "# type: ignore[E1000]".

* bpo-36778: "cp65001" encoding (Windows code page 65001) becomes an
  alias to "utf_8" encoding.

* bpo-36867: The multiprocessing.resource_tracker replaces the
  multiprocessing.semaphore_tracker module. Other than semaphores,
  resource_tracker also tracks shared_memory segments.

* bpo-30262: The "Cache" and "Statement" objects of the "sqlite3"
  module are not exposed to the user.  Patch by Aviv Palivoda.

* bpo-24538: In "shutil.copystat()", first copy extended file
  attributes and then file permissions, since extended attributes can
  only be set on the destination while it is still writeable.

* bpo-36829: Add new "sys.unraisablehook()" function which can be
  overridden to control how "unraisable exceptions" are handled. It is
  called when an exception has occurred but there is no way for Python
  to handle it. For example, when a destructor raises an exception or
  during garbage collection ("gc.collect()").

* bpo-36832: Introducing "zipfile.Path", a pathlib-compatible wrapper
  for traversing zip files.

* bpo-36814: Fix an issue where os.posix_spawnp() would incorrectly
  raise a TypeError when file_actions is None.

* bpo-33110: Handle exceptions raised by functions added by
  concurrent.futures add_done_callback correctly when the Future has
  already completed.

* bpo-26903: Limit "max_workers" in "ProcessPoolExecutor" to 61 to
  work around a WaitForMultipleObjects limitation.

* bpo-36813: Fix "QueueListener" to call "queue.task_done()" upon
  stopping. Patch by Bar Harel.

* bpo-36806: Forbid creation of asyncio stream objects like
  StreamReader, StreamWriter, Process, and their protocols outside of
  asyncio package.

* bpo-36802: Provide both sync and async calls for
  StreamWriter.write() and StreamWriter.close()

* bpo-36801: Properly handle SSL connection closing in asyncio
  StreamWriter.drain() call.

* bpo-36785: Implement PEP 574 (pickle protocol 5 with out-of-band
  buffers).

* bpo-36772: functools.lru_cache() can now be used as a straight
  decorator in addition to its existing usage as a function that
  returns a decorator.

* bpo-6584: Add a "BadGzipFile" exception to the "gzip" module.

* bpo-36748: Optimized write buffering in C implementation of
  "TextIOWrapper". Writing ASCII string to "TextIOWrapper" with ascii,
  latin1, or utf-8 encoding is about 20% faster.  Patch by Inada
  Naoki.

* bpo-8138: Don't mark "wsgiref.simple_server.SimpleServer" as multi-
  threaded since "wsgiref.simple_server.WSGIServer" is single-
  threaded.

* bpo-22640: "py_compile.compile()" now supports silent mode. Patch by
  Joannah Nanjekye

* bpo-29183: Fix double exceptions in "wsgiref.handlers.BaseHandler"
  by calling its "close()" method only when no exception is raised.

* bpo-36548: Improved the repr of regular expression flags.

* bpo-36542: The signature of Python functions can now be overridden
  by specifying the "__text_signature__" attribute.

* bpo-36533: Reinitialize logging.Handler locks in forked child
  processes instead of attempting to acquire them all in the parent
  before forking only to be released in the child process.  The
  acquire/release pattern was leading to deadlocks in code that has
  implemented any form of chained logging handlers that depend upon
  one another as the lock acquisition order cannot be guaranteed.

* bpo-35252: Throw a TypeError instead of an AssertionError when using
  an invalid type annotation with singledispatch.

* bpo-35900: Allow reduction methods to return a 6-item tuple where
  the 6th item specifies a custom state-setting method that's called
  instead of the regular "__setstate__" method.

* bpo-35900: enable custom reduction callback registration for
  functions and classes in _pickle.c, using the new Pickler's
  attribute "reducer_override"

* bpo-36368: Fix a bug crashing SharedMemoryManager instances in
  interactive sessions after a ctrl-c (KeyboardInterrupt) was sent

* bpo-31904: Fix mmap fail for VxWorks

* bpo-27497: "csv.DictWriter.writeheader()" now returns the return
  value of the underlying "csv.Writer.writerow()" method. Patch
  contributed by Ashish Nitin Patil.

* bpo-36239: Parsing .mo files now ignores comments starting and
  ending with #-#-#-#-#.

* bpo-26707: Enable plistlib to read and write binary plist files that
  were created as a KeyedArchive file. Specifically, this allows the
  plistlib to process 0x80 tokens as UID objects.

* bpo-31904: Add posix module support for VxWorks.

* bpo-35125: Asyncio: Remove inner callback on outer cancellation in
  shield

* bpo-35721: Fix "asyncio.SelectorEventLoop.subprocess_exec()" leaks
  file descriptors if "Popen" fails and called with
  "stdin=subprocess.PIPE". Patch by Niklas Fiekas.

* bpo-31855: "unittest.mock.mock_open()" results now respects the
  argument of read([size]). Patch contributed by Rémi Lapeyre.

* bpo-35431: Implement "math.comb()" that returns binomial
  coefficient, that computes the number of ways to choose k items from
  n items without repetition and without order. Patch by Yash Aggarwal
  and Keller Fuchs.

* bpo-26660: Fixed permission errors in "TemporaryDirectory" clean up.
  Previously "TemporaryDirectory.cleanup()" failed when non-writeable
  or non-searchable files or directories were created inside a
  temporary directory.

* bpo-34271: Add debugging helpers to ssl module. It's now possible to
  dump key material and to trace TLS protocol. The default and stdlib
  contexts also support SSLKEYLOGFILE env var.

* bpo-26467: Added AsyncMock to support using unittest to mock asyncio
  coroutines. Patch by Lisa Roach.

* bpo-33569: dataclasses.InitVar: Exposes the type used to create the
  init var.

* bpo-34424: Fix serialization of messages containing encoded strings
  when the policy.linesep is set to a multi-character string. Patch by
  Jens Troeger.

* bpo-34303: Performance of "functools.reduce()" is slightly improved.
  Patch by Sergey Fedoseev.

* bpo-33361: Fix a bug in "codecs.StreamRecoder" where seeking might
  leave old data in a buffer and break subsequent read calls. Patch by
  Ammar Askar.

* bpo-22454: The "shlex" module now exposes "shlex.join()", the
  inverse of "shlex.split()". Patch by Bo Bayles.

* bpo-31922: "asyncio.AbstractEventLoop.create_datagram_endpoint()":
  Do not connect UDP socket when broadcast is allowed. This allows to
  receive replies after a UDP broadcast.

* bpo-24882: Change ThreadPoolExecutor to use existing idle threads
  before spinning up new ones.

* bpo-31961: Added support for bytes and path-like objects in
  "subprocess.Popen()" on Windows.  The *args* parameter now accepts a
  *path-like object* if *shell* is "False" and a sequence containing
  bytes and path-like objects. The *executable* parameter now accepts
  a bytes and *path-like object*. The *cwd* parameter now accepts a
  bytes object. Based on patch by Anders Lorentsen.

* bpo-33123: "pathlib.Path.unlink" now accepts a *missing_ok*
  parameter to avoid a "FileNotFoundError" from being raised. Patch by
  Robert Buchholz.

* bpo-32941: Allow "mmap.mmap" objects to access the madvise() system
  call (through "mmap.mmap.madvise()").

* bpo-22102: Added support for ZIP files with disks set to 0. Such
  files are commonly created by builtin tools on Windows when use
  ZIP64 extension. Patch by Francisco Facioni.

* bpo-32515: trace.py can now run modules via python3 -m trace -t
  --module module_name

* bpo-32299: Changed "unittest.mock.patch.dict()" to return the
  patched dictionary when used as context manager. Patch by Vadim
  Tsander.

* bpo-27141: Added a "__copy__()" to "collections.UserList" and
  "collections.UserDict" in order to correctly implement shallow
  copying of the objects. Patch by Bar Harel.

* bpo-31829: "\r", "\0" and "\x1a" (end-of-file on Windows) are now
  escaped in protocol 0 pickles of Unicode strings. This allows to
  load them without loss from files open in text mode in Python 2.

* bpo-23395: "_thread.interrupt_main()" now avoids setting the Python
  error status if the "SIGINT" signal is ignored or not handled by
  Python.


文档
----

* bpo-36896: Clarify that some types have unstable constructor
  signature between Python versions.

* bpo-36686: Improve documentation of the stdin, stdout, and stderr
  arguments of the "asyncio.subprocess_exec" function to specify which
  values are supported. Also mention that decoding as text is not
  supported.

  Add a few tests to verify that the various values passed to the std*
  arguments actually work.

* bpo-36984: Improve version added references in "typing" module - by
  Anthony Sottile.

* bpo-36868: What's new now mentions
  SSLContext.hostname_checks_common_name instead of
  SSLContext.host_flags.

* bpo-35924: Add a note to the "curses.addstr()" documentation to warn
  that multiline strings can cause segfaults because of an ncurses
  bug.

* bpo-36783: Added C API Documentation for Time_FromTimeAndFold and
  PyDateTime_FromDateAndTimeAndFold as per PEP 495. Patch by Edison
  Abahurire.

* bpo-36797: More of the legacy distutils documentation has been
  either pruned, or else more clearly marked as being retained solely
  until the setuptools documentation covers it independently.

* bpo-22865: Add detail to the documentation on the "pty.spawn"
  function.

* bpo-35397: Remove deprecation and document urllib.parse.unwrap().
  Patch contributed by Rémi Lapeyre.

* bpo-32995: Added the context variable in glossary.

* bpo-33519: Clarify that "copy()" is not part of the
  "MutableSequence" ABC.

* bpo-33482: Make "codecs.StreamRecoder.writelines" take a list of
  bytes.

* bpo-25735: Added documentation for func factorial to indicate that
  returns integer values

* bpo-20285: Expand object.__doc__ (docstring) to make it clearer.
  Modify pydoc.py so that help(object) lists object methods (for other
  classes, help omits methods of the object base class.)


测试
----

* bpo-37069: Modify test_coroutines, test_cprofile, test_generators,
  test_raise, test_ssl and test_yield_from to use
  "test.support.catch_unraisable_exception()" rather than
  "test.support.captured_stderr()".

* bpo-37098: Fix test_memfd_create on older Linux Kernels.

* bpo-37081: 使用OpenSSL 1.1.1c进行测试

* bpo-36829: Add "test.support.catch_unraisable_exception()": context
  manager catching unraisable exception using "sys.unraisablehook()".

* bpo-36915: The main regrtest process now always removes all
  temporary directories of worker processes even if they crash or if
  they are killed on KeyboardInterrupt (CTRL+c).

* bpo-36719: "python3 -m test -jN ..." now continues the execution of
  next tests when a worker process crash (CHILD_ERROR state).
  Previously, the test suite stopped immediately. Use --failfast to
  stop at the first error.

* bpo-36816: Update Lib/test/selfsigned_pythontestdotnet.pem to match
  self-signed.pythontest.net's new TLS certificate.

* bpo-35925: Skip httplib and nntplib networking tests when they would
  otherwise fail due to a modern OS or distro with a default OpenSSL
  policy of rejecting connections to servers with weak certificates.

* bpo-36782: Add tests for several C API functions in the "datetime"
  module. Patch by Edison Abahurire.

* bpo-36342: Fix test_multiprocessing in test_venv if platform lacks
  functioning sem_open.


构建
----

* bpo-36721: To embed Python into an application, a new "--embed"
  option must be passed to "python3-config --libs --embed" to get
  "-lpython3.8" (link the application to libpython). To support both
  3.8 and older, try "python3-config --libs --embed" first and
  fallback to "python3-config --libs" (without "--embed") if the
  previous command fails.

  增加一个 pkg-config "python-3.8-embed" 模块用来将 Python 嵌入到一个
  应用中: "pkg-config python-3.8-embed --libs" 包含 "-lpython3.8"。 要
  同时支持 3.8 和旧版本，请先尝试 "pkg-config python-X.Y-embed --libs"
  并在此命令失败时回退到 "pkg-config python-X.Y --libs" (即不带 "--
  embed") （请将 "X.Y" 替换为 Python 版本号）。

  On the other hand, "pkg-config python3.8 --libs" no longer contains
  "-lpython3.8". C extensions must not be linked to libpython (except
  on Android, case handled by the script); this change is backward
  incompatible on purpose.

* bpo-36786: "make install" now runs compileall in parallel.


Windows
-------

* bpo-36965: include of STATUS_CONTROL_C_EXIT without depending on MSC
  compiler

* bpo-35926: 在Windows安装程序中将OpenSSL更新为1.1.1b

* bpo-29883: Add Windows support for UDP transports for the Proactor
  Event Loop. Patch by Adam Meily.

* bpo-33407: The "Py_DEPRECATED()" macro has been implemented for
  MSVC.


macOS
-----

* bpo-36231: Support building Python on macOS without /usr/include
  installed. As of macOS 10.14, system header files are only available
  within an SDK provided by either the Command Line Tools or the Xcode
  app.


IDLE
----

* bpo-35610: Replace now redundant .context_use_ps1 with
  .prompt_last_line. This finishes change started in bpo-31858.

* bpo-37038: Make idlelib.run runnable; add test clause.

* bpo-36958: Print any argument other than None or int passed to
  SystemExit or sys.exit().

* bpo-36807: When saving a file, call os.fsync() so bits are flushed
  to e.g. USB drive.

* bpo-32411: In browser.py, remove extraneous sorting by line number
  since dictionary was created in line number order.


工具/示例
---------

* bpo-37053: Handle strings like u"bar" correctly in
  Tools/parser/unparse.py. Patch by Chih-Hsuan Yen.


C API
-----

* bpo-36763: Implement the **PEP 587** "Python Initialization
  Configuration".

* bpo-36379: Fix crashes when attempting to use the *modulo* parameter
  when "__ipow__" is implemented in C.

* bpo-37107: Update "PyObject_CallMethodObjArgs()" and
  "_PyObject_CallMethodIdObjArgs" to use "_PyObject_GetMethod" to
  avoid creating a bound method object in many cases. Patch by Michael
  J. Sullivan.

* bpo-36974: Implement **PEP 590**: Vectorcall: a fast calling
  protocol for CPython. This is a new protocol to optimize calls of
  custom callable objects.

* bpo-36763: "Py_Main()" now returns the exitcode rather than calling
  "Py_Exit(exitcode)" when calling "PyErr_Print()" if the current
  exception type is "SystemExit".

* bpo-36922: Add new type flag "Py_TPFLAGS_METHOD_DESCRIPTOR" for
  objects behaving like unbound methods. These are objects supporting
  the optimization given by the "LOAD_METHOD"/"CALL_METHOD" opcodes.
  See PEP 590.

* bpo-36728: The "PyEval_ReInitThreads()" function has been removed
  from the C API. It should not be called explicitly: use
  "PyOS_AfterFork_Child()" instead.


Python 3.8.0 alpha 4
====================

*发布日期: 2019-05-06*


安全
----

* bpo-36742: 于函数 urlsplit() 中修复了对于预规格化字符的不当处理过程
  。

* bpo-30458: Address CVE-2019-9740 by disallowing URL paths with
  embedded whitespace or control characters through into the
  underlying http client request.  Such potentially malicious header
  injection URLs now cause an http.client.InvalidURL exception to be
  raised.

* bpo-35755: "shutil.which()" now uses "os.confstr("CS_PATH")" if
  available and if the "PATH" environment variable is not set. Remove
  also the current directory from "posixpath.defpath". On Unix,
  "shutil.which()" and the "subprocess" module no longer search the
  executable in the current directory if the "PATH" environment
  variable is not set.


核心与内置
----------

* bpo-36722: In debug build, import now also looks for C extensions
  compiled in release mode and for C extensions compiled in the stable
  ABI.

* bpo-32849: Fix Python Initialization code on FreeBSD to detect
  properly when stdin file descriptor (fd 0) is invalid.

* bpo-36623: Remove parser headers and related function declarations
  that lack implementations after the removal of pgen.

* bpo-20180: "dict.pop()" is now up to 33% faster thanks to Argument
  Clinic. Patch by Inada Naoki.

* bpo-36611: Debug memory allocators: disable serialno field by
  default from debug hooks on Python memory allocators to reduce the
  memory footprint by 5%. Enable "tracemalloc" to get the traceback
  where a memory block has been allocated when a fatal memory error is
  logged to decide where to put a breakpoint. Compile Python with
  "PYMEM_DEBUG_SERIALNO" defined to get back the field.

* bpo-36588: On AIX, "sys.platform" doesn't contain the major version
  anymore. Always return "'aix'", instead of "'aix3'" .. "'aix7'".
  Since older Python versions include the version number, it is
  recommended to always use "sys.platform.startswith('aix')".
  Contributed by M. Felt.

* bpo-36549: Change str.capitalize to use titlecase for the first
  character instead of uppercase.

* bpo-36540: Implement **PEP 570** (Python positional-only
  parameters). Patch by Pablo Galindo.

* bpo-36475: "PyEval_AcquireLock()" and "PyEval_AcquireThread()" now
  terminate the current thread if called while the interpreter is
  finalizing, making them consistent with "PyEval_RestoreThread()",
  "Py_END_ALLOW_THREADS()", and "PyGILState_Ensure()".

* bpo-36504: 在 _ctypes.c's "PyCArrayType_new()" 中修复了“有符号整数”
  类型的溢出。

* bpo-20844: 修复了含有经编码的 cookie 和换行符的脚本位于 Windows 平台
  可能运行失败的问题。

* bpo-24214: 修复了UTF-8增量解码器对surrogatepass的错误回调方法的支持

* bpo-36452: Changing "dict" keys during iteration of the dict itself,
  "keys()", "values()", or "items()" will now be detected in certain
  corner cases where keys are deleted/added so that the number of keys
  isn't changed. A "RuntimeError" will be raised after "len(dict)"
  iterations. Contributed by Thomas Perl.

* bpo-36459: 修复了由于tokenizer.c中的 "tok_nextc()" 方法可能导致的两
  次 "PyMem_FREE()" 调用。

* bpo-36433: 修复了位于 classmethoddescr_call 的类型错误信息

* bpo-36430: 修复了函数 "itertools.count()" 中的潜在引用对象泄漏。

* bpo-36440: Include node names in "ParserError" messages, instead of
  numeric IDs. Patch by A. Skrobov.

* bpo-36143: Regenerate "keyword" from the Grammar and Tokens file
  using pgen. Patch by Pablo Galindo.

* bpo-18372: Add missing "PyObject_GC_Track()" calls in the "pickle"
  module. Patch by Zackery Spytz.


库
--

* bpo-35952: Fix pythoninfo when the compiler is missing.

* bpo-28238: The ".find*()" methods of xml.etree.ElementTree can now
  search for wildcards like "{*}tag" and "{ns}*" that match a tag in
  any namespace or all tags in a namespace.  Patch by Stefan Behnel.

* bpo-26978: "pathlib.path.link_to()" is now implemented. It creates a
  hard link pointing to a path.

* bpo-1613500: "fileinput.FileInput" now uses the input file mode to
  correctly set the output file mode (previously it was hardcoded to
  "'w'")  when "inplace=True" is passed to its constructor.

* bpo-36734: Fix compilation of "faulthandler.c" on HP-UX. Initialize
  "stack_t current_stack" to zero using "memset()".

* bpo-13611: The xml.etree.ElementTree packages gained support for
  C14N 2.0 serialisation. Patch by Stefan Behnel.

* bpo-36669: Add missing matrix multiplication operator support to
  weakref.proxy.

* bpo-36676: The XMLParser() in xml.etree.ElementTree provides
  namespace prefix context to the parser target if it defines the
  callback methods "start_ns()" and/or "end_ns()". Patch by Stefan
  Behnel.

* bpo-36673: The TreeBuilder and XMLPullParser in
  xml.etree.ElementTree gained support for parsing comments and
  processing instructions. Patch by Stefan Behnel.

* bpo-36650: The C version of functools.lru_cache() was treating calls
  with an empty "**kwargs" dictionary as being distinct from calls
  with no keywords at all. This did not result in an incorrect answer,
  but it did trigger an unexpected cache miss.

* bpo-28552: Fix "distutils.sysconfig" if "sys.executable" is "None"
  or an empty string: use "os.getcwd()" to initialize "project_base".
  Fix also the distutils build command: don't use "sys.executable" if
  it is "None" or an empty string.

* bpo-35755: "shutil.which()" and "distutils.spawn.find_executable()"
  now use "os.confstr("CS_PATH")" if available instead of
  "os.defpath", if the "PATH" environment variable is not set.
  Moreover, don't use "os.confstr("CS_PATH")" nor "os.defpath" if the
  "PATH" environment variable is set to an empty string.

* bpo-25430: improve performance of "IPNetwork.__contains__()"

* bpo-30485: Path expressions in xml.etree.ElementTree can now avoid
  explicit namespace prefixes for tags (or the "{namespace}tag"
  notation) by passing a default namespace with an empty string
  prefix.

* bpo-36613: Fix "asyncio" wait() not removing callback if exception

* bpo-36598: Fix "isinstance" check for Mock objects with spec when
  the code is executed under tracing. Patch by Karthikeyan
  Singaravelan.

* bpo-18748: In development mode ("-X" "dev") and in debug build, the
  "io.IOBase" destructor now logs "close()" exceptions. These
  exceptions are silent by default in release mode.

* bpo-36575: The "_lsprof" module now uses internal timer same to
  "time.perf_counter()" by default. "gettimeofday(2)" was used on
  Unix. New timer has better resolution on most Unix platforms and
  timings are no longer impacted by system clock updates since
  "perf_counter()" is monotonic. Patch by Inada Naoki.

* bpo-33461: "json.loads" now emits "DeprecationWarning" when
  "encoding" option is specified.  Patch by Matthias Bussonnier.

* bpo-36559: The random module now prefers the lean internal _sha512
  module over hashlib for seed(version=2) to optimize import time.

* bpo-17561: Set backlog=None as the default for socket.create_server.

* bpo-34373: Fix "time.mktime()" error handling on AIX for year before
  1970.

* bpo-36232: Improve error message when trying to open existing DBM
  database that actually doesn't exist. Patch by Marco Rougeth.

* bpo-36546: Add statistics.quantiles()

* bpo-36050: Optimized "http.client.HTTPResponse.read()" for large
  response. Patch by Inada Naoki.

* bpo-36522: If *debuglevel* is set to >0 in "http.client", print all
  values for headers with multiple values for the same header name.
  Patch by Matt Houglum.

* bpo-36492: Deprecated passing required arguments like *func* as
  keyword arguments in functions which should accept arbitrary keyword
  arguments and pass them to other function. Arbitrary keyword
  arguments (even with names "self" and "func") can now be passed to
  these functions if the required arguments are passed as positional
  arguments.

* bpo-27181: Add statistics.geometric_mean().

* bpo-30427: "os.path.normcase()" relies on "os.fspath()" to check the
  type of its argument. Redundant checks have been removed from its
  "posixpath.normcase()" and "ntpath.normcase()" implementations.
  Patch by Wolfgang Maier.

* bpo-36385: Stop rejecting IPv4 octets for being ambiguously octal.
  Leading zeros are ignored, and no longer are assumed to specify
  octal octets. Octets are always decimal numbers. Octets must still
  be no more than three digits, including leading zeroes.

* bpo-36434: Errors during writing to a ZIP file no longer prevent to
  properly close it.

* bpo-36407: Fixed wrong indentation writing for CDATA section in
  xml.dom.minidom. Patch by Vladimir Surjaninov.

* bpo-36326: inspect.getdoc() can now find docstrings for member
  objects when __slots__ is a dictionary.

* bpo-36366: Calling "stop()" on an unstarted or stopped
  "unittest.mock.patch()" object will now return "None" instead of
  raising "RuntimeError", making the method idempotent. Patch by
  Karthikeyan Singaravelan.

* bpo-36348: The "imap.IMAP4.logout()" method no longer ignores
  silently arbitrary exceptions.

* bpo-31904: Add time module support and fix test_time faiures for
  VxWorks.

* bpo-36227: Added support for keyword arguments "default_namespace"
  and "xml_declaration" in functions ElementTree.tostring() and
  ElementTree.tostringlist().

* bpo-36004: Added new alternate constructors
  "datetime.date.fromisocalendar()" and
  "datetime.datetime.fromisocalendar()", which construct date objects
  from ISO year, week number and weekday; these are the inverse of
  each class's "isocalendar" method. Patch by Paul Ganssle.

* bpo-35936: "modulefinder" no longer depends on the deprecated "imp"
  module, and the initializer for "modulefinder.ModuleFinder" now has
  immutable default arguments. Patch by Brandt Bucher.

* bpo-35376: "modulefinder" correctly handles modules that have the
  same name as a bad package. Patch by Brandt Bucher.

* bpo-17396: "modulefinder" no longer crashes when encountering syntax
  errors in followed imports. Patch by Brandt Bucher.

* bpo-35934: Added "create_server()" and "has_dualstack_ipv6()"
  convenience functions to automate the necessary tasks usually
  involved when creating a server socket, including accepting both
  IPv4 and IPv6 connections on the same socket.  (Contributed by
  Giampaolo Rodola in bpo-17561.)

* bpo-23078: Add support for "classmethod()" and "staticmethod()" to
  "unittest.mock.create_autospec()".  Initial patch by Felipe Ochoa.

* bpo-35416: Fix potential resource warnings in distutils. Patch by
  Mickaël Schoentgen.

* bpo-25451: Add transparency methods to "tkinter.PhotoImage".  Patch
  by Zackery Spytz.

* bpo-35082: Don't return deleted attributes when calling dir on a
  "unittest.mock.Mock".

* bpo-34547: "wsgiref.handlers.BaseHandler" now handles abrupt client
  connection terminations gracefully. Patch by Petter Strandmark.

* bpo-31658: "xml.sax.parse()" now supports *path-like*. Patch by
  Mickaël Schoentgen.

* bpo-34139: Remove stale unix datagram socket before binding

* bpo-33530: Implemented Happy Eyeballs in
  "asyncio.create_connection()". Added two new arguments,
  *happy_eyeballs_delay* and *interleave*, to specify Happy Eyeballs
  behavior.

* bpo-33291: Do not raise AttributeError when calling the inspect
  functions isgeneratorfunction, iscoroutinefunction,
  isasyncgenfunction on a method created from an arbitrary callable.
  Instead, return False.

* bpo-31310: Fix the multiprocessing.semaphore_tracker so it is reused
  by child processes

* bpo-31292: 为包含 "include" 指令的文件修复 "setup.py check
  --restructuredtext"。


文档
----

* bpo-36625: Remove obsolete comments from docstrings in
  fractions.Fraction

* bpo-30840: Document relative imports

* bpo-36523: Add docstring for io.IOBase.writelines().

* bpo-36425: 新增的文档翻译: 简体中文.

* bpo-36345: Avoid the duplication of code from
  "Tools/scripts/serve.py" in using the "literalinclude" directive for
  the basic wsgiref-based web server in the documentation of
  "wsgiref". Contributed by Stéphane Wirtel.

* bpo-36345: Using the code of the "Tools/scripts/serve.py" script as
  an example in the "wsgiref" documentation.  Contributed by Stéphane
  Wirtel.

* bpo-36157: Added Documention for  PyInterpreterState_Main().

* bpo-33043: Updates the docs.python.org page with the addition of a
  'Contributing to Docs' link at the end of the page (between
  'Reporting Bugs' and 'About Documentation'). Updates the 'Found a
  Bug' page with additional links and information in the Documentation
  Bugs section.

* bpo-35581: @typing.type_check_only now allows type stubs to mark
  functions and classes not available during runtime.

* bpo-33832: Add glossary entry for 'magic method'.

* bpo-32913: Added re.Match.groupdict example to regex HOWTO.


测试
----

* bpo-36719: regrtest now always detects uncollectable objects.
  Previously, the check was only enabled by "--findleaks". The check
  now also works with "-jN/--multiprocess N". "--findleaks" becomes a
  deprecated alias to "--fail-env-changed".

* bpo-36725: When using mulitprocessing mode (-jN), regrtest now
  better reports errors if a worker process fails, and it exits
  immediately on a worker thread failure or when interrupted.

* bpo-36454: Change test_time.test_monotonic() to test only the lower
  bound of elapsed time after a sleep command rather than the upper
  bound. This prevents unnecessary test failures on slow buildbots.
  Patch by Victor Stinner.

* bpo-32424: Improve test coverage for xml.etree.ElementTree. Patch by
  Gordon P. Hemsley.

* bpo-32424: Fix typo in test_cyclic_gc() test for
  xml.etree.ElementTree. Patch by Gordon P. Hemsley.

* bpo-36635: Add a new "_testinternalcapi" module to test the internal
  C API.

* bpo-36629: Fix "test_imap4_host_default_value()" of "test_imaplib":
  catch also "errno.ENETUNREACH" error.

* bpo-36611: Fix "test_sys.test_getallocatedblocks()" when
  "tracemalloc" is enabled.

* bpo-36560: Fix reference leak hunting in regrtest: compute also
  deltas (of reference count, allocated memory blocks, file descriptor
  count) during warmup, to ensure that everything is initialized
  before starting to hunt reference leaks.

* bpo-36565: Fix reference hunting ("python3 -m test -R 3:3") when
  Python has no built-in abc module.

* bpo-31904: Port test_resource to VxWorks: skip tests cases setting
  RLIMIT_FSIZE and RLIMIT_CPU.

* bpo-31904: Fix test_tabnanny on VxWorks: adjust ENOENT error
  message.

* bpo-36436: Fix "_testcapi.pymem_buffer_overflow()": handle memory
  allocation failure.

* bpo-31904: Fix test_utf8_mode on VxWorks: Python always use UTF-8 on
  VxWorks.

* bpo-36341: Fix tests that may fail with PermissionError upon calling
  bind() on AF_UNIX sockets.


构建
----

* bpo-36747: Remove the stale scriptsinstall Makefile target.

* bpo-21536: On Unix, C extensions are no longer linked to libpython
  except on Android and Cygwin.

  通过共享库的 Python 构建的 C 扩展现在可以被静态链接的 Python 加载了
  。

  When Python is embedded, "libpython" must not be loaded with
  "RTLD_LOCAL", but "RTLD_GLOBAL" instead. Previously, using
  "RTLD_LOCAL", it was already not possible to load C extensions which
  were not linked to "libpython", such as C extensions of the standard
  library built by the "*shared*" section of "Modules/Setup".

  distutils，python-config 和 python-config.py 已被修改。

* bpo-36707: "./configure --with-pymalloc" no longer adds the "m" flag
  to SOABI (sys.implementation.cache_tag). Enabling or disabling
  pymalloc has no impact on the ABI.

* bpo-36635: Change "PyAPI_FUNC(type)", "PyAPI_DATA(type)" and
  "PyMODINIT_FUNC" macros of "pyport.h" when "Py_BUILD_CORE_MODULE" is
  defined. The "Py_BUILD_CORE_MODULE" define must be now be used to
  build a C extension as a dynamic library accessing Python internals:
  export the PyInit_xxx() function in DLL exports on Windows.

* bpo-31904: Don't build the "_crypt" extension on VxWorks.

* bpo-36618: Add "-fmax-type-align=8" to CFLAGS when clang compiler is
  detected. The pymalloc memory allocator aligns memory on 8 bytes. On
  x86-64, clang expects alignment on 16 bytes by default and so uses
  MOVAPS instruction which can lead to segmentation fault. Instruct
  clang that Python is limited to alignment on 8 bytes to use MOVUPS
  instruction instead: slower but don't trigger a SIGSEGV if the
  memory is not aligned on 16 bytes. Sadly, the flag must be added to
  "CFLAGS" and not just "CFLAGS_NODIST", since third party C
  extensions can have the same issue.

* bpo-36605: "make tags" and "make TAGS" now also parse
  "Modules/_io/*.c" and "Modules/_io/*.h".

* bpo-36465: Release builds and debug builds are now ABI compatible:
  defining the "Py_DEBUG" macro no longer implies the "Py_TRACE_REFS"
  macro, which introduces the only ABI incompatibility. The
  "Py_TRACE_REFS" macro, which adds the "sys.getobjects()" function
  and the "PYTHONDUMPREFS" environment variable, can be set using the
  new "./configure --with-trace-refs" build option.

* bpo-36577: setup.py now correctly reports missing OpenSSL headers
  and libraries again.

* bpo-36544: Fix regression introduced in bpo-36146 refactoring
  setup.py

* bpo-36508: "python-config --ldflags" no longer includes flags of the
  "LINKFORSHARED" variable. The "LINKFORSHARED" variable must only be
  used to build executables.

* bpo-36503: Remove references to "aix3" and "aix4". Patch by M. Felt.


Windows
-------

* bpo-35920: Added platform.win32_edition() and
  platform.win32_is_iot(). Added support for cross-compiling packages
  for Windows ARM32. Skip tests that are not expected to work on
  Windows IoT Core ARM32.

* bpo-36649: Remove trailing spaces for registry keys when installed
  via the Store.

* bpo-34144: Fixed activate.bat to correctly update codepage when
  chcp.com returns dots in output. Patch by Lorenz Mende.

* bpo-36509: Added preset-iot layout for Windows IoT ARM containers.
  This layout doesn't contain UI components like tkinter or IDLE. It
  also doesn't contain files to support on-target builds since Windows
  ARM32 builds must be cross-compiled when using MSVC.

* bpo-35941: enum_certificates function of the ssl module now returns
  certificates from all available certificate stores inside windows in
  a query instead of returning only certificates from the system wide
  certificate store. This includes certificates from these certificate
  stores: local machine, local machine enterprise, local machine group
  policy, current user, current user group policy, services, users.
  ssl.enum_crls() function is changed in the same way to return all
  certificate revocation lists inside the windows certificate
  revocation list stores.

* bpo-36441: Fixes creating a venv when debug binaries are installed.

* bpo-36085: Enable better DLL resolution on Windows by using safe DLL
  search paths and adding "os.add_dll_directory()".

* bpo-36010: Add the venv standard library module to the nuget
  distribution for Windows.

* bpo-29515: Add the following socket module constants on Windows:
  IPPROTO_AH IPPROTO_CBT IPPROTO_DSTOPTS IPPROTO_EGP IPPROTO_ESP
  IPPROTO_FRAGMENT IPPROTO_GGP IPPROTO_HOPOPTS IPPROTO_ICLFXBM
  IPPROTO_ICMPV6 IPPROTO_IDP IPPROTO_IGMP IPPROTO_IGP IPPROTO_IPV4
  IPPROTO_IPV6 IPPROTO_L2TP IPPROTO_MAX IPPROTO_ND IPPROTO_NONE
  IPPROTO_PGM IPPROTO_PIM IPPROTO_PUP IPPROTO_RDP IPPROTO_ROUTING
  IPPROTO_SCTP IPPROTO_ST

* bpo-35947: Added current version of libffi to cpython-source-deps.
  Change _ctypes to use current version of libffi on Windows.

* bpo-34060: Report system load when running test suite on Windows.
  Patch by Ammar Askar. Based on prior work by Jeremy Kloth.

* bpo-31512: With the Windows 10 Creators Update, non-elevated users
  can now create symlinks as long as the computer has Developer Mode
  enabled.


macOS
-----

* bpo-34602: Avoid failures setting macOS stack resource limit with
  resource.setrlimit. This reverts an earlier fix for bpo-18075 which
  forced a non-default stack size when building the interpreter
  executable on macOS.


IDLE
----

* bpo-36429: Fix starting IDLE with pyshell. Add idlelib.pyshell alias
  at top; remove pyshell alias at bottom. Remove obsolete
  __name__=='__main__' command.


工具/示例
---------

* bpo-14546: Fix the argument handling in Tools/scripts/lll.py.


C API
-----

* bpo-36763: Fix memory leak in "Py_SetStandardStreamEncoding()":
  release memory if the function is called twice.

* bpo-36641: "PyDoc_VAR(name)" and "PyDoc_STRVAR(name,str)" now create
  "static const char name[]" instead of "static char name[]".  Patch
  by Inada Naoki.

* bpo-36389: Change the value of "CLEANBYTE", "DEADDYTE" and
  "FORBIDDENBYTE" internal constants used by debug hooks on Python
  memory allocators ("PyMem_SetupDebugHooks()" function). Byte
  patterns "0xCB", "0xDB" and "0xFB" have been replaced with "0xCD",
  "0xDD" and "0xFD" to use the same values than Windows CRT debug
  "malloc()" and "free()".

* bpo-36443: Since Python 3.7.0, calling "Py_DecodeLocale()" before
  "Py_Initialize()" produces mojibake if the "LC_CTYPE" locale is
  coerced and/or if the UTF-8 Mode is enabled by the user
  configuration. The LC_CTYPE coercion and UTF-8 Mode are now disabled
  by default to fix the mojibake issue. They must now be enabled
  explicitly (opt-in) using the new "_Py_PreInitialize()" API with
  "_PyPreConfig".

* bpo-36025: Fixed an accidental change to the datetime C API where
  the arguments to the "PyDate_FromTimestamp()" function were
  incorrectly interpreted as a single timestamp rather than an
  arguments tuple, which causes existing code to start raising
  "TypeError". The backwards-incompatible change was only present in
  alpha releases of Python 3.8. Patch by Paul Ganssle.

* bpo-35810: Modify "PyObject_Init" to correctly increase the refcount
  of heap- allocated Type objects. Also fix the refcounts of the heap-
  allocated types that were either doing this manually or not
  decreasing the type's refcount in tp_dealloc


Python 3.8.0 alpha 3
====================

*发布日期： 2019-03-25*


安全
----

* bpo-36216: Changes urlsplit() to raise ValueError when the URL
  contains characters that decompose under IDNA encoding (NFKC-
  normalization) into characters that affect how the URL is parsed.

* bpo-35121: Don't send cookies of domain A without Domain attribute
  to domain B when domain A is a suffix match of domain B while using
  a cookiejar with "http.cookiejar.DefaultCookiePolicy" policy. Patch
  by Karthikeyan Singaravelan.


核心与内置
----------

* bpo-36421: Fix a possible double decref in _ctypes.c's
  "PyCArrayType_new()".

* bpo-36412: Fix a possible crash when creating a new dictionary.

* bpo-36398: Fix a possible crash in "structseq_repr()".

* bpo-36256: Fix bug in parsermodule when parsing a state in a DFA
  that has two or more arcs with labels of the same type. Patch by
  Pablo Galindo.

* bpo-36365: repr(structseq) is no longer limited to 512 bytes.

* bpo-36374: Fix a possible null pointer dereference in
  "merge_consts_recursive()". Patch by Zackery Spytz.

* bpo-36236: 在 Python 初始化时，如果当前目录被移除，则它将不再会被添
  加到 "sys.path" 中。

* bpo-36352: Python initialization now fails with an error, rather
  than silently truncating paths, if a path is too long.

* bpo-36301: Python initialization now fails if decoding
  "pybuilddir.txt" configuration file fails at startup.

* bpo-36333: Fix leak in _PyRuntimeState_Fini. Contributed by Stéphane
  Wirtel.

* bpo-36332: The builtin "compile()" can now handle AST objects that
  contain assignment expressions. Patch by Pablo Galindo.

* bpo-36282: Improved error message for too much positional arguments
  in some builtin functions.

* bpo-30040: New empty dict uses fewer memory for now.  It used more
  memory than empty dict created by "dict.clear()".  And empty dict
  creation and deletion is about 2x faster.  Patch by Inada Naoki.

* bpo-36262: 修复了在 "float(str)", "complex(str)", "pickle.load()",
  "marshal.load()" 等所用的函数 "_Py_dg_strtod()" 中进行从字符串到浮点
  数的转换时偶有发生的一个内存泄漏问题。

* bpo-36252: Update Unicode databases to version 12.0.0.

* bpo-36218: Fix a segfault occurring when sorting a list of
  heterogeneous values. Patch contributed by Rémi Lapeyre and Elliot
  Gorokhovsky.

* bpo-36188: Cleaned up left-over vestiges of Python 2 unbound method
  handling in method objects and documentation. Patch by Martijn
  Pieters

* bpo-36124: Add a new interpreter-specific dict and expose it in the
  C-API via PyInterpreterState_GetDict().  This parallels
  PyThreadState_GetDict(). However, extension modules should continue
  using PyModule_GetState() for their own internal per-interpreter
  state.

* bpo-35975: Add a "feature_version" flag to "ast.parse()"
  (documented) and "compile()" (hidden) that allows tweaking the
  parser to support older versions of the grammar. In particular, if
  "feature_version" is 5 or 6, the hacks for the "async" and "await"
  keyword from PEP 492 are reinstated. (For 7 or higher, these are
  unconditionally treated as keywords, but they are still special
  tokens rather than "NAME" tokens that the parser driver recognizes.)

* bpo-31904: Use UTF-8 as the system encoding on VxWorks.

* bpo-36048: The "__index__()" special method will be used instead of
  "__int__()" for implicit conversion of Python numbers to C integers.
  Using the "__int__()" method in implicit conversions has been
  deprecated.

* bpo-35808: Retire pgen and use a modified version of pgen2 to
  generate the parser. Patch by Pablo Galindo.


库
--

* bpo-36401: The class documentation created by pydoc now has a
  separate section for readonly properties.

* bpo-36320: The typing.NamedTuple() class has deprecated the
  _field_types attribute in favor of the __annotations__ attribute
  which carried the same information. Also, both attributes were
  converted from OrderedDict to a regular dict.

* bpo-34745: Fix "asyncio" ssl memory issues caused by circular
  references

* bpo-36324: Add method to statistics.NormalDist for computing the
  inverse cumulative normal distribution.

* bpo-36321: collections.namedtuple() misspelled the name of an
  attribute. To be consistent with typing.NamedTuple, the attribute
  name should have been "_field_defaults" instead of
  "_fields_defaults".  For backwards compatibility, both spellings are
  now created.  The misspelled version may be removed in the future.

* bpo-36297: "unicode_internal" codec is removed.  It was deprecated
  since Python 3.3. Patch by Inada Naoki.

* bpo-36298: Raise ModuleNotFoundError in pyclbr when a module can't
  be found. Thanks to 'mental' for the bug report.

* bpo-36268: Switch the default format used for writing tars with
  mod:"tarfile" to the modern POSIX.1-2001 pax standard, from the
  vendor-specific GNU. Contributed by C.A.M. Gerlach.

* bpo-36285: Fix integer overflows in the array module. Patch by
  Stephan Hohe.

* bpo-31904: Add _signal module support for VxWorks.

* bpo-36272: "logging" does not silently ignore RecursionError
  anymore. Patch contributed by Rémi Lapeyre.

* bpo-36280: Add a kind field to ast.Constant. It is 'u' if the
  literal has a 'u' prefix (i.e. a Python 2 style unicode literal),
  else None.

* bpo-35931: The "pdb" "debug" command now gracefully handles all
  exceptions.

* bpo-36251: Fix format strings used for stderrprinter and re.Match
  reprs. Patch by Stephan Hohe.

* bpo-36235: Fix "CFLAGS" in "customize_compiler()" of
  "distutils.sysconfig": when the "CFLAGS" environment variable is
  defined, don't override "CFLAGS" variable with the "OPT" variable
  anymore. Initial patch written by David Malcolm.

* bpo-35807: Update ensurepip to install pip 19.0.3 and setuptools
  40.8.0.

* bpo-36139: Release GIL when closing "mmap" objects.

* bpo-36179: Fix two unlikely reference leaks in _hashopenssl. The
  leaks only occur in out-of-memory cases.

* bpo-36169: Add overlap() method to statistics.NormalDist.  Computes
  the overlapping coefficient for two normal distributions.

* bpo-36103: Default buffer size used by "shutil.copyfileobj()" is
  changed from 16 KiB to 64 KiB on non-Windows platform to reduce
  system call overhead. Contributed by Inada Naoki.

* bpo-36130: Fix "pdb" with "skip=..." when stepping into a frame
  without a "__name__" global.  Patch by Anthony Sottile.

* bpo-35652: shutil.copytree(copy_function=...) erroneously pass
  DirEntry instead of a path string.

* bpo-35178: Ensure custom "warnings.formatwarning()" function can
  receive "line" as positional argument. Based on patch by Tashrif
  Billah.

* bpo-36106: Resolve potential name clash with libm's sinpi(). Patch
  by Dmitrii Pasechnik.

* bpo-36091: Clean up reference to async generator in Lib/types. Patch
  by Henry Chen.

* bpo-36043: "FileCookieJar" supports *path-like object*. Contributed
  by Stéphane Wirtel

* bpo-35899: Enum has been fixed to correctly handle empty strings and
  strings with non-Latin characters (ie. 'α', 'א') without crashing.
  Original patch contributed by Maxwell. Assisted by Stéphane Wirtel.

* bpo-21269: Add "args" and "kwargs" properties to mock call objects.
  Contributed by Kumar Akshay.

* bpo-30670: "pprint.pp" has been added to pretty-print objects with
  dictionary keys being sorted with their insertion order by default.
  Parameter *sort_dicts* has been added to "pprint.pprint",
  "pprint.pformat" and "pprint.PrettyPrinter". Contributed by Rémi
  Lapeyre.

* bpo-35843: Implement "__getitem__" for "_NamespacePath".  Patch by
  Anthony Sottile.

* bpo-35802: Clean up code which checked presence of "os.stat" /
  "os.lstat" / "os.chmod" which are always present.  Patch by Anthony
  Sottile.

* bpo-35715: Librates the return value of a ProcessPoolExecutor
  _process_worker after it's no longer needed to free memory

* bpo-35493: Use "multiprocessing.connection.wait()" instead of
  polling each 0.2 seconds for worker updates in
  "multiprocessing.Pool". Patch by Pablo Galindo.

* bpo-35661: Store the venv prompt in pyvenv.cfg.

* bpo-35121: Don't set cookie for a request when the request path is a
  prefix match of the cookie's path attribute but doesn't end with
  "/". Patch by Karthikeyan Singaravelan.

* bpo-21478: Calls to a child function created with
  "unittest.mock.create_autospec()" should propagate to the parent.
  Patch by Karthikeyan Singaravelan.

* bpo-35198: Fix C++ extension compilation on AIX


文档
----

* bpo-36329: Declare the path of the Python binary for the usage of
  "Tools/scripts/serve.py" when executing "make -C Doc/ serve".
  Contributed by Stéphane Wirtel

* bpo-36138: Improve documentation about converting datetime.timedelta
  to scalars.

* bpo-21314: A new entry was added to the Core Language Section of the
  Programming FAQ, which explaines the usage of slash(/) in the
  signature of a function. Patch by Lysandros Nikolaou


测试
----

* bpo-36234: test_posix.PosixUidGidTests: add tests for invalid
  uid/gid type (str). Initial patch written by David Malcolm.

* bpo-29571: Fix "test_re.test_locale_flag()":  use
  "locale.getpreferredencoding()" rather than "locale.getlocale()" to
  get the locale encoding. With some locales, "locale.getlocale()"
  returns the wrong encoding.

* bpo-36123: Fix race condition in test_socket.


构建
----

* bpo-36356: Fix leaks that led to build failure when configured with
  address sanitizer.

* bpo-36146: Add "TEST_EXTENSIONS" constant to "setup.py" to allow to
  not build test extensions like "_testcapi".

* bpo-36146: Fix setup.py on macOS: only add "/usr/include/ffi" to
  include directories of _ctypes, not for all extensions.

* bpo-31904: Enable build system to cross-build for VxWorks RTOS.


Windows
-------

* bpo-36312: Fixed decoders for the following code pages: 50220,
  50221, 50222, 50225, 50227, 50229, 57002 through 57011, 65000 and
  42.

* bpo-36264: Don't honor POSIX "HOME" in "os.path.expanduser" on
  windows.  Patch by Anthony Sottile.

* bpo-24643: Fix name collisions due to "#define timezone _timezone"
  in PC/pyconfig.h.


IDLE
----

* bpo-36405: Use dict unpacking in idlelib.

* bpo-36396: Remove fgBg param of idlelib.config.GetHighlight(). This
  param was only used twice and changed the return type.

* bpo-36176: 修复 IDLE 自动补全和 calltip 悬浮窗的颜色. 避免与 Linux
  暗色主题冲突 (略微加深了calltip 的背景颜色).

* bpo-23205: For the grep module, add tests for findfiles, refactor
  findfiles to be a module-level function, and refactor findfiles to
  use os.walk.

* bpo-23216: 将文档字符串添加到IDLE 的搜索模块。

* bpo-36152: Remove colorizer.ColorDelegator.close_when_done and the
  corresponding argument of .close().  In IDLE, both have always been
  None or False since 2007.

* bpo-32129: Avoid blurry IDLE application icon on macOS with Tk 8.6.
  Patch by Kevin Walzer.

* bpo-36096: Refactor class variables to instance variables in
  colorizer.

* bpo-30348: Increase test coverage of idlelib.autocomplete by 30%.
  Patch by Louie Lu


工具/示例
---------

* bpo-35132: Fix py-list and py-bt commands of python-gdb.py on gdb7.

* bpo-32217: Fix freeze script on Windows.


C API
-----

* bpo-36381: Raise "DeprecationWarning" when '#' formats are used for
  building or parsing values without "PY_SSIZE_T_CLEAN".

* bpo-36142: The whole coreconfig.h header is now excluded from
  Py_LIMITED_API. Move functions definitions into a new internal
  pycore_coreconfig.h header.


Python 3.8.0 alpha 2
====================

*发布日期: 2019-02-25*


核心与内置
----------

* bpo-36052: Raise a "SyntaxError" when assigning a value to
  "__debug__" with the Assignment Operator. Contributed by Stéphane
  Wirtel and Pablo Galindo.

* bpo-36012: Doubled the speed of class variable writes.  When a non-
  dunder attribute was updated, there was an unnecessary call to
  update slots.

* bpo-35942: The error message emitted when returning invalid types
  from "__fspath__" in interfaces that allow passing "PathLike"
  objects has been improved and now it does explain the origin of the
  error.

* bpo-36016: "gc.get_objects" can now receive an optional parameter
  indicating a generation to get objects from. Patch by Pablo Galindo.

* bpo-1054041: When the main interpreter exits due to an uncaught
  KeyboardInterrupt, the process now exits in the appropriate manner
  for its parent process to detect that a SIGINT or ^C terminated the
  process.  This allows shells and batch scripts to understand that
  the user has asked them to stop.

* bpo-35992: Fix "__class_getitem__()" not being called on a class
  with a custom non-subscriptable metaclass.

* bpo-35993: Fix a crash on fork when using subinterpreters.
  Contributed by Stéphane Wirtel

* bpo-35991: Fix a potential double free in Modules/_randommodule.c.

* bpo-35961: Fix a crash in slice_richcompare(): use strong references
  rather than stolen references for the two temporary internal tuples.

* bpo-35911: Enable the creation of cell objects by adding a
  "cell.__new__" method, and expose the type "cell" in "Lib/types.py"
  under the name CellType. Patch by Pierre Glaser.

* bpo-12822: Use monotonic clock for "pthread_cond_timedwait" when
  "pthread_condattr_setclock" and "CLOCK_MONOTONIC" are available.

* bpo-15248: The compiler emits now syntax warnings in the case when a
  comma is likely missed before tuple or list.

* bpo-35886: The implementation of PyInterpreterState has been moved
  into the internal header files (guarded by Py_BUILD_CORE).

* bpo-31506: Clarify the errors reported when "object.__new__" and
  "object.__init__" receive more than one argument. Contributed by
  Sanyam Khurana.

* bpo-35724: Signal-handling is now guaranteed to happen relative to
  the main interpreter.

* bpo-33608: We added a new internal _Py_AddPendingCall() that
  operates relative to the provided interpreter.  This allows us to
  use the existing implementation to ask another interpreter to do
  work that cannot be done in the current interpreter, like decref an
  object the other interpreter owns.  The existing Py_AddPendingCall()
  only operates relative to the main interpreter.

* bpo-33989: Fix a possible crash in "list.sort()" when sorting
  objects with "ob_type->tp_richcompare == NULL".  Patch by Zackery
  Spytz.


库
--

* bpo-35512: "unittest.mock.patch.dict()" used as a decorator with
  string target resolves the target during function call instead of
  during decorator construction. Patch by Karthikeyan Singaravelan.

* bpo-36018: Add statistics.NormalDist, a tool for creating and
  manipulating normal distributions of random variable.  Features a
  composite class that treats the mean and standard deviation of
  measurement data as single entity.

* bpo-35904: Added statistics.fmean() as a faster, floating point
  variant of the existing mean() function.

* bpo-35918: Removed broken "has_key" method from
  multiprocessing.managers.SyncManager.dict. Contributed by Rémi
  Lapeyre.

* bpo-18283: Add support for bytes to "shutil.which()".

* bpo-35960: Fix "dataclasses.field()" throwing away empty mapping
  objects passed as metadata.

* bpo-35500: Write expected and actual call parameters on separate
  lines in "unittest.mock.Mock.assert_called_with()" assertion errors.
  Contributed by Susan Su.

* bpo-35931: The "pdb" "debug" command now gracefully handles syntax
  errors.

* bpo-24209: In http.server script, rely on getaddrinfo to bind to
  preferred address based on the bind parameter. Now default bind or
  binding to a name may bind to IPv6 or dual-stack, depending on the
  environment.

* bpo-35321: Set "__spec__.origin" of  "_frozen_importlib" to frozen
  so that it matches the behavior of "_frozen_importlib_external".
  Patch by Nina Zakharenko.

* bpo-35378: Fix a reference issue inside "multiprocessing.Pool" that
  caused the pool to remain alive if it was deleted without being
  closed or terminated explicitly. A new strong reference is added to
  the pool iterators to link the lifetime of the pool to the lifetime
  of its iterators so the pool does not get destroyed if a pool
  iterator is still alive.

* bpo-34294: re module, fix wrong capturing groups in rare cases.
  "re.search()", "re.findall()", "re.sub()" and other functions that
  scan through string looking for a match, should reset capturing
  groups between two match attempts. Patch by Ma Lin.

* bpo-35615: "weakref": Fix a RuntimeError when copying a
  WeakKeyDictionary or a WeakValueDictionary, due to some keys or
  values disappearing while iterating.

* bpo-35606: Implement "math.prod()" as analogous function to "sum()"
  that returns the product of a 'start' value (default: 1) times an
  iterable of numbers. Patch by Pablo Galindo.

* bpo-32417: Performing arithmetic between "datetime.datetime"
  subclasses and "datetime.timedelta" now returns an object of the
  same type as the "datetime.datetime" subclass. As a result,
  "datetime.datetime.astimezone()" and alternate constructors like
  "datetime.datetime.now()" and "datetime.fromtimestamp()" called with
  a "tz" argument now *also* retain their subclass.

* bpo-35153: Add *headers* optional keyword-only parameter to
  "xmlrpc.client.ServerProxy", "xmlrpc.client.Transport" and
  "xmlrpc.client.SafeTransport".  Patch by Cédric Krier.

* bpo-34572: Fix C implementation of pickle.loads to use importlib's
  locking mechanisms, and thereby avoid using partially-loaded
  modules. Patch by Tim Burgess.


文档
----

* bpo-36083: Fix formatting of --check-hash-based-pycs options in the
  manpage Synopsis.

* bpo-36007: Bump minimum sphinx version to 1.8.  Patch by Anthony
  Sottile.

* bpo-22062: Update documentation and docstrings for pathlib. Original
  patch by Mike Short.


测试
----

* bpo-27313: Avoid test_ttk_guionly ComboboxTest failure with macOS
  Cocoa Tk.

* bpo-36019: Add test.support.TEST_HTTP_URL and replace references of
  http://www.example.com by this new constant. Contributed by Stéphane
  Wirtel.

* bpo-36037: Fix test_ssl for strict OpenSSL configuration like RHEL8
  strict crypto policy. Use older TLS version for minimum TLS version
  of the server SSL context if needed, to test TLS version older than
  default minimum TLS version.

* bpo-35798: Added "test.support.check_syntax_warning()".

* bpo-35505: Make test_imap4_host_default_value independent on whether
  the local IMAP server is running.

* bpo-35917: multiprocessing: provide unit tests for SyncManager and
  SharedMemoryManager classes + all the shareable types which are
  supposed to be supported by them.  (patch by Giampaolo Rodola)

* bpo-35704: Skip "test_shutil.test_unpack_archive_xztar" to prevent a
  MemoryError on 32-bit AIX when MAXDATA setting is less than
  0x20000000.

  Patch by Michael Felt (aixtools)

* bpo-34720: Assert m_state != NULL to mimic GC traversal functions
  that do not correctly handle module creation when the module state
  has not been created.


Windows
-------

* bpo-35976: Added ARM build support to Windows build files in
  PCBuild.

* bpo-35692: "pathlib" no longer raises when checking file and
  directory existence on drives that are not ready

* bpo-35872: Uses the base Python executable when invoking venv in a
  virtual environment

* bpo-35873: Prevents venv paths being inherited by child processes

* bpo-35299: Fix sysconfig detection of the source directory and
  distutils handling of pyconfig.h during PGO profiling


IDLE
----

* bpo-24310: IDLE -- 文档设置对话框字体选项卡示例。

* bpo-35833: Revise IDLE doc for control codes sent to Shell. Add a
  code example block.

* bpo-35689: Add docstrings and unittests for colorizer.py.


Python 3.8.0 alpha 1
====================

*发布日期: 2019-02-03*


安全
----

* bpo-35746: [CVE-2019-5010] Fix a NULL pointer deref in ssl module.
  The cert parser did not handle CRL distribution points with empty DP
  or URI correctly. A malicious or buggy certificate can result into
  segfault. Vulnerability (TALOS-2018-0758) reported by Colin Read and
  Nicolas Edet of Cisco.

* bpo-34812: The "-I" command line option (run Python in isolated
  mode) is now also copied by the "multiprocessing" and "distutils"
  modules when spawning child processes. Previously, only "-E" and
  "-s" options (enabled by "-I") were copied.

* bpo-34791: The xml.sax and xml.dom.domreg no longer use environment
  variables to override parser implementations when
  sys.flags.ignore_environment is set by -E or -I arguments.

* bpo-17239: The xml.sax and xml.dom.minidom parsers no longer
  processes external entities by default. External DTD and ENTITY
  declarations no longer load files or create network connections.

* bpo-34623: CVE-2018-14647: The C accelerated _elementtree module now
  initializes hash randomization salt from _Py_HashSecret instead of
  libexpat's default CSPRNG.

* bpo-34405: 将Windows内部版本更新到OpenSSL 1.1.0i

* bpo-33871: 修复了使用 "os.sendfile()" 在macOS上发送部分文件的错误。
  使用 *trailers* 参数可能导致从输入文件发送的字节数多于指定的数量。

* bpo-32533: Fixed thread-safety of error handling in _ssl.

* bpo-33136: Harden ssl module against LibreSSL CVE-2018-8970.
  X509_VERIFY_PARAM_set1_host() is called with an explicit namelen. A
  new test ensures that NULL bytes are not allowed.

* bpo-33001: Minimal fix to prevent buffer overrun in os.symlink on
  Windows

* bpo-32981: Regexes in difflib and poplib were vulnerable to
  catastrophic backtracking. These regexes formed potential DOS
  vectors (REDOS). They have been refactored. This resolves
  CVE-2018-1060 and CVE-2018-1061. Patch by Jamie Davis.

* bpo-28414: The ssl module now allows users to perform their own IDN
  en/decoding when using SNI.


核心与内置
----------

* bpo-35877: Make parenthesis optional for named expressions in while
  statement. Patch by Karthikeyan Singaravelan.

* bpo-35814: Allow same right hand side expressions in annotated
  assignments as in normal ones. In particular, "x: Tuple[int, int] =
  1, 2" (without parentheses on the right) is now allowed.

* bpo-35766: Add the option to parse PEP 484 type comments in the ast
  module. (Off by default.) This is merging the key functionality of
  the third party fork thereof,
  [typed_ast](https://github.com/python/typed_ast).

* bpo-35713: Reorganize Python initialization to get working
  exceptions and sys.stderr earlier.

* bpo-33416: Add end line and end column position information to the
  Python AST nodes. This is a C-level backwards incompatible change.

* bpo-35720: Fixed a minor memory leak in pymain_parse_cmdline_impl
  function in Modules/main.c

* bpo-35634: "func(**kwargs)" will now raise an error when "kwargs" is
  a mapping containing multiple entries with the same key. An error
  was already raised when other keyword arguments are passed before
  "**kwargs" since Python 3.6.

* bpo-35623: 修复了在排序超长列表时崩溃的问题。 补丁作者 Stephan Hohe
  。

* bpo-35214: 添加了 clang Memory Sanitizer 构建工具以绕过来自 posix,
  socket, time, test_io 和 test_faulthandler 的误报问题。

* bpo-35560: 修复了在调试版中使用 "n" 格式进行零留空和小宽度的浮点格式
  化时 "format()" 内的一个断言错误。 发布版未受影响。 补丁作者
  Karthikeyan Singaravelan。

* bpo-35552: Format characters "%s" and "%V" in
  "PyUnicode_FromFormat()" and "%s" in "PyBytes_FromFormat()" no
  longer read memory past the limit if *precision* is specified.

* bpo-35504: 修复了在删除特定属性时的段错误和 "SystemError" 问题。 补
  丁作者 Zackery Spytz。

* bpo-35504: Fixed a SystemError when delete the characters_written
  attribute of an OSError.

* bpo-35494: Improved syntax error messages for unbalanced parentheses
  in f-string.

* bpo-35444: Fixed error handling in pickling methods when fail to
  look up builtin "getattr". Sped up pickling iterators.

* bpo-35436: Fix various issues with memory allocation error handling.
  Patch by Zackery Spytz.

* bpo-35423: Separate the signal handling trigger in the eval loop
  from the "pending calls" machinery. There is no semantic change and
  the difference in performance is insignificant.

* bpo-35357: Internal attributes' names of unittest.mock._Call and
  unittest.mock.MagicProxy (name, parent & from_kall) are now prefixed
  with _mock_ in order to prevent clashes with widely used object
  attributes. Fixed minor typo in test function name.

* bpo-35372: Fixed the code page decoder for input longer than 2 GiB
  containing undecodable bytes.

* bpo-35336: Fix PYTHONCOERCECLOCALE=1 environment variable: only
  coerce the C locale if the LC_CTYPE locale is "C".

* bpo-31241: The *lineno* and *col_offset* attributes of AST nodes for
  list comprehensions, generator expressions and tuples are now point
  to the opening parenthesis or square brace. For tuples without
  parenthesis they point to the position of the first item.

* bpo-33954: For "str.format()", "float.__format__()" and
  "complex.__format__()" methods for non-ASCII decimal point when
  using the "n" formatter.

* bpo-35269: Fix a possible segfault involving a newly-created
  coroutine. Patch by Zackery Spytz.

* bpo-35224: Implement **PEP 572** (assignment expressions). Patch by
  Emily Morehouse.

* bpo-32492: Speed up "namedtuple" attribute access by 1.6x using a C
  fast-path for the name descriptors. Patch by Pablo Galindo.

* bpo-35214: Fixed an out of bounds memory access when parsing a
  truncated unicode escape sequence at the end of a string such as
  "'\N'".  It would read one byte beyond the end of the memory
  allocation.

* bpo-35214: The interpreter and extension modules have had
  annotations added so that they work properly under clang's Memory
  Sanitizer.  A new configure flag --with-memory-sanitizer has been
  added to make test builds of this nature easier to perform.

* bpo-35193: Fix an off by one error in the bytecode peephole
  optimizer where it could read bytes beyond the end of bounds of an
  array when removing unreachable code. This bug was present in every
  release of Python 3.6 and 3.7 until now.

* bpo-35169: Improved error messages for forbidden assignments.

* bpo-34022: Fix handling of hash-based bytecode files in "zipimport".
  Patch by Elvis Pranskevichus.

* bpo-28401: Debug builds will no longer to attempt to import
  extension modules built for the ABI as they were never compatible to
  begin with. Patch by Stefano Rivera.

* bpo-29341: Clarify in the docstrings of "os" methods that path-like
  objects are also accepted as input parameters.

* bpo-35050: "socket": Fix off-by-one bug in length check for "AF_ALG"
  name and type.

* bpo-29743: Raise "ValueError" instead of "OverflowError" in case of
  a negative "_length_" in a "ctypes.Array" subclass.  Also raise
  "TypeError" instead of "AttributeError" for non-integer "_length_".
  Original patch by Oren Milman.

* bpo-16806: Fix "lineno" and "col_offset" for multi-line string
  tokens.

* bpo-35029: "SyntaxWarning" raised as an exception at code generation
  time will be now replaced with a "SyntaxError" for better error
  reporting.

* bpo-34983: Expose "symtable.Symbol.is_nonlocal()" in the symtable
  module. Patch by Pablo Galindo.

* bpo-34974: "bytes" and "bytearray" constructors no longer convert
  unexpected exceptions (e.g. "MemoryError" and "KeyboardInterrupt")
  to "TypeError".

* bpo-34939: Allow annotated names in module namespace that are
  declared global before the annotation happens. Patch by Pablo
  Galindo.

* bpo-34973: Fixed crash in "bytes()" when the "list" argument is
  mutated while it is iterated.

* bpo-34876: The *lineno* and *col_offset* attributes of the AST for
  decorated function and class refer now to the position of the
  corresponding "def", "async def" and "class" instead of the position
  of the first decorator. This leads to more correct line reporting in
  tracing. This is the only case when the position of child AST nodes
  can precede the position of the parent AST node.

* bpo-34879: Fix a possible null pointer dereference in bytesobject.c.
  Patch by Zackery Spytz.

* bpo-34784: Fix the implementation of PyStructSequence_NewType in
  order to create heap allocated StructSequences.

* bpo-32912: A "SyntaxWarning" is now emitted instead of a
  "DeprecationWarning" for invalid escape sequences in string and
  bytes literals.

* bpo-34854: 修复问题——当编译包含一个没有默认值的关键字参数的 lambda
  的字符串注解时可导致崩溃。

* bpo-34850: The compiler now produces a "SyntaxWarning" when identity
  checks ("is" and "is not") are used with certain types of literals
  (e.g. strings, ints).  These can often work by accident in CPython,
  but are not guaranteed by the language spec.  The warning advises
  users to use equality tests ("==" and "!=") instead.

* bpo-34824: Fix a possible null pointer dereference in
  Modules/_ssl.c. Patch by Zackery Spytz.

* bpo-30156: The C function "property_descr_get()" uses a "cached"
  tuple to optimize function calls. But this tuple can be discovered
  in debug mode with "sys.getobjects()". Remove the optimization, it's
  not really worth it and it causes 3 different crashes last years.

* bpo-34762: Fix contextvars C API to use PyObject* pointer types.

* bpo-34751: The hash function for tuples is now based on xxHash which
  gives better collision results on (formerly) pathological cases.
  Additionally, on 64-bit systems it improves tuple hashes in general.
  Patch by Jeroen Demeyer with substantial contributions by Tim
  Peters.

* bpo-34735: Fix a memory leak in Modules/timemodule.c.  Patch by
  Zackery Spytz.

* bpo-34683: Fixed a bug where some SyntaxError error pointed to
  locations that were off-by-one.

* bpo-34651: Only allow the main interpreter to fork.  The avoids the
  possibility of affecting the main interpreter, which is critical to
  operation of the runtime.

* bpo-34653: Remove unused function
  PyParser_SimpleParseStringFilename.

* bpo-32236: Warn that line buffering is not supported if "open()" is
  called with binary mode and "buffering=1".

* bpo-34641: Further restrict the syntax of the left-hand side of
  keyword arguments in function calls. In particular,
  "f((keyword)=arg)" is now disallowed.

* bpo-34637: Make the *start* argument to *sum()* visible as a keyword
  argument.

* bpo-1621: Do not assume signed integer overflow behavior (C
  undefined behavior) when performing set hash table resizing.

* bpo-34588: Fix an off-by-one in the recursive call pruning feature
  of traceback formatting.

* bpo-34485: On Windows, the LC_CTYPE is now set to the user preferred
  locale at startup. Previously, the LC_CTYPE locale was "C" at
  startup, but changed when calling setlocale(LC_CTYPE, "") or
  setlocale(LC_ALL, "").

* bpo-34485: Standard streams like sys.stdout now use the
  "surrogateescape" error handler, instead of "strict", on the POSIX
  locale (when the C locale is not coerced and the UTF-8 Mode is
  disabled).

* bpo-34485: Fix the error handler of standard streams like
  sys.stdout: PYTHONIOENCODING=":" is now ignored instead of setting
  the error handler to "strict".

* bpo-34485: Python now gets the locale encoding with C code to
  initialize the encoding of standard streams like sys.stdout.
  Moreover, the encoding is now initialized to the Python codec name
  to get a normalized encoding name and to ensure that the codec is
  loaded. The change avoids importing _bootlocale and _locale modules
  at startup by default.

* bpo-34527: On FreeBSD, Py_DecodeLocale() and Py_EncodeLocale() now
  also forces the ASCII encoding if the LC_CTYPE locale is "POSIX",
  not only if the LC_CTYPE locale is "C".

* bpo-34527: The UTF-8 Mode is now also enabled by the "POSIX" locale,
  not only by the "C" locale.

* bpo-34403: On HP-UX with C or POSIX locale,
  sys.getfilesystemencoding() now returns "ascii" instead of "roman8"
  (when the UTF-8 Mode is disabled and the C locale is not coerced).

* bpo-34523: The Python filesystem encoding is now read earlier during
  the Python initialization.

* bpo-12458: Tracebacks show now correct line number for
  subexpressions in multiline expressions. Tracebacks show now the
  line number of the first line for multiline expressions instead of
  the line number of the last subexpression.

* bpo-34408: Prevent a null pointer dereference and resource leakage
  in "PyInterpreterState_New()".

* bpo-34400: Fix undefined behavior in parsetok.c.  Patch by Zackery
  Spytz.

* bpo-33073: Added as_integer_ratio to ints to make them more
  interoperable with floats.

* bpo-34377: 更新valgrind的抑制列表，使用
  "_PyObject_Free"/"_PyObject_Realloc" 代替
  "PyObject_Free"/"PyObject_Realloc" 。

* bpo-34353: Added the "socket" option in the "stat.filemode()" Python
  implementation to match the C implementation.

* bpo-34320: 修复问题——"dict(od)" 不会复制 OrderedDict 的迭代顺序。

* bpo-34113: Fixed crash on debug builds when opcode stack was
  adjusted with negative numbers. Patch by Constantin Petrisor.

* bpo-34100: Compiler now merges constants in tuples and frozensets
  recursively. Code attributes like "co_names" are merged too.

* bpo-34151: Performance of list concatenation, repetition and slicing
  operations is slightly improved. Patch by Sergey Fedoseev.

* bpo-34170: -X dev: 即使启用了开发模式，现在也可以使用PYTHONMALLOC重
  载内存分配器。

* bpo-33237: Improved "AttributeError" message for partially
  initialized module.

* bpo-34149: Fix min and max functions to get default behavior when
  key is None.

* bpo-34125: Profiling of unbound built-in methods now works when
  "**kwargs" is given.

* bpo-34141: Optimized pickling atomic types (None, bool, int, float,
  bytes, str).

* bpo-34126: 修复在分析某些未绑定的方法的无效调用时崩溃的问题。由
  Jeroen Demeyer修复。

* bpo-24618: 修复了当创建代码对象时使用的变量名元组太小或参数太多导致
  读取无效内存的问题。

* bpo-34068: 在调用 "io.IOBase.close()" 时确保 "closed" 属性未设置有效
  的异常。 由Zackery Spytz和Serhiy Storchaka修复。

* bpo-34087: 修复由unicode转换为数值类型时缓冲区溢出的问题。

* bpo-34080: 修复了编译器在标记化过程中引发一些不常见错误时内存泄漏的
  问题。

* bpo-34066: 调用 "open()" 和进入  "with open()" 的 **with** 语句块内
  时禁止使用 Ctrl-C 中断。

* bpo-34042: 修复 dict.copy() 以维护正确的总引用计数（由
  sys.gettotalrefcount()报告）。

* bpo-33418: Fix potential memory leak in function object when it
  creates reference cycle.

* bpo-33985: 实现contextvars.ContextVar.name 属性。

* bpo-33956: Update vendored Expat library copy to version 2.2.5.

* bpo-24596: 执行 "PyErr_Print()" 之前，在 "PyRun_SimpleFileExFlags()"
  内减少模块对象的引用。 由Zackery Spytz修复。

* bpo-33451: 执行 "PyEval_EvalCode()" 前先关闭直接执行的pyc文件。

* bpo-1617161: The hash of "BuiltinMethodType" instances (methods of
  built-in classes) now depends on the hash of the identity of
  *__self__* instead of its value. The hash and equality of
  "ModuleType" and "MethodWrapperType" instances (methods of user-
  defined classes and some methods of built-in classes like
  "str.__add__") now depend on the hash and equality of the identity
  of *__self__* instead of its value. "MethodWrapperType" instances no
  longer support ordering.

* bpo-33824: 修复"LC_ALL=C python3.7 -V"：在读取Python配置后编码发生更
  改时，正确重置命令行解析器。

* bpo-33803: Fix a crash in hamt.c caused by enabling GC tracking for
  an object that hadn't all of its fields set to NULL.

* bpo-33738: Seven macro incompatibilities with the Limited API were
  fixed, and the macros "PyIter_Check()", "PyIndex_Check()" and
  "PyExceptionClass_Name()" were added as functions. A script for
  automatic macro checks was added.

* bpo-33786: Fix asynchronous generators to handle GeneratorExit in
  athrow() correctly

* bpo-30167: "PyRun_SimpleFileExFlags" removes "__cached__" from
  module in addition to "__file__".

* bpo-33706: Fix a crash in Python initialization when parsing the
  command line options. Thanks Christoph Gohlke for the bug report and
  the fix!

* bpo-33597: Reduce "PyGC_Head" size from 3 words to 2 words.

* bpo-30654: Fixed reset of the SIGINT handler to SIG_DFL on
  interpreter shutdown even when there was a custom handler set
  previously. Patch by Philipp Kerling.

* bpo-33622: Fixed a leak when the garbage collector fails to add an
  object with the "__del__" method or referenced by it into the
  "gc.garbage" list. "PyGC_Collect()" can now be called when an
  exception is set and preserves it.

* bpo-33462: Make dict and dict views reversible. Patch by Rémi
  Lapeyre.

* bpo-23722: A "RuntimeError" is now raised when the custom metaclass
  doesn't provide the "__classcell__" entry in the namespace passed to
  "type.__new__".  A "DeprecationWarning" was emitted in Python 3.6--
  3.7.

* bpo-33499: Add "PYTHONPYCACHEPREFIX" environment variable and "-X"
  "pycache_prefix" command-line option to set an alternate root
  directory for writing module bytecode cache files.

* bpo-25711: The "zipimport" module has been rewritten in pure Python.

* bpo-33509: Fix module_globals parameter of warnings.warn_explicit():
  don't crash if module_globals is not a dict.

* bpo-31849: Fix signed/unsigned comparison warning in pyhash.c.

* bpo-33475: Fixed miscellaneous bugs in converting annotations to
  strings and optimized parentheses in the string representation.

* bpo-20104: Added support for the "setpgroup", "resetids",
  "setsigmask", "setsigdef" and "scheduler" parameters of
  "posix_spawn". Patch by Pablo Galindo.

* bpo-33391: Fix a leak in set_symmetric_difference().

* bpo-33363: 在异步函数外使用``async with`` 和 "async for"  时抛出
  SyntaxError异常。

* bpo-28055: Fix unaligned accesses in siphash24(). Patch by Rolf Eike
  Beer.

* bpo-33128: 修复导致PathFinder在sys.meta_path上出现两次的错误。由
  Pablo Galindo Salgado提供补丁。

* bpo-33331: Modules imported last are now cleared first at
  interpreter shutdown.

* bpo-33312: Fixed clang ubsan (undefined behavior sanitizer) warnings
  in dictobject.c by adjusting how the internal struct _dictkeysobject
  shared keys structure is declared.

* bpo-33305: Improved syntax error messages for invalid numerical
  literals.

* bpo-33306: Improved syntax error messages for unbalanced
  parentheses.

* bpo-33234: The list constructor will pre-size and not over-allocate
  when the input length is known.

* bpo-33270: Intern the names for all anonymous code objects.  Patch
  by Zackery Spytz.

* bpo-30455: The C and Python code and the documentation related to
  tokens are now generated from a single source file "Grammar/Tokens".

* bpo-33176: Add a "toreadonly()" method to memoryviews.

* bpo-33231: 修复 "normalizestring()" 中潜在的内存泄漏。

* bpo-33205: Change dict growth function from
  "round_up_to_power_2(used*2+hashtable_size/2)" to
  "round_up_to_power_2(used*3)".  Previously, dict is shrinked only
  when "used == 0". Now dict has more chance to be shrinked.

* bpo-29922: Improved error messages in 'async with' when
  "__aenter__()" or "__aexit__()" return non-awaitable object.

* bpo-33199: Fix "ma_version_tag" in dict implementation is
  uninitialized when copying from key-sharing dict.

* bpo-33053: When using the -m switch, sys.path[0] is now explicitly
  expanded as the *starting* working directory, rather than being left
  as the empty path (which allows imports from the current working
  directory at the time of the import)

* bpo-33138: Changed standard error message for non-pickleable and
  non-copyable types. It now says "cannot pickle" instead of "can't
  pickle" or "cannot serialize".

* bpo-33018: Improve consistency of errors raised by "issubclass()"
  when called with a non-class and an abstract base class as the first
  and second arguments, respectively. Patch by Josh Bronson.

* bpo-33083: "math.factorial" no longer accepts arguments that are not
  int-like. Patch by Pablo Galindo.

* bpo-33041: Added new opcode "END_ASYNC_FOR" and fixes the following
  issues:

  * Setting global "StopAsyncIteration" no longer breaks "async for"
    loops.

  * 跳入一个 "async for" 循环现在被禁止了。

  * 跳出一个 "async for" 循环不再会破坏堆栈了。

* bpo-25750: Fix rare Python crash due to bad refcounting in
  "type_getattro()" if a descriptor deletes itself from the class.
  Patch by Jeroen Demeyer.

* bpo-33041: Fixed bytecode generation for "async for" with a complex
  target. A StopAsyncIteration raised on assigning or unpacking will
  be now propagated instead of stopping the iteration.

* bpo-33026: Fixed jumping out of "with" block by setting f_lineno.

* bpo-33005: Fix a crash on fork when using a custom memory allocator
  (ex: using PYTHONMALLOC env var). _PyGILState_Reinit() and
  _PyInterpreterState_Enable() now use the default RAW memory
  allocator to allocate a new interpreters mutex on fork.

* bpo-32911: Due to unexpected compatibility issues discovered during
  downstream beta testing, reverted bpo-29463. "docstring" field is
  removed from Module, ClassDef, FunctionDef, and AsyncFunctionDef ast
  nodes which was added in 3.7a1.  Docstring expression is restored as
  a first statement in their body. Based on patch by Inada Naoki.

* bpo-17288: Prevent jumps from 'return' and 'exception' trace events.

* bpo-32946: Importing names from already imported module with "from
  ... import ..." is now 30% faster if the module is not a package.

* bpo-32932: Make error message more revealing when there are non-str
  objects in "__all__".

* bpo-32925: Optimized iterating and containing test for literal lists
  consisting of non-constants: "x in [a, b]" and "for x in [a, b]".
  The case of all constant elements already was optimized.

* bpo-32889: Update Valgrind suppression list to account for the
  rename of "Py_ADDRESS_IN_RANG" to "address_in_range".

* bpo-32836: Don't use temporary variables in cases of list/dict/set
  comprehensions

* bpo-31356: Remove the new API added in bpo-31356
  (gc.ensure_disabled() context manager).

* bpo-32305: For namespace packages, ensure that both "__file__" and
  "__spec__.origin" are set to None.

* bpo-32303: Make sure "__spec__.loader" matches "__loader__" for
  namespace packages.

* bpo-32711: Fix the warning messages for Python/ast_unparse.c. Patch
  by Stéphane Wirtel

* bpo-32583: Fix possible crashing in builtin Unicode decoders caused
  by write out-of-bound errors when using customized decode error
  handlers.

* bpo-32489: A "continue" statement is now allowed in the "finally"
  clause.

* bpo-17611: Simplified the interpreter loop by moving the logic of
  unrolling the stack of blocks into the compiler. The compiler emits
  now explicit instructions for adjusting the stack of values and
  calling the cleaning up code for "break", "continue" and "return".

  Removed opcodes "BREAK_LOOP", "CONTINUE_LOOP", "SETUP_LOOP" and
  "SETUP_EXCEPT". Added new opcodes "ROT_FOUR", "BEGIN_FINALLY" and
  "CALL_FINALLY" and "POP_FINALLY". Changed the behavior of
  "END_FINALLY" and "WITH_CLEANUP_START".

* bpo-32285: New function unicodedata.is_normalized, which can check
  whether a string is in a specific normal form.

* bpo-10544: Yield expressions are now disallowed in comprehensions
  and generator expressions except the expression for the outermost
  iterable.

* bpo-32117: Iterable unpacking is now allowed without parentheses in
  yield and return statements, e.g. "yield 1, 2, 3, *rest". Thanks to
  David Cuthbert for the change and Jordan Chapman for added tests.

* bpo-31902: Fix the "col_offset" attribute for ast nodes
  "ast.AsyncFor", "ast.AsyncFunctionDef", and "ast.AsyncWith".
  Previously, "col_offset" pointed to the keyword after "async".

* bpo-25862: 修复 "io.TextIOWrapper" 的 "tell()" 方法内的错误断言。

* bpo-21983: Fix a crash in "ctypes.cast()" in case the type argument
  is a ctypes structured data type. Patch by Eryk Sun and Oren Milman.

* bpo-31577: Fix a crash in "os.utime()" in case of a bad ns argument.
  Patch by Oren Milman.

* bpo-29832: Remove references to 'getsockaddrarg' from various socket
  error messages. Patch by Oren Milman.


库
--

* bpo-35845: Add 'order' parameter to memoryview.tobytes().

* bpo-35864: The _asdict() method for collections.namedtuple now
  returns a regular dict instead of an OrderedDict.

* bpo-35537: An ExitStack is now used internally within
  subprocess.POpen to clean up pipe file handles. No behavior change
  in normal operation. But if closing one handle were ever to cause an
  exception, the others will now be closed instead of leaked.  (patch
  by Giampaolo Rodola)

* bpo-35847: RISC-V needed the CTYPES_PASS_BY_REF_HACK.  Fixes ctypes
  Structure test_pass_by_value.

* bpo-35813: Shared memory submodule added to multiprocessing to avoid
  need for serialization between processes

* bpo-35780: Fix lru_cache() errors arising in recursive, reentrant,
  or multi-threaded code. These errors could result in orphan links
  and in the cache being trapped in a state with fewer than the
  specified maximum number of links. Fix handling of negative maxsize
  which should have been treated as zero. Fix errors in toggling the
  "full" status flag. Fix misordering of links when errors are
  encountered.  Sync-up the C code and pure Python code for the space
  saving path in functions with a single positional argument. In this
  common case, the space overhead of an lru cache entry is reduced by
  almost half.  Fix counting of cache misses. In error cases, the miss
  count was out of sync with the actual number of times the underlying
  user function was called.

* bpo-35537: "os.posix_spawn()" and "os.posix_spawnp()" now have a
  *setsid* parameter.

* bpo-23846: "asyncio.ProactorEventLoop" now catches and logs send
  errors when the self-pipe is full.

* bpo-34323: "asyncio": Enhance "IocpProactor.close()" log: wait 1
  second before the first log, then log every second. Log also the
  number of seconds since "close()" was called.

* bpo-35674: Add a new "os.posix_spawnp()" function. Patch by Joannah
  Nanjekye.

* bpo-35733: "ast.Constant(boolean)" no longer an instance of
  "ast.Num".  Patch by Anthony Sottile.

* bpo-35726: QueueHandler.prepare() now makes a copy of the record
  before modifying and enqueueing it, to avoid affecting other
  handlers in the chain.

* bpo-35719: Sped up multi-argument "math" functions atan2(),
  copysign(), remainder() and hypot() by 1.3--2.5 times.

* bpo-35717: Fix KeyError exception raised when using enums and
  compile. Patch contributed by Rémi Lapeyre.

* bpo-35699: Fixed detection of Visual Studio Build Tools 2017 in
  distutils

* bpo-32710: Fix memory leaks in asyncio ProactorEventLoop on
  overlapped operation failure.

* bpo-35702: The "time.CLOCK_UPTIME_RAW" constant is now available for
  macOS 10.12.

* bpo-32710: Fix a memory leak in asyncio in the ProactorEventLoop
  when "ReadFile()" or "WSASend()" overlapped operation fail
  immediately: release the internal buffer.

* bpo-35682: Fix "asyncio.ProactorEventLoop.sendfile()": don't attempt
  to set the result of an internal future if it's already done.

* bpo-35283: Add a deprecated warning for the
  "threading.Thread.isAlive()" method. Patch by Dong-hee Na.

* bpo-35664: Improve operator.itemgetter() performance by 33% with
  optimized argument handling and with adding a fast path for the
  common case of a single non-negative integer index into a tuple
  (which is the typical use case in the standard library).

* bpo-35643: 修复了 Modules/_sha3/cleanup.py 中的一个 SyntaxWarning:
  invalid escape sequence。 补丁作者 Mickaël Schoentgen。

* bpo-35619: Improved support of custom data descriptors in "help()"
  and "pydoc".

* bpo-28503: 当库函数可用时 "crypt" 模块现在将在内部使用 "crypt_r()"
  而非 "crypt()"。

* bpo-35614: Fixed help() on metaclasses. Patch by Sanyam Khurana.

* bpo-35568: Expose "raise(signum)" as "raise_signal"

* bpo-35588: The floor division and modulo operations and the
  "divmod()" function on "fractions.Fraction" types are 2--4x faster.
  Patch by Stefan Behnel.

* bpo-35585: 加快构建按值枚举的速度，例如 http.HTTPStatus(200)。

* bpo-30561: random.gammavariate(1.0, beta) now computes the same
  result as random.expovariate(1.0 / beta).  This synchonizes the two
  algorithms and eliminates some idiosyncrasies in the old
  implementation.  It does however produce a difference stream of
  random variables than it used to.

* bpo-35537: The "subprocess" module can now use the
  "os.posix_spawn()" function in some cases for better performance.

* bpo-35526: Delaying the 'joke' of barry_as_FLUFL.mandatory to Python
  version 4.0

* bpo-35523: Remove "ctypes" callback workaround: no longer create a
  callback at startup. Avoid SELinux alert on "import ctypes" and
  "import uuid".

* bpo-31784: "uuid.uuid1()" now calls "time.time_ns()" rather than
  "int(time.time() * 1e9)".

* bpo-35513: "unittest.runner" 的 "TextTestRunner" 现在将使用
  "time.perf_counter()" 而非 "time.time()" 来计量一个测试的执行时间:
  "time.time()" 可以回退，而 "time.perf_counter()" 为单调递增。

* bpo-35502: 修复了构建树未完成的情况下
  "xml.etree.ElementTree.TreeBuilder" 中的引用泄漏（特别是在解析 XML
  期间引发错误的时候）。

* bpo-35348: Make "platform.architecture()" parsing of "file" command
  output more reliable: add the "-b" option to the "file" command to
  omit the filename, force the usage of the C locale, and search also
  the "shared object" pattern.

* bpo-35491: "multiprocessing": Add "Pool.__repr__()" and enhance
  "BaseProcess.__repr__()" (add pid and parent pid) to ease debugging.
  Pool state constant values are now strings instead of integers, for
  example "RUN" value becomes "'RUN'" instead of "0".

* bpo-35477: "multiprocessing.Pool.__enter__()" now fails if the pool
  is not running: "with pool:" fails if used more than once.

* bpo-31446: 复制被传递给 CreateProcessW 的命令行，因为此函数能改变输
  入缓存的内容。

* bpo-35471: Python2.4 取消了对MacOS 9 的支持。Python3.7 中已弃用
  macpath 模块。该模块现在已移除。

* bpo-23057: Unblock Proactor event loop when keyboard interrupt is
  received on Windows

* bpo-35052: Fix xml.dom.minidom cloneNode() on a document with an
  entity: pass the correct arguments to the user data handler of an
  entity.

* bpo-20239: Allow repeated assignment deletion of
  "unittest.mock.Mock" attributes. Patch by Pablo Galindo.

* bpo-17185: 在 mock 上设置 "__signature__" 以便 "inspect" 能获得签名
  。 补丁作者为 Karthikeyan Singaravelan。

* bpo-35445: Memory errors during creating posix.environ no longer
  ignored.

* bpo-35415: Validate fileno= argument to socket.socket().

* bpo-35424: "multiprocessing.Pool" destructor now emits
  "ResourceWarning" if the pool is still running.

* bpo-35330: When a "Mock" instance was used to wrap an object, if
  "side_effect" is used in one of the mocks of it methods, don't call
  the original implementation and return the result of using the side
  effect the same way that it is done with return_value.

* bpo-35346: 从 "platform" 模块中删除 MacOS 9 和 Rhapsody 支持。
  Rhapsody 上一次发布是在2000年。MacOS 9 上一次发布是在2001年。

* bpo-10496: "check_environ()" of "distutils.utils" now catches
  "KeyError" on calling "pwd.getpwuid()": don't create the "HOME"
  environment variable in this case.

* bpo-10496: "posixpath.expanduser()" now returns the input *path*
  unchanged if the "HOME" environment variable is not set and the
  current user has no home directory (if the current user identifier
  doesn't exist in the password database). This change fix the "site"
  module if the current user doesn't exist in the password database
  (if the user has no home directory).

* bpo-35389: "platform.libc_ver()" now uses
  "os.confstr('CS_GNU_LIBC_VERSION')" if available and the
  *executable* parameter is not set.

* bpo-35394: Add empty slots to asyncio abstract protocols.

* bpo-35310: Fix a bug in "select.select()" where, in some cases, the
  file descriptor sequences were returned unmodified after a signal
  interruption, even though the file descriptors might not be ready
  yet. "select.select()" will now always return empty lists if a
  timeout has occurred.  Patch by Oran Avraham.

* bpo-35380: Enable TCP_NODELAY on Windows for proactor asyncio event
  loop.

* bpo-35341: Add generic version of "collections.OrderedDict" to the
  "typing" module. Patch by Ismo Toijala.

* bpo-35371: Fixed possible crash in "os.utime()" on Windows when pass
  incorrect arguments.

* bpo-35346: "platform.uname()" now redirects "stderr" to "os.devnull"
  when running external programs like "cmd /c ver".

* bpo-35066: Previously, calling the strftime() method on a datetime
  object with a trailing '%' in the format string would result in an
  exception. However, this only occurred when the datetime C module
  was being used; the python implementation did not match this
  behavior. Datetime is now PEP-399 compliant, and will not throw an
  exception on a trailing '%'.

* bpo-35345: The function "platform.popen" has been removed, it was
  deprecated since Python 3.3: use "os.popen()" instead.

* bpo-35344: On macOS, "platform.platform()" now uses
  "platform.mac_ver()", if it returns a non-empty release string, to
  get the macOS version rather than the darwin version.

* bpo-35312: Make "lib2to3.pgen2.parse.ParseError" round-trip pickle-
  able. Patch by Anthony Sottile.

* bpo-35308: Fix regression in "webbrowser" where default browsers may
  be preferred over browsers in the "BROWSER" environment variable.

* bpo-24746: Avoid stripping trailing whitespace in doctest fancy
  diff. Original patch by R. David Murray & Jairo Trad. Enhanced by
  Sanyam Khurana.

* bpo-28604: "locale.localeconv()" now sets temporarily the "LC_CTYPE"
  locale to the "LC_MONETARY" locale if the two locales are different
  and monetary strings are non-ASCII. This temporary change affects
  other threads.

* bpo-35277: Update ensurepip to install pip 18.1 and setuptools
  40.6.2.

* bpo-24209: Adds IPv6 support when invoking http.server directly.

* bpo-35226: Recursively check arguments when testing for equality of
  "unittest.mock.call" objects and add note that tracking of
  parameters used to create ancestors of mocks in "mock_calls" is not
  possible.

* bpo-29564: The warnings module now suggests to enable tracemalloc if
  the source is specified, the tracemalloc module is available, but
  tracemalloc is not tracing memory allocations.

* bpo-35189: Modify the following fnctl function to retry if
  interrupted by a signal (EINTR): flock, lockf, fnctl

* bpo-30064: Use add_done_callback() in sock_* asyncio API to
  unsubscribe reader/writer early on calcellation.

* bpo-35186: Removed the "built with" comment added when "setup.py
  upload" is used with either "bdist_rpm" or "bdist_dumb".

* bpo-35152: Allow sending more than 2 GB at once on a multiprocessing
  connection on non-Windows systems.

* bpo-35062: Fix incorrect parsing of
  "_io.IncrementalNewlineDecoder"'s *translate* argument.

* bpo-35065: Remove "StreamReaderProtocol._untrack_reader". The call
  to "_untrack_reader" is currently performed too soon, causing the
  protocol to forget about the reader before "connection_lost" can run
  and feed the EOF to the reader.

* bpo-34160: ElementTree and minidom now preserve the attribute order
  specified by the user.

* bpo-35079: Improve difflib.SequenceManager.get_matching_blocks doc
  by adding 'non-overlapping' and changing '!=' to '<'.

* bpo-33710: Deprecated "l*gettext()" functions and methods in the
  "gettext" module. They return encoded bytes instead of Unicode
  strings and are artifacts from Python 2 times. Also deprecated
  functions and methods related to setting the charset for
  "l*gettext()" functions and methods.

* bpo-35017: "socketserver.BaseServer.serve_forever()" now exits
  immediately if it's "shutdown()" method is called while it is
  polling for new events.

* bpo-35024: "importlib" no longer logs "wrote" redundantly after
  "(created|could not create)" is already logged. Patch by Quentin
  Agren.

* bpo-35047: "unittest.mock" now includes mock calls in exception
  messages if "assert_not_called", "assert_called_once", or
  "assert_called_once_with" fails. Patch by Petter Strandmark.

* bpo-31047: Fix "ntpath.abspath" regression where it didn't remove a
  trailing separator on Windows. Patch by Tim Graham.

* bpo-35053: tracemalloc now tries to update the traceback when an
  object is reused from a "free list" (optimization for faster object
  creation, used by the builtin list type for example).

* bpo-31553: Add the --json-lines option to json.tool. Patch by
  hongweipeng.

* bpo-34794: Fixed a leak in Tkinter when pass the Python wrapper
  around Tcl_Obj back to Tcl/Tk.

* bpo-34909: Enum: fix grandchildren subclassing when parent mixed
  with concrete data types.

* bpo-35022: "unittest.mock.MagicMock" now supports the "__fspath__"
  method (from "os.PathLike").

* bpo-35008: Fixed references leaks when call the "__setstate__()"
  method of "xml.etree.ElementTree.Element" in the C implementation
  for already initialized element.

* bpo-23420: Verify the value for the parameter '-s' of the cProfile
  CLI. Patch by Robert Kuska

* bpo-33947: dataclasses now handle recursive reprs without raising
  RecursionError.

* bpo-34890: Make "inspect.iscoroutinefunction()",
  "inspect.isgeneratorfunction()" and "inspect.isasyncgenfunction()"
  work with "functools.partial()". Patch by Pablo Galindo.

* bpo-34521: Use "socket.CMSG_SPACE()" to calculate ancillary data
  size instead of "socket.CMSG_LEN()" in
  "multiprocessing.reduction.recvfds()" as **RFC 3542** requires the
  use of the former for portable applications.

* bpo-31522: The "mailbox.mbox.get_string" function *from_* parameter
  can now successfully be set to a non-default value.

* bpo-34970: Protect tasks weak set manipulation in
  "asyncio.all_tasks()"

* bpo-34969: gzip: Add --fast, --best on the gzip CLI, these
  parameters will be used for the fast compression method (quick) or
  the best method compress (slower, but smaller file). Also, change
  the default compression level to 6 (tradeoff).

* bpo-16965: The *2to3* "execfile" fixer now opens the file with mode
  "'rb'".  Patch by Zackery Spytz.

* bpo-34966: "pydoc" now supports aliases not only to methods defined
  in the end class, but also to inherited methods.  The docstring is
  not duplicated for aliases.

* bpo-34926: "mimetypes.MimeTypes.guess_type()" now accepts *path-like
  object* in addition to url strings. Patch by Mayank Asthana.

* bpo-23831: Add "moveto()" method to the "tkinter.Canvas" widget.
  Patch by Juliette Monsel.

* bpo-34941: Methods "find()", "findtext()" and "findall()" of the
  "Element" class in the "xml.etree.ElementTree" module are now able
  to find children which are instances of "Element" subclasses.

* bpo-32680: "smtplib.SMTP" objects now always have a "sock" attribute
  present

* bpo-34769: Fix for async generators not finalizing when event loop
  is in debug mode and garbage collector runs in another thread.

* bpo-34936: Fix "TclError" in "tkinter.Spinbox.selection_element()".
  Patch by Juliette Monsel.

* bpo-34829: Add methods "selection_from", "selection_range",
  "selection_present" and "selection_to" to the "tkinter.Spinbox" for
  consistency with the "tkinter.Entry" widget. Patch by Juliette
  Monsel.

* bpo-34911: Added *secure_protocols* argument to
  *http.cookiejar.DefaultCookiePolicy* to allow for tweaking of
  protocols and also to add support by default for *wss*, the secure
  websocket protocol.

* bpo-34922: Fixed integer overflow in the "digest()" and
  "hexdigest()" methods for the SHAKE algorithm in the "hashlib"
  module.

* bpo-34925: 25% speedup in argument parsing for the functions in the
  bisect module.

* bpo-34900: Fixed "unittest.TestCase.debug()" when used to call test
  methods with subtests.  Patch by Bruno Oliveira.

* bpo-34844: logging.Formatter enhancement - Ensure styles and fmt
  matches in logging.Formatter - Added validate method in each format
  style class: StrFormatStyle, PercentStyle, StringTemplateStyle. -
  This method is called in the constructor of logging.Formatter class
  - Also re-raise the KeyError in the format method of each style
  class, so it would a bit clear that it's an error with the invalid
  format fields.

* bpo-34897: Adjust test.support.missing_compiler_executable check so
  that a nominal command name of "" is ignored. Patch by Michael Felt.

* bpo-34871: Fix inspect module polluted "sys.modules" when parsing
  "__text_signature__" of callable.

* bpo-34898: Add "mtime" argument to "gzip.compress" for reproducible
  output. Patch by Guo Ci Teo.

* bpo-28441: On Cygwin and MinGW, ensure that "sys.executable" always
  includes the full filename in the path, including the ".exe" suffix
  (unless it is a symbolic link).

* bpo-34866: Adding "max_num_fields" to "cgi.FieldStorage" to make DOS
  attacks harder by limiting the number of "MiniFieldStorage" objects
  created by "FieldStorage".

* bpo-34711: http.server ensures it reports HTTPStatus.NOT_FOUND when
  the local path ends with "/" and is not a directory, even if the
  underlying OS (e.g. AIX) accepts such paths as a valid file
  reference. Patch by Michael Felt.

* bpo-34872: Fix self-cancellation in C implementation of asyncio.Task

* bpo-34849: Don't log waiting for "selector.select" in asyncio loop
  iteration. The waiting is pretty normal for any asyncio program,
  logging its time just adds a noise to logs without any useful
  information provided.

* bpo-34022: The "SOURCE_DATE_EPOCH" environment variable no longer
  overrides the value of the *invalidation_mode* argument to
  "py_compile.compile()", and determines its default value instead.

* bpo-34819: 使用一个单一时钟计算 "Executor.map()" 和 "as_completed()"
  中的超时，以防止当系统时钟被修改时因偏离导致的超时。

* bpo-34758: Add .wasm -> application/wasm to list of recognized file
  types and content type headers

* bpo-34789: "xml.sax.make_parser()" now accepts any iterable as its
  *parser_list* argument.  Patch by Andrés Delfino.

* bpo-34334: In "QueueHandler", clear "exc_text" from "LogRecord" to
  prevent traceback from being written twice.

* bpo-34687: On Windows, asyncio now uses ProactorEventLoop, instead
  of SelectorEventLoop, by default.

* bpo-5950: Support reading zip files with archive comments in
  "zipimport".

* bpo-32892: The parser now represents all constants as "ast.Constant"
  instead of using specific constant AST types ("Num", "Str", "Bytes",
  "NameConstant" and "Ellipsis"). These classes are considered
  deprecated and will be removed in future Python versions.

* bpo-34728: Add deprecation warning when "loop" is used in methods:
  "asyncio.sleep", "asyncio.wait" and "asyncio.wait_for".

* bpo-34738: ZIP files created by "distutils" will now include entries
  for directories.

* bpo-34659: Add an optional *initial* argument to
  itertools.accumulate().

* bpo-29577: Support multiple mixin classes when creating Enums.

* bpo-34670: Add SSLContext.post_handshake_auth and
  SSLSocket.verify_client_post_handshake for TLS 1.3's post handshake
  authentication feature.

* bpo-32718: The Activate.ps1 script from venv works with PowerShell
  Core 6.1 and is now available under all operating systems.

* bpo-31177: Fix bug that prevented using "reset_mock" on mock
  instances with deleted attributes

* bpo-34672: Add a workaround, so the "'Z'" "time.strftime()"
  specifier on the musl C library can work in some cases.

* bpo-34666: Implement "asyncio.StreamWriter.awrite" and
  "asyncio.StreamWriter.aclose()" coroutines.  Methods are needed for
  providing a consistent stream API with control flow switched on by
  default.

* bpo-6721: Acquire the logging module's commonly used internal locks
  while fork()ing to avoid deadlocks in the child process.

* bpo-34658: Fix a rare interpreter unhandled exception state
  SystemError only seen when using subprocess with a preexec_fn while
  an after_parent handler has been registered with os.register_at_fork
  and the fork system call fails.

* bpo-34652: Ensure "os.lchmod()" is never defined on Linux.

* bpo-34638: Store a weak reference to stream reader to break strong
  references loop between reader and protocol.  It allows to detect
  and close the socket if the stream is deleted (garbage collected)
  without "close()" call.

* bpo-34536: "Enum._missing_":  raise "ValueError" if None returned
  and "TypeError" if non-member is returned.

* bpo-34636: Speed up re scanning of many non-matching characters for
  s w and d within bytes objects. (microoptimization)

* bpo-24412: Add "addModuleCleanup()" and "addClassCleanup()" to
  unittest to support cleanups for "setUpModule()" and "setUpClass()".
  Patch by Lisa Roach.

* bpo-34630: Don't log SSL certificate errors in asyncio code
  (connection error logging is skipped already).

* bpo-32490: Prevent filename duplication in "subprocess" exception
  messages.  Patch by Zackery Spytz.

* bpo-34363: dataclasses.asdict() and .astuple() now handle
  namedtuples correctly.

* bpo-34625: Update vendorized expat library version to 2.2.6.

* bpo-32270: The subprocess module no longer mistakenly closes
  redirected fds even when they were in pass_fds when outside of the
  default {0, 1, 2} set.

* bpo-34622: Create a dedicated "asyncio.CancelledError",
  "asyncio.InvalidStateError" and "asyncio.TimeoutError" exception
  classes.  Inherit them from corresponding exceptions from
  "concurrent.futures" package. Extract "asyncio" exceptions into a
  separate file.

* bpo-34610: Fixed iterator of "multiprocessing.managers.DictProxy".

* bpo-34421: Fix distutils logging for non-ASCII strings.  This caused
  installation issues on Windows.

* bpo-34604: Fix possible mojibake in the error message of
  "pwd.getpwnam" and "grp.getgrnam" using string representation
  because of invisible characters or trailing whitespaces. Patch by
  William Grzybowski.

* bpo-30977: Make uuid.UUID use "__slots__" to reduce its memory
  footprint. Based on original patch by Wouter Bolsterlee.

* bpo-34574: OrderedDict iterators are not exhausted during pickling
  anymore. Patch by Sergey Fedoseev.

* bpo-8110: Refactored "subprocess" to check for Windows-specific
  modules rather than "sys.platform == 'win32'".

* bpo-34530: "distutils.spawn.find_executable()" now falls back on
  "os.defpath" if the "PATH" environment variable is not set.

* bpo-34563: On Windows, fix multiprocessing.Connection for very large
  read: fix _winapi.PeekNamedPipe() and _winapi.ReadFile() for read
  larger than INT_MAX (usually 2^31-1).

* bpo-34558: Correct typo in Lib/ctypes/_aix.py

* bpo-34282: Move "Enum._convert" to "EnumMeta._convert_" and fix enum
  members getting shadowed by parent attributes.

* bpo-22872: When the queue is closed, "ValueError" is now raised by
  "multiprocessing.Queue.put()" and "multiprocessing.Queue.get()"
  instead of "AssertionError" and "OSError", respectively. Patch by
  Zackery Spytz.

* bpo-34515: Fix parsing non-ASCII identifiers in
  "lib2to3.pgen2.tokenize" (PEP 3131).

* bpo-13312: Avoids a possible integer underflow (undefined behavior)
  in the time module's year handling code when passed a very low
  negative year value.

* bpo-34472: Improved compatibility for streamed files in "zipfile".
  Previously an optional signature was not being written and certain
  ZIP applications were not supported. Patch by Silas Sewell.

* bpo-34454: Fix the .fromisoformat() methods of datetime types
  crashing when given unicode with non-UTF-8-encodable code points.
  Specifically, datetime.fromisoformat() now accepts surrogate unicode
  code points used as the separator. Report and tests by Alexey
  Izbyshev, patch by Paul Ganssle.

* bpo-6700: Fix inspect.getsourcelines for module level
  frames/tracebacks. Patch by Vladimir Matveev.

* bpo-34171: Running the "trace" module no longer creates the
  "trace.cover" file.

* bpo-34441: Fix crash when an "ABC"-derived class with invalid
  "__subclasses__" is passed as the second argument to "issubclass()".
  Patch by Alexey Izbyshev.

* bpo-34427: Fix infinite loop in "a.extend(a)" for "MutableSequence"
  subclasses.

* bpo-34412: Make "signal.strsignal()" work on HP-UX. Patch by Michael
  Osipov.

* bpo-20849: shutil.copytree now accepts a new "dirs_exist_ok" keyword
  argument. Patch by Josh Bronson.

* bpo-31715: Associate ".mjs" file extension with
  "application/javascript" MIME Type.

* bpo-34384: "os.readlink()" now accepts *path-like* and "bytes"
  objects on Windows.

* bpo-22602: The UTF-7 decoder now raises "UnicodeDecodeError" for
  ill-formed sequences starting with "+" (as specified in RFC 2152).
  Patch by Zackery Spytz.

* bpo-2122: The "mmap.flush()" method now returns "None" on success,
  raises an exception on error under all platforms.

* bpo-34341: Appending to the ZIP archive with the ZIP64 extension no
  longer grows the size of extra fields of existing entries.

* bpo-34333: 修复在 "pathlib.PurePath.with_suffix()" 内使用
  %-formatting 格式化错误信息的错误。

* bpo-18540: The "imaplib.IMAP4" and "imaplib.IMAP4_SSL" classes now
  resolve to the local host IP correctly when the default value of
  *host* parameter ("''") is used.

* bpo-26502: Implement "traceback.FrameSummary.__len__()" method to
  preserve compatibility with the old tuple API.

* bpo-34318: "assertRaises()", "assertRaisesRegex()", "assertWarns()"
  and "assertWarnsRegex()" no longer success if the passed callable is
  None. They no longer ignore unknown keyword arguments in the context
  manager mode. A DeprecationWarning was raised in these cases since
  Python 3.5.

* bpo-9372: Deprecate "__getitem__()" methods of
  "xml.dom.pulldom.DOMEventStream", "wsgiref.util.FileWrapper" and
  "fileinput.FileInput".

* bpo-33613: Fix a race condition in
  "multiprocessing.semaphore_tracker" when the tracker receives SIGINT
  before it can register signal handlers for ignoring it.

* bpo-34248: Report filename in the exception raised when the database
  file cannot be opened by "dbm.gnu.open()" and "dbm.ndbm.open()" due
  to OS-related error. Patch by Zsolt Cserna.

* bpo-33089: Add math.dist() to compute the Euclidean distance between
  two points.

* bpo-34246: "smtplib.SMTP.send_message()" no longer modifies the
  content of the *mail_options* argument. Patch by Pablo S. Blum de
  Aguiar.

* bpo-31047: Fix "ntpath.abspath" for invalid paths on windows. Patch
  by Franz Woellert.

* bpo-32321: Add pure Python fallback for functools.reduce. Patch by
  Robert Wright.

* bpo-34270: The default asyncio task class now always has a name
  which can be get or set using two new methods ("get_name()" and
  "set_name()") and is visible in the "repr()" output. An initial name
  can also be set using the new "name" keyword argument to
  "asyncio.create_task()" or the "create_task()" method of the event
  loop. If no initial name is set, the default Task implementation
  generates a name like "Task-1" using a monotonic counter.

* bpo-34263: asyncio's event loop will not pass timeouts longer than
  one day to epoll/select etc.

* bpo-34035: Fix several AttributeError in zipfile seek() methods.
  Patch by Mickaël Schoentgen.

* bpo-32215: Fix performance regression in "sqlite3" when a DML
  statement appeared in a different line than the rest of the SQL
  query.

* bpo-34075: Deprecate passing non-ThreadPoolExecutor instances to
  "AbstractEventLoop.set_default_executor()".

* bpo-34251: Restore "msilib.Win64" to preserve backwards
  compatibility since it's already used by "distutils"' "bdist_msi"
  command.

* bpo-19891: Ignore errors caused by missing / non-writable homedir
  while writing history during exit of an interactive session.  Patch
  by Anthony Sottile.

* bpo-33089: Enhanced math.hypot() to support more than two
  dimensions.

* bpo-34228: tracemalloc: PYTHONTRACEMALLOC=0 environment variable and
  -X tracemalloc=0 command line option are now allowed to disable
  explicitly tracemalloc at startup.

* bpo-13041: Use "shutil.get_terminal_size()" to calculate the
  terminal width correctly in the "argparse.HelpFormatter" class.
  Initial patch by Zbyszek Jędrzejewski-Szmek.

* bpo-34213: Allow frozen dataclasses to have a field named "object".
  Previously this conflicted with an internal use of "object".

* bpo-34052: "sqlite3.Connection.create_aggregate()",
  "sqlite3.Connection.create_function()",
  "sqlite3.Connection.set_authorizer()",
  "sqlite3.Connection.set_progress_handler()" methods raises TypeError
  when unhashable objects are passed as callable. These methods now
  don't pass such objects to SQLite API. Previous behavior could lead
  to segfaults. Patch by Sergey Fedoseev.

* bpo-34197: Attributes *skipinitialspace*, *doublequote* and *strict*
  of the *dialect* attribute of the "csv" reader are now "bool"
  instances instead of integers 0 or 1.

* bpo-32788: Errors other than "TypeError" raised in methods
  "__adapt__()" and "__conform__()" in the "sqlite3" module are now
  propagated to the user.

* bpo-21446: The "reload" fixer now uses "importlib.reload()" instead
  of deprecated "imp.reload()".

* bpo-940286: pydoc's "Helper.showtopic()" method now prints the cross
  references of a topic correctly.

* bpo-34164: "base64.b32decode()" could raise UnboundLocalError or
  OverflowError for incorrect padding.  Now it always raises
  "base64.Error" in these cases.

* bpo-33729: Fixed issues with arguments parsing in "hashlib".

* bpo-34097: ZipFile can zip files older than 1980-01-01 and newer
  than 2107-12-31 using a new "strict_timestamps" parameter at the
  cost of setting the timestamp to the limit.

* bpo-34108: Remove extraneous CR in 2to3 refactor.

* bpo-34070: Make sure to only check if the handle is a tty, when
  opening a file with "buffering=-1".

* bpo-27494: Reverted bpo-27494. 2to3 rejects now a trailing comma in
  generator expressions.

* bpo-33967: functools.singledispatch now raises TypeError instead of
  IndexError when no positional arguments are passed.

* bpo-34041: Add the parameter *deterministic* to the
  "sqlite3.Connection.create_function()" method. Patch by Sergey
  Fedoseev.

* bpo-34056: Ensure the loader shim created by "imp.load_module"
  always returns bytes from its "get_data()" function. This fixes
  using "imp.load_module" with **PEP 552** hash-based pycs.

* bpo-34054: The multiprocessing module now uses the monotonic clock
  "time.monotonic()" instead of the system clock "time.time()" to
  implement timeout.

* bpo-34043: Optimize tarfile uncompress performance about 15% when
  gzip is used.

* bpo-34044: "subprocess.Popen" now copies the *startupinfo* argument
  to leave it unchanged: it will modify the copy, so that the same
  "STARTUPINFO" object can be used multiple times.

* bpo-34010: Fixed a performance regression for reading streams with
  tarfile. The buffered read should use a list, instead of appending
  to a bytes object.

* bpo-34019: webbrowser: Correct the arguments passed to Opera Browser
  when opening a new URL using the "webbrowser" module. Patch by
  Bumsik Kim.

* bpo-34003: csv.DictReader now creates dicts instead of OrderedDicts.
  Patch by Michael Selik.

* bpo-33978: Closed existing logging handlers before reconfiguration
  via fileConfig and dictConfig. Patch by Karthikeyan Singaravelan.

* bpo-14117: Make minor tweaks to turtledemo. The 'wikipedia' example
  is now 'rosette', describing what it draws.  The 'penrose' print
  output is reduced. The'1024' output of 'tree' is eliminated.

* bpo-33974: Fixed passing lists and tuples of strings containing
  special characters """, "\", "{", "}" and "\n" as options to "ttk"
  widgets.

* bpo-27500: Fix getaddrinfo to resolve IPv6 addresses correctly.

* bpo-24567: Improve random.choices() to handle subnormal input
  weights that could occasionally trigger an IndexError.

* bpo-33871: Fixed integer overflow in "os.readv()", "os.writev()",
  "os.preadv()" and "os.pwritev()" and in "os.sendfile()" with
  *headers* or *trailers* arguments (on BSD-based OSes and macOS).

* bpo-25007: Add "copy.copy()" and "copy.deepcopy()" support to zlib
  compressors and decompressors.  Patch by Zackery Spytz.

* bpo-33929: multiprocessing: Fix a race condition in Popen of
  multiprocessing.popen_spawn_win32. The child process now duplicates
  the read end of pipe instead of "stealing" it. Previously, the read
  end of pipe was "stolen" by the child process, but it leaked a
  handle if the child process had been terminated before it could
  steal the handle from the parent process.

* bpo-33899: Tokenize module now implicitly emits a NEWLINE when
  provided with input that does not have a trailing new line.  This
  behavior now matches what the C tokenizer does internally.
  Contributed by Ammar Askar.

* bpo-33897: Added a 'force' keyword argument to
  logging.basicConfig().

* bpo-33695: "shutil.copytree()" uses "os.scandir()" function and all
  copy functions depending from it use cached "os.stat()" values. The
  speedup for copying a directory with 8000 files is around +9% on
  Linux, +20% on Windows and + 30% on a Windows SMB share. Also the
  number of "os.stat()" syscalls is reduced by 38% making
  "shutil.copytree()" especially faster on network filesystems.
  (Contributed by Giampaolo Rodola' in bpo-33695.)

* bpo-33916: bz2 and lzma: When Decompressor.__init__() is called
  twice, free the old lock to not leak memory.

* bpo-32568: Make select.epoll() and its documentation consistent
  regarding *sizehint* and *flags*.

* bpo-33833: Fixed bug in asyncio where ProactorSocketTransport logs
  AssertionError if force closed during write.

* bpo-33663: Convert content length to string before putting to
  header.

* bpo-33721: "os.path" functions that return a boolean result like
  "exists()", "lexists()", "isdir()", "isfile()", "islink()", and
  "ismount()", and "pathlib.Path" methods that return a boolean result
  like "exists()", "is_dir()", "is_file()", "is_mount()",
  "is_symlink()", "is_block_device()", "is_char_device()",
  "is_fifo()", "is_socket()" now return "False" instead of raising
  "ValueError" or its subclasses "UnicodeEncodeError" and
  "UnicodeDecodeError" for paths that contain characters or bytes
  unrepresentable at the OS level.

* bpo-26544: Fixed implementation of "platform.libc_ver()". It almost
  always returned version '2.9' for glibc.

* bpo-33843: Remove deprecated "cgi.escape", "cgi.parse_qs" and
  "cgi.parse_qsl".

* bpo-33842: Remove "tarfile.filemode" which is deprecated since
  Python 3.3.

* bpo-30167: Prevent site.main() exception if PYTHONSTARTUP is set.
  Patch by Steve Weber.

* bpo-33805: Improve error message of dataclasses.replace() when an
  InitVar is not specified

* bpo-33687: Fix the call to "os.chmod()" for "uu.decode()" if a mode
  is given or decoded. Patch by Timo Furrer.

* bpo-33812: Datetime instance d with non-None tzinfo, but with
  d.tzinfo.utcoffset(d) returning None is now treated as naive by the
  astimezone() method.

* bpo-32108: In configparser, don't clear section when it is assigned
  to itself.

* bpo-27397: Make email module properly handle invalid-length base64
  strings.

* bpo-33578: Implement multibyte encoder/decoder state methods

* bpo-30805: Avoid race condition with debug logging

* bpo-33476: Fix _header_value_parser.py when address group is missing
  final ';'. Contributed by Enrique Perez-Terron

* bpo-33694: asyncio: Fix a race condition causing data loss on
  pause_reading()/resume_reading() when using the ProactorEventLoop.

* bpo-32493: Correct test for "uuid_enc_be" availability in
  "configure.ac". Patch by Michael Felt.

* bpo-33792: Add asyncio.WindowsSelectorEventLoopPolicy and
  asyncio.WindowsProactorEventLoopPolicy.

* bpo-33274: W3C DOM Level 1 specifies return value of
  Element.removeAttributeNode() as "The Attr node that was removed."
  xml.dom.minidom now complies with this requirement.

* bpo-33778: Update "unicodedata"'s database to Unicode version
  11.0.0.

* bpo-33165: Added a stacklevel parameter to logging calls to allow
  use of wrapper/helper functions for logging APIs.

* bpo-33770: improve base64 exception message for encoded inputs of
  invalid length

* bpo-33769: asyncio/start_tls: Fix error message; cancel callbacks in
  case of an unhandled error; mark SSLTransport as closed if it is
  aborted.

* bpo-33767: The concatenation ("+") and repetition ("*") sequence
  operations now raise "TypeError" instead of "SystemError" when
  performed on "mmap.mmap" objects.  Patch by Zackery Spytz.

* bpo-33734: asyncio/ssl: Fix AttributeError, increase default
  handshake timeout

* bpo-31014: Fixed creating a controller for "webbrowser" when a user
  specifies a path to an entry in the BROWSER environment variable.
  Based on patch by John Still.

* bpo-2504: Add gettext.pgettext() and variants.

* bpo-33197: Add description property for _ParameterKind

* bpo-32751: When cancelling the task due to a timeout,
  "asyncio.wait_for()" will now wait until the cancellation is
  complete.

* bpo-32684: Fix gather to propagate cancellation of itself even with
  return_exceptions.

* bpo-33654: Support protocol type switching in
  SSLTransport.set_protocol().

* bpo-33674: Pause the transport as early as possible to further
  reduce the risk of data_received() being called before
  connection_made().

* bpo-33671: "shutil.copyfile()", "shutil.copy()", "shutil.copy2()",
  "shutil.copytree()" and "shutil.move()" use platform-specific fast-
  copy syscalls on Linux and macOS in order to copy the file more
  efficiently. On Windows "shutil.copyfile()" uses a bigger default
  buffer size (1 MiB instead of 16 KiB) and a "memoryview()"-based
  variant of "shutil.copyfileobj()" is used. The speedup for copying a
  512MiB file is about +26% on Linux, +50% on macOS and +40% on
  Windows. Also, much less CPU cycles are consumed. (Contributed by
  Giampaolo Rodola' in bpo-25427.)

* bpo-33674: Fix a race condition in SSLProtocol.connection_made() of
  asyncio.sslproto: start immediately the handshake instead of using
  call_soon(). Previously, data_received() could be called before the
  handshake started, causing the handshake to hang or fail.

* bpo-31647: Fixed bug where calling write_eof() on a
  _SelectorSocketTransport after it's already closed raises
  AttributeError.

* bpo-32610: Make asyncio.all_tasks() return only pending tasks.

* bpo-32410: Avoid blocking on file IO in sendfile fallback code

* bpo-33469: Fix RuntimeError after closing loop that used
  run_in_executor

* bpo-33672: Fix Task.__repr__ crash with Cython's bogus coroutines

* bpo-33654: Fix transport.set_protocol() to support switching between
  asyncio.Protocol and asyncio.BufferedProtocol.  Fix loop.start_tls()
  to work with asyncio.BufferedProtocols.

* bpo-33652: Pickles of type variables and subscripted generics are
  now future-proof and compatible with older Python versions.

* bpo-32493: Fixed "uuid.uuid1()" on FreeBSD.

* bpo-33238: Add "InvalidStateError" to "concurrent.futures".
  "Future.set_result" and "Future.set_exception" now raise
  "InvalidStateError" if the futures are not pending or running. Patch
  by Jason Haydaman.

* bpo-33618: Finalize and document preliminary and experimental TLS
  1.3 support with OpenSSL 1.1.1

* bpo-33625: Release GIL on "grp.getgrnam", "grp.getgrgid",
  "pwd.getpwnam" and "pwd.getpwuid" if reentrant variants of these
  functions are available. Patch by William Grzybowski.

* bpo-33623: Fix possible SIGSGV when asyncio.Future is created in
  __del__

* bpo-11874: Use a better regex when breaking usage into wrappable
  parts. Avoids bogus assertion errors from custom metavar strings.

* bpo-30877: Fixed a bug in the Python implementation of the JSON
  decoder that prevented the cache of parsed strings from clearing
  after finishing the decoding. Based on patch by c-fos.

* bpo-33604: Remove HMAC default to md5 marked for removal in 3.8
  (removal originally planned in 3.6, bump to 3.8 in gh-7062).

* bpo-33582: Emit a deprecation warning for inspect.formatargspec

* bpo-21145: Add "functools.cached_property" decorator, for computed
  properties cached for the life of the instance.

* bpo-33570: Change TLS 1.3 cipher suite settings for compatibility
  with OpenSSL 1.1.1-pre6 and newer. OpenSSL 1.1.1 will have TLS 1.3
  ciphers enabled by default.

* bpo-28556: Do not simplify arguments to "typing.Union". Now
  "Union[Manager, Employee]" is not simplified to "Employee" at
  runtime. Such simplification previously caused several bugs and
  limited possibilities for introspection.

* bpo-12486: "tokenize.generate_tokens()" is now documented as a
  public API to tokenize unicode strings. It was previously present
  but undocumented.

* bpo-33540: Add a new "block_on_close" class attribute to
  "ForkingMixIn" and "ThreadingMixIn" classes of "socketserver".

* bpo-33548: tempfile._candidate_tempdir_list should consider common
  TEMP locations

* bpo-33109: argparse subparsers are once again not required by
  default, reverting the change in behavior introduced by bpo-26510 in
  3.7.0a2.

* bpo-33541: Remove unused private method "_strptime.LocaleTime.__pad"
  (a.k.a. "_LocaleTime__pad").

* bpo-33536: dataclasses.make_dataclass now checks for invalid field
  names and duplicate fields. Also, added a check for invalid field
  specifications.

* bpo-33542: Prevent "uuid.get_node" from using a DUID instead of a
  MAC on Windows. Patch by Zvi Effron

* bpo-26819: Fix race condition with "ReadTransport.resume_reading" in
  Windows proactor event loop.

* Fix failure in "typing.get_type_hints()" when ClassVar was provided
  as a string forward reference.

* bpo-33516: "unittest.mock.MagicMock" now supports the "__round__"
  magic method.

* bpo-28612: Added support for Site Maps to urllib's "RobotFileParser"
  as "RobotFileParser.site_maps()". Patch by Lady Red, based on patch
  by Peter Wirtz.

* bpo-28167: Remove platform.linux_distribution, which was deprecated
  since 3.5.

* bpo-33504: Switch the default dictionary implementation for
  "configparser" from "collections.OrderedDict" to the standard "dict"
  type.

* bpo-33505: Optimize asyncio.ensure_future() by reordering if checks:
  1.17x faster.

* bpo-33497: Add errors param to cgi.parse_multipart and make an
  encoding in FieldStorage use the given errors (needed for Twisted).
  Patch by Amber Brown.

* bpo-29235: The "cProfile.Profile" class can now be used as a context
  manager. Patch by Scott Sanderson.

* bpo-33495: Change dataclasses.Fields repr to use the repr of each of
  its members, instead of str.  This makes it more clear what each
  field actually represents.  This is especially true for the 'type'
  member.

* bpo-26103: Correct "inspect.isdatadescriptor" to look for "__set__"
  or "__delete__".  Patch by Aaron Hall.

* bpo-29209: Removed the "doctype()" method and the *html* parameter
  of the constructor of "XMLParser".  The "doctype()" method defined
  in a subclass will no longer be called. Deprecated methods
  "getchildren()" and "getiterator()" in the "ElementTree" module emit
  now a "DeprecationWarning" instead of "PendingDeprecationWarning".

* bpo-33453: Fix dataclasses to work if using literal string type
  annotations or if using PEP 563 "Postponed Evaluation of
  Annotations". Only specific string prefixes are detected for both
  ClassVar ("ClassVar" and "typing.ClassVar") and InitVar ("InitVar"
  and "dataclasses.InitVar").

* bpo-28556: Minor fixes in typing module: add annotations to
  "NamedTuple.__new__", pass "*args" and "**kwds" in
  "Generic.__new__".  Original PRs by Paulius Šarka and Chad Dombrova.

* bpo-33365: Print the header values besides the header keys instead
  just the header keys if *debuglevel* is set to >0 in "http.client".
  Patch by Marco Strigl.

* bpo-20087: Updated alias mapping with glibc 2.27 supported locales.

* bpo-33422: Fix trailing quotation marks getting deleted when looking
  up byte/string literals on pydoc. Patch by Andrés Delfino.

* bpo-28167: The function "platform.linux_distribution" and
  "platform.dist" now trigger a "DeprecationWarning" and have been
  marked for removal in Python 3.8

* bpo-33281: Fix ctypes.util.find_library regression on macOS.

* bpo-33311: Text and html output generated by cgitb does not display
  parentheses if the current call is done directly in the module.
  Patch by Stéphane Blondon.

* bpo-27300: The file classes in *tempfile* now accept an *errors*
  parameter that complements the already existing *encoding*.  Patch
  by Stephan Hohe.

* bpo-32933: "unittest.mock.mock_open()" now supports iteration over
  the file contents. Patch by Tony Flury.

* bpo-33217: Raise "TypeError" when looking up non-Enum objects in
  Enum classes and Enum members.

* bpo-33197: Update error message when constructing invalid
  inspect.Parameters Patch by Dong-hee Na.

* bpo-33383: Fixed crash in the get() method of the "dbm.ndbm"
  database object when it is called with a single argument.

* bpo-33375: The warnings module now finds the Python file associated
  with a warning from the code object, rather than the frame's global
  namespace. This is consistent with how tracebacks and pdb find
  filenames, and should work better for dynamically executed code.

* bpo-33336: "imaplib" now allows "MOVE" command in "IMAP4.uid()" (RFC
  6851: IMAP MOVE Extension) and potentially as a name of supported
  method of "IMAP4" object.

* bpo-32455: Added *jump* parameter to "dis.stack_effect()".

* bpo-27485: Rename and deprecate undocumented functions in
  "urllib.parse()".

* bpo-33332: Add "signal.valid_signals()" to expose the POSIX
  sigfillset() functionality.

* bpo-33251: "ConfigParser.items()" was fixed so that key-value pairs
  passed in via "vars" are not included in the resulting output.

* bpo-33329: Fix multiprocessing regression on newer glibcs

* bpo-33334: "dis.stack_effect()" now supports all defined opcodes
  including NOP and EXTENDED_ARG.

* bpo-991266: Fix quoting of the "Comment" attribute of
  "http.cookies.SimpleCookie".

* bpo-33131: Upgrade bundled version of pip to 10.0.1.

* bpo-33308: Fixed a crash in the "parser" module when converting an
  ST object to a tree of tuples or lists with "line_info=False" and
  "col_info=True".

* bpo-23403: lib2to3 now uses pickle protocol 4 for pre-computed
  grammars.

* bpo-33266: lib2to3 now recognizes "rf'...'" strings.

* bpo-11594: Ensure line-endings are respected when using lib2to3.

* bpo-33254: Have "importlib.resources.contents()" and
  "importlib.abc.ResourceReader.contents()" return an *iterable*
  instead of an *iterator*.

* bpo-33265: "contextlib.ExitStack" and "contextlib.AsyncExitStack"
  now use a method instead of a wrapper function for exit callbacks.

* bpo-33263: Fix FD leak in "_SelectorSocketTransport"  Patch by Vlad
  Starostin.

* bpo-33256: Fix display of "<module>" call in the html produced by
  "cgitb.html()". Patch by Stéphane Blondon.

* bpo-33144: "random.Random()" and its subclassing mechanism got
  optimized to check only once at class/subclass instantiation time
  whether its "getrandbits()" method can be relied on by other
  methods, including "randrange()", for the generation of arbitrarily
  large random integers. Patch by Wolfgang Maier.

* bpo-33185: Fixed regression when running pydoc with the "-m" switch.
  (The regression was introduced in 3.7.0b3 by the resolution of
  bpo-33053)

  This fix also changed pydoc to add "os.getcwd()" to "sys.path" when
  necessary, rather than adding ""."".

* bpo-29613: Added support for the "SameSite" cookie flag to the
  "http.cookies" module.

* bpo-33169: Delete entries of "None" in "sys.path_importer_cache"
  when "importlib.machinery.invalidate_caches()" is called.

* bpo-33203: "random.Random.choice()" now raises "IndexError" for
  empty sequences consistently even when called from subclasses
  without a "getrandbits()" implementation.

* bpo-33224: Update difflib.mdiff() for **PEP 479**.  Convert an
  uncaught StopIteration in a generator into a return-statement.

* bpo-33209: End framing at the end of C implementation of
  "pickle.Pickler.dump()".

* bpo-32861: The urllib.robotparser's "__str__" representation now
  includes wildcard entries and the "Crawl-delay" and "Request-rate"
  fields. Also removes extra newlines that were being appended to the
  end of the string. Patch by Michael Lazar.

* bpo-23403: "DEFAULT_PROTOCOL" in "pickle" was bumped to 4. Protocol
  4 is described in **PEP 3154** and available since Python 3.4. It
  offers better performance and smaller size compared to protocol 3
  introduced in Python 3.0.

* bpo-20104: Improved error handling and fixed a reference leak in
  "os.posix_spawn()".

* bpo-33106: Deleting a key from a read-only dbm database raises
  module specific error instead of KeyError.

* bpo-33175: In dataclasses, Field.__set_name__ now looks up the
  __set_name__ special method on the class, not the instance, of the
  default value.

* bpo-32380: Create functools.singledispatchmethod to support generic
  single dispatch on descriptors and methods.

* bpo-33141: Have Field objects pass through __set_name__ to their
  default values, if they have their own __set_name__.

* bpo-33096: Allow ttk.Treeview.insert to insert iid that has a false
  boolean value. Note iid=0 and iid=False would be same. Patch by
  Garvit Khatri.

* bpo-32873: Treat type variables and special typing forms as
  immutable by copy and pickle.  This fixes several minor issues and
  inconsistencies, and improves backwards compatibility with Python
  3.6.

* bpo-33134: When computing dataclass's __hash__, use the lookup table
  to contain the function which returns the __hash__ value.  This is
  an improvement over looking up a string, and then testing that
  string to see what to do.

* bpo-33127: ssl模块现在使用LibreSSL 2.7.1编译。

* bpo-32505: 如果数据类的成员变量的类型为Field，但没有类型注解，则引发
  TypeError。

* bpo-33078: 修复在OSX平台因为依赖sem_getvalue而导致的失败。

* bpo-33116: 将'Field'添加到dataclasses.__all__。

* bpo-32896: Fix an error where subclassing a dataclass with a field
  that uses a default_factory would generate an incorrect class.

* bpo-33100: Dataclasses: If a field has a default value that's a
  MemberDescriptorType, then it's from that field being in __slots__,
  not an actual default value.

* bpo-32953: If a non-dataclass inherits from a frozen dataclass,
  allow attributes to be added to the derived class.  Only attributes
  from the frozen dataclass cannot be assigned to.  Require all
  dataclasses in a hierarchy to be either all frozen or all non-
  frozen.

* bpo-33097: Raise RuntimeError when "executor.submit" is called
  during interpreter shutdown.

* bpo-32968: Modulo and floor division involving Fraction and float
  should return float.

* bpo-33061: 添加丢失的 "NoReturn" 到typing.py的 "__all__"

* bpo-33078: Fix the size handling in multiprocessing.Queue when a
  pickling error occurs.

* bpo-33064: lib2to3 now properly supports trailing commas after
  "*args" and "**kwargs" in function signatures.

* bpo-33056: FIX properly close leaking fds in
  concurrent.futures.ProcessPoolExecutor.

* bpo-33021: Release the GIL during fstat() calls, avoiding hang of
  all threads when calling mmap.mmap(), os.urandom(), and
  random.seed().  Patch by Nir Soffer.

* bpo-31804: Avoid failing in multiprocessing.Process if the standard
  streams are closed or None at exit.

* bpo-33034: Providing an explicit error message when casting the port
  property to anything that is not an integer value using "urlparse()"
  and "urlsplit()". Patch by Matt Eaton.

* bpo-30249: Improve struct.unpack_from() exception messages for
  problems with the buffer size and offset.

* bpo-33037: Skip sending/receiving data after SSL transport closing.

* bpo-27683: Fix a regression in "ipaddress" that result of "hosts()"
  is empty when the network is constructed by a tuple containing an
  integer mask and only 1 bit left for addresses.

* bpo-22674: Add the strsignal() function in the signal module that
  returns the system description of the given signal, as returned by
  strsignal(3).

* bpo-32999: Fix C implementation of "ABC.__subclasscheck__(cls,
  subclass)" crashed when "subclass" is not a type object.

* bpo-33009: Fix inspect.signature() for single-parameter
  partialmethods.

* bpo-32969: Expose several missing constants in zlib and fix
  corresponding documentation.

* bpo-32056: Improved exceptions raised for invalid number of channels
  and sample width when read an audio file in modules "aifc", "wave"
  and "sunau".

* bpo-32970: Improved disassembly of the MAKE_FUNCTION instruction.

* bpo-32844: Fix wrong redirection of a low descriptor (0 or 1) to
  stderr in subprocess if another low descriptor is closed.

* bpo-32960: For dataclasses, disallow inheriting frozen from non-
  frozen classes, and also disallow inheriting non-frozen from frozen
  classes. This restriction will be relaxed at a future date.

* bpo-32713: Fixed tarfile.itn handling of out-of-bounds float values.
  Patch by Joffrey Fuhrer.

* bpo-32257: The ssl module now contains OP_NO_RENEGOTIATION constant,
  available with OpenSSL 1.1.0h or 1.1.1.

* bpo-32951: Direct instantiation of SSLSocket and SSLObject objects
  is now prohibited. The constructors were never documented, tested,
  or designed as public constructors. Users were suppose to use
  ssl.wrap_socket() or SSLContext.

* bpo-32929: Remove the tri-state parameter "hash", and add the
  boolean "unsafe_hash". If unsafe_hash is True, add a __hash__
  function, but if a __hash__ exists, raise TypeError.  If unsafe_hash
  is False, add a __hash__ based on the values of eq= and frozen=.
  The unsafe_hash=False behavior is the same as the old hash=None
  behavior.  unsafe_hash=False is the default, just as hash=None used
  to be.

* bpo-32947: Add OP_ENABLE_MIDDLEBOX_COMPAT and test workaround for
  TLSv1.3 for future compatibility with OpenSSL 1.1.1.

* bpo-32146: Document the interaction between frozen executables and
  the spawn and forkserver start methods in multiprocessing.

* bpo-30622: The ssl module now detects missing NPN support in
  LibreSSL.

* bpo-32922: dbm.open() now encodes filename with the filesystem
  encoding rather than default encoding.

* bpo-32759: Free unused arenas in multiprocessing.heap.

* bpo-32859: In "os.dup2", don't check every call whether the "dup3"
  syscall exists or not.

* bpo-32556: nt._getfinalpathname, nt._getvolumepathname and
  nt._getdiskusage now correctly convert from bytes.

* bpo-21060: Rewrite confusing message from setup.py upload from "No
  dist file created in earlier command" to the more helpful "Must
  create and upload files in one command".

* bpo-32857: In "tkinter", "after_cancel(None)" now raises a
  "ValueError" instead of canceling the first scheduled function.
  Patch by Cheryl Sabella.

* bpo-32852: Make sure sys.argv remains as a list when running trace.

* bpo-31333: "_abc" module is added.  It is a speedup module with C
  implementations for various functions and methods in "abc".
  Creating an ABC subclass and calling "isinstance" or "issubclass"
  with an ABC subclass are up to 1.5x faster. In addition, this makes
  Python start-up up to 10% faster.

  Note that the new implementation hides internal registry and caches,
  previously accessible via private attributes "_abc_registry",
  "_abc_cache", and "_abc_negative_cache".  There are three debugging
  helper methods that can be used instead "_dump_registry",
  "_abc_registry_clear", and "_abc_caches_clear".

* bpo-32841: Fixed "asyncio.Condition" issue which silently ignored
  cancellation after notifying and cancelling a conditional lock.
  Patch by Bar Harel.

* bpo-32819: ssl.match_hostname() has been simplified and no longer
  depends on re and ipaddress module for wildcard and IP addresses.
  Error reporting for invalid wildcards has been improved.

* bpo-19675: "multiprocessing.Pool" no longer leaks processes if its
  initialization fails.

* bpo-32394: socket: Remove
  TCP_FASTOPEN,TCP_KEEPCNT,TCP_KEEPIDLE,TCP_KEEPINTVL flags on older
  version Windows during run-time.

* bpo-31787: Fixed refleaks of "__init__()" methods in various
  modules. (Contributed by Oren Milman)

* bpo-30157: Fixed guessing quote and delimiter in csv.Sniffer.sniff()
  when only the last field is quoted.  Patch by Jake Davis.

* bpo-30688: Added support of "\N{name}" escapes in regular
  expressions. Based on patch by Jonathan Eunice.

* bpo-32792: collections.ChainMap() preserves the order of the
  underlying mappings.

* bpo-32775: "fnmatch.translate()" no longer produces patterns which
  contain set operations. Sets starting with '[' or containing '--',
  '&&', '~~' or '||' will be interpreted differently in regular
  expressions in future versions. Currently they emit warnings.
  fnmatch.translate() now avoids producing patterns containing such
  sets by accident.

* bpo-32622: Implement native fast sendfile for Windows proactor event
  loop.

* bpo-32777: Fix a rare but potential pre-exec child process deadlock
  in subprocess on POSIX systems when marking file descriptors
  inheritable on exec in the child process.  This bug appears to have
  been introduced in 3.4.

* bpo-32647: The ctypes module used to depend on indirect linking for
  dlopen. The shared extension is now explicitly linked against libdl
  on platforms with dl.

* bpo-32749: A "dbm.dumb" database opened with flags 'r' is now read-
  only. "dbm.dumb.open()" with flags 'r' and 'w' no longer creates a
  database if it does not exist.

* bpo-32741: Implement "asyncio.TimerHandle.when()" method.

* bpo-32691: Use mod_spec.parent when running modules with pdb

* bpo-32734: Fixed "asyncio.Lock()" safety issue which allowed
  acquiring and locking the same lock multiple times, without it being
  free. Patch by Bar Harel.

* bpo-32727: Do not include name field in SMTP envelope from address.
  Patch by Stéphane Wirtel

* bpo-31453: Add TLSVersion constants and SSLContext.maximum_version /
  minimum_version attributes. The new API wraps OpenSSL 1.1 https://w
  ww.openssl.org/docs/man1.1.0/ssl/SSL_CTX_set_min_proto_version.html
  feature.

* bpo-24334: Internal implementation details of ssl module were
  cleaned up. The SSLSocket has one less layer of indirection. Owner
  and session information are now handled by the SSLSocket and
  SSLObject constructor. Channel binding implementation has been
  simplified.

* bpo-31848: Fix the error handling in Aifc_read.initfp() when the
  SSND chunk is not found. Patch by Zackery Spytz.

* bpo-32585: Add Ttk spinbox widget to "tkinter.ttk".  Patch by Alan D
  Moore.

* bpo-32512: "profile" CLI accepts "-m module_name" as an alternative
  to script path.

* bpo-8525: help() on a type now displays builtin subclasses. This is
  intended primarily to help with notification of more specific
  exception subclasses.

  Patch by Sanyam Khurana.

* bpo-31639: http.server now exposes a ThreadingHTTPServer class and
  uses it when the module is run with "-m" to cope with web browsers
  pre-opening sockets.

* bpo-29877: compileall: import ProcessPoolExecutor only when needed,
  preventing hangs on low resource platforms

* bpo-32221: Various functions returning tuple containing IPv6
  addresses now omit "%scope" part since the same information is
  already encoded in *scopeid* tuple item. Especially this speeds up
  "socket.recvfrom()" when it receives multicast packet since useless
  resolving of network interface name is omitted.

* bpo-32147: "binascii.unhexlify()" is now up to 2 times faster. Patch
  by Sergey Fedoseev.

* bpo-30693: The TarFile class now recurses directories in a
  reproducible way.

* bpo-30693: The ZipFile class now recurses directories in a
  reproducible way.

* bpo-31680: Added "curses.ncurses_version".

* bpo-31908: Fix output of cover files for "trace" module command-line
  tool. Previously emitted cover files only when "--missing" option
  was used. Patch by Michael Selik.

* bpo-31608: Raise a "TypeError" instead of crashing if a
  "collections.deque" subclass returns a non-deque from "__new__".
  Patch by Oren Milman.

* bpo-31425: Add support for sockets of the AF_QIPCRTR address family,
  supported by the Linux kernel. This is used to communicate with
  services, such as GPS or radio, running on Qualcomm devices. Patch
  by Bjorn Andersson.

* bpo-22005: Implemented unpickling instances of "datetime", "date"
  and "time" pickled by Python 2. "encoding='latin1'" should be used
  for successful decoding.

* bpo-27645: "sqlite3.Connection" now exposes a "backup" method, if
  the underlying SQLite library is at version 3.6.11 or higher.  Patch
  by Lele Gaifax.

* bpo-16865: Support arrays >=2GiB in "ctypes".  Patch by Segev Finer.

* bpo-31508: Removed support of arguments in
  "tkinter.ttk.Treeview.selection". It was deprecated in 3.6.  Use
  specialized methods like "selection_set" for changing the selection.

* bpo-29456: Fix bugs in hangul normalization: u1176, u11a7 and u11c3


文档
----

* bpo-21257: Document "http.client.parse_headers()".

* bpo-34764: Improve example of iter() with 2nd sentinel argument.

* bpo-35564: Explicitly set master_doc variable in conf.py for
  compliance with Sphinx 2.0

* bpo-35511: Specified that profile.Profile class doesn't not support
  enable or disable methods. Also, elaborated that Profile object as a
  context manager is only supported in cProfile module.

* bpo-10536: Enhance the gettext docs. Patch by Éric Araujo

* bpo-35089: Remove mention of "typing.io" and "typing.re". Their
  types should be imported from "typing" directly.

* bpo-35038: Fix the documentation about an unexisting "f_restricted"
  attribute in the frame object. Patch by Stéphane Wirtel

* bpo-35042: Replace PEP XYZ by the pep role and allow to use the
  direct links to the PEPs.

* bpo-35044: Fix the documentation with the role "exc" for the
  appropriated exception. Patch by Stéphane Wirtel

* bpo-35035: Rename documentation for "email.utils" to
  "email.utils.rst".

* bpo-34967: Use app.add_object_type() instead of the deprecated
  Sphinx function app.description_unit()

* bpo-34913: Add documentation about the new command line interface of
  the gzip module.

* bpo-32174: chm document displays non-ASCII charaters properly on
  some MBCS Windows systems.

* bpo-11233: Create availability directive for documentation.
  Original patch by Georg Brandl.

* bpo-34790: Document how passing coroutines to asyncio.wait() can be
  confusing.

* bpo-34552: Make clear that "==" operator sometimes is equivalent to
  "is". The "<", "<=", ">" and ">=" operators are only defined where
  they make sense.

* bpo-28617: Fixed info in the stdtypes docs concerning the types that
  support membership tests.

* bpo-20177: Migrate datetime.date.fromtimestamp to Argument Clinic.
  Patch by Tim Hoffmann.

* bpo-34065: Fix wrongly written basicConfig documentation markup
  syntax

* bpo-33460: replaced ellipsis with correct error codes in tutorial
  chapter 3.

* bpo-33847: Add '@' operator entry to index.

* bpo-33409: Clarified the relationship between **PEP 538**'s
  PYTHONCOERCECLOCALE and PEP 540's PYTHONUTF8 mode.

* bpo-33197: Add versionadded tag to the documentation of
  ParameterKind.description

* bpo-17045: Improve the C-API doc for PyTypeObject.  This includes
  adding several quick-reference tables and a lot of missing
  slot/typedef entries. The existing entries were also cleaned up with
  a slightly more consistent format.

* bpo-33736: Improve the documentation of "asyncio.open_connection()",
  "asyncio.start_server()" and their UNIX socket counterparts.

* bpo-23859: Document that "asyncio.wait()" does not cancel its
  futures on timeout.

* bpo-32436: Document **PEP 567** changes to asyncio.

* bpo-33604: 更新HMAC md5默认报告DeprecationWarning，并将在3.8移除。

* bpo-33594: Document "getargspec", "from_function" and "from_builtin"
  as deprecated in their respective docstring, and include version
  since deprecation in DeprecationWarning message.

* bpo-33503: 修复错误的pypi链接

* bpo-33421: 为``typing.AsyncContextManager``添加缺失的文档。

* bpo-33487: BZ2file now emit a DeprecationWarning when buffering=None
  is passed, the deprecation message and documentation also now
  explicitly state it is deprecated since 3.0.

* bpo-33378: Add Korean language switcher for
  https://docs.python.org/3/

* bpo-33276: Clarify that the "__path__" attribute on modules cannot
  be just any value.

* bpo-33201: Modernize documentation for writing C extension types.

* bpo-33195: Deprecate "Py_UNICODE" usage in "c-api/arg" document.
  "Py_UNICODE" related APIs are deprecated since Python 3.3, but it is
  missed in the document.

* bpo-33126: Document PyBuffer_ToContiguous().

* bpo-27212: Modify documentation for the "islice()" recipe to consume
  initial values up to the start index.

* bpo-28247: Update "zipapp" documentation to describe how to make
  standalone applications.

* bpo-18802: Documentation changes for ipaddress.  Patch by Jon Foster
  and Berker Peksag.

* bpo-27428: Update documentation to clarify that
  "WindowsRegistryFinder" implements "MetaPathFinder". (Patch by
  Himanshu Lakhara)

* bpo-28124: The ssl module function ssl.wrap_socket() has been de-
  emphasized and deprecated in favor of the more secure and efficient
  SSLContext.wrap_socket() method.

* bpo-17232: Clarify docs for -O and -OO.  Patch by Terry Reedy.

* bpo-32436: Add documentation for the contextvars module (PEP 567).

* bpo-32800: Update link to w3c doc for xml default namespaces.

* bpo-11015: Update "test.support" documentation.

* bpo-32613: Update the faq/windows.html to use the py command from
  PEP 397 instead of python.

* bpo-8722: Document "__getattr__()" behavior when property "get()"
  method raises "AttributeError".

* bpo-32614: Modify RE examples in documentation to use raw strings to
  prevent "DeprecationWarning" and add text to REGEX HOWTO to
  highlight the deprecation.

* bpo-20709: Remove the paragraph where we explain that os.utime()
  does not support a directory as path under Windows. Patch by Jan-
  Philip Gehrcke

* bpo-32722: Remove the bad example in the tutorial of the Generator
  Expression. Patch by Stéphane Wirtel

* bpo-31972: Improve docstrings for "pathlib.PurePath" subclasses.

* bpo-30607: Use the externalized "python-docs-theme" package when
  building the documentation.

* bpo-8243: Add a note about curses.addch and curses.addstr exception
  behavior when writing outside a window, or pad.

* bpo-32337: Update documentation related with "dict" order.

* bpo-25041: Document "AF_PACKET" in the "socket" module.

* bpo-31432: Clarify meaning of CERT_NONE, CERT_OPTIONAL, and
  CERT_REQUIRED flags for ssl.SSLContext.verify_mode.


测试
----

* bpo-35772: Fix sparse file tests of test_tarfile on ppc64 with the
  tmpfs filesystem. Fix the function testing if the filesystem
  supports sparse files: create a file which contains data and
  "holes", instead of creating a file which contains no data. tmpfs
  effective block size is a page size (tmpfs lives in the page cache).
  RHEL uses 64 KiB pages on aarch64, ppc64, ppc64le, only s390x and
  x86_64 use 4 KiB pages, whereas the test punch holes of 4 KiB.

* bpo-35045: Make ssl tests less strict and also accept TLSv1 as
  system default. The changes unbreaks test_min_max_version on Fedora
  29.

* bpo-32710: "test_asyncio/test_sendfile.py" now resets the event loop
  policy using "tearDownModule()" as done in other tests, to prevent a
  warning when running tests on Windows.

* bpo-33717: test.pythoninfo now logs information of all clocks, not
  only time.time() and time.perf_counter().

* bpo-35488: Add a test to pathlib's Path.match() to verify it does
  not support glob-style ** recursive pattern matching.

* bpo-31731: Fix a race condition in "check_interrupted_write()" of
  test_io: create directly the thread with SIGALRM signal blocked,
  rather than blocking the signal later from the thread. Previously,
  it was possible that the thread gets the signal before the signal is
  blocked.

* bpo-35424: Fix test_multiprocessing_main_handling: use
  "multiprocessing.Pool" with a context manager and then explicitly
  join the pool.

* bpo-35519: Rename "test.bisect" module to "test.bisect_cmd" to avoid
  conflict with "bisect" module when running directly a test like
  "./python Lib/test/test_xmlrpc.py".

* bpo-35513: Replace "time.time()" with "time.monotonic()" in tests to
  measure time delta.

* bpo-34279: "test.support.run_unittest()" no longer raise
  "TestDidNotRun" if the test result contains skipped tests. The
  exception is now only raised if no test have been run and no test
  have been skipped.

* bpo-35412: Add testcase to "test_future4": check unicode literal.

* bpo-26704: 添加了对一个实例方法进行双重修补的测试演示。 补丁作者为
  Anthony Sottile。

* bpo-33725: test_multiprocessing_fork may crash on recent versions of
  macOS.  Until the issue is resolved, skip the test on macOS.

* bpo-35352: Modify test_asyncio to use the certificate set from the
  test directory.

* bpo-35317: Fix "mktime()" overflow error in "test_email": run
  "test_localtime_daylight_true_dst_true()" and
  "test_localtime_daylight_false_dst_true()" with a specific timezone.

* bpo-21263: After several reports that test_gdb does not work
  properly on macOS and since gdb is not shipped by default anymore,
  test_gdb is now skipped on macOS when LLVM Clang has been used to
  compile Python. Patch by Lysandros Nikolaou

* bpo-34279: regrtest issue a warning when no tests have been executed
  in a particular test file. Also, a new final result state is issued
  if no test have been executed across all test files. Patch by Pablo
  Galindo.

* bpo-34962: make docstest in Doc now passes., and is enforced in CI

* bpo-23596: Use argparse for the command line of the gzip module.
  Patch by Antony Lee

* bpo-34537: Fix "test_gdb.test_strings()" when "LC_ALL=C" and GDB was
  compiled with Python 3.6 or earlier.

* bpo-34587: test_socket: Remove RDSTest.testCongestion(). The test
  tries to fill the receiver's socket buffer and expects an error. But
  the RDS protocol doesn't require that. Moreover, the Linux
  implementation of RDS expects that the producer of the messages
  reduces its rate, it's not the role of the receiver to trigger an
  error. The test fails on Fedora 28 by design, so just remove it.

* bpo-34661: Fix test_shutil if unzip doesn't support -t.

* bpo-34200: Fixed non-deterministic flakiness of test_pkg by not
  using the scary test.support.module_cleanup() logic to save and
  restore sys.modules contents between test cases.

* bpo-34569: The experimental PEP 554 data channels now correctly pass
  negative PyLong objects between subinterpreters on 32-bit systems.
  Patch by Michael Felt.

* bpo-34594: Fix usage of hardcoded "errno" values in the tests.

* bpo-34579: Fix test_embed for AIX Patch by Michael Felt

* bpo-34542: Use 3072 RSA keys and SHA-256 signature for test certs
  and keys.

* bpo-11193: Remove special condition for AIX in
  "test_subprocess.test_undecodable_env"

* bpo-34347: Fix "test_utf8_mode.test_cmd_line" for AIX

* bpo-34490: On AIX with AF_UNIX family sockets getsockname() does not
  provide 'sockname', so skip calls to
  transport.get_extra_info('sockname')

* bpo-34391: Fix ftplib test for TLS 1.3 by reading from data socket.

* bpo-11192: Fix "test_socket" on AIX 6.1 and later IPv6 zone id
  supports only supported by inet_pton6_zone() Switch to runtime-based
  platform.system() to establish current platform  rather than build-
  time based sys.platform()

* bpo-34399: Update all RSA keys and DH params to use at least 2048
  bits.

* bpo-34373: Fix "test_mktime" and "test_pthread_getcpuclickid" tests
  for AIX Add range checking for "_PyTime_localtime" for AIX Patch by
  Michael Felt

* bpo-11191: Skip the distutils test 'test_search_cpp' when using XLC
  as compiler patch by aixtools (Michael Felt)

* Improved an error message when mock assert_has_calls fails.

* bpo-33746: Fix test_unittest when run in verbose mode.

* bpo-33901: Fix test_dbm_gnu on macOS with gdbm 1.15: add a larger
  value to make sure that the file size changes.

* bpo-33873: Fix a bug in "regrtest" that caused an extra test to run
  if --huntrleaks/-R was used. Exit with error in case that invalid
  parameters are specified to --huntrleaks/-R (at least one warmup run
  and one repetition must be used).

* bpo-33562: Check that a global asyncio event loop policy is not left
  behind by any tests.

* bpo-33655: 忽略运行在BSD平台的ZFS上时test_posix_fallocate的失败。

* bpo-32962: Fixed test_gdb when Python is compiled with flags -mcet
  -fcf-protection -O0.

* bpo-33358: Fix "test_embed.test_pre_initialization_sys_options()"
  when the interpreter is built with "--enable-shared".

* bpo-32872: Avoid regrtest compatibility issue with namespace
  packages.

* bpo-32517: Fix failing "test_asyncio" on macOS 10.12.2+ due to
  transport of "KqueueSelector" loop was not being closed.

* bpo-32663: Making sure the "SMTPUTF8SimTests" class of tests gets
  run in test_smtplib.py.

* bpo-27643: Test_C test case needs "signed short" bitfields, but the
  IBM XLC compiler (on AIX) does not support this Skip the code and
  test when AIX and XLC are used

  Applicable to Python2-2.7 and later

* bpo-19417: Add test_bdb.py.

* bpo-31809: Add tests to verify connection with secp ECDH curves.


构建
----

* bpo-34691: The _contextvars module is now built into the core Python
  library on Windows.

* bpo-35683: Improved Azure Pipelines build steps and now verifying
  layouts correctly

* bpo-35642: Remove asynciomodule.c from pythoncore.vcxproj

* bpo-35550: Fix incorrect Solaris #ifdef checks to look for __sun &&
  __SVR4 instead of sun when compiling.

* bpo-35499: "make profile-opt" no longer replaces "CFLAGS_NODIST"
  with "CFLAGS". It now adds profile-guided optimization (PGO) flags
  to "CFLAGS_NODIST": existing "CFLAGS_NODIST" flags are kept.

* bpo-35257: Avoid leaking the linker flags from Link Time
  Optimizations (LTO) into distutils when compiling C extensions.

* bpo-35351: When building Python with clang and LTO, LTO flags are no
  longer passed into CFLAGS to build third-party C extensions through
  distutils.

* bpo-35139: Fix a compiler error when statically linking "pyexpat" in
  "Modules/Setup".

* bpo-35059: PCbuild: Set InlineFunctionExpansion to
  OnlyExplicitInline ("/Ob1" option) in pyproject.props in Debug mode
  to expand functions marked as inline. This change should make Python
  compiled in Debug mode a little bit faster on Windows.

* bpo-35011: Restores the use of pyexpatns.h to isolate our embedded
  copy of the expat C library so that its symbols do not conflict at
  link or dynamic loading time with an embedding application or other
  extension modules with their own version of libexpat.

* bpo-28015: Have --with-lto works correctly with clang.

* bpo-34765: Update the outdated install-sh file to the latest
  revision from automake v1.16.1

* bpo-34585: Check for floating-point byte order in configure.ac using
  compilation tests instead of executing code, so that these checks
  work in cross-compiled builds.

* bpo-34710: Fixed SSL module build with OpenSSL & pedantic CFLAGS.

* bpo-34582: Add JUnit XML output for regression tests and update
  Azure DevOps builds.

* bpo-34081: Make Sphinx warnings as errors in the Docs Makefile.

* bpo-34555: Fix for case where it was not possible to have both
  "HAVE_LINUX_VM_SOCKETS_H" and "HAVE_SOCKADDR_ALG" be undefined.

* bpo-33015: Fix an undefined behaviour in the pthread implementation
  of "PyThread_start_new_thread()": add a function wrapper to always
  return "NULL".

* bpo-34245: The Python shared library is now installed with write
  permission (mode 0755), which is the standard way of installing such
  libraries.

* bpo-34121: Fix detection of C11 atomic support on clang.

* bpo-32430: Rename Modules/Setup.dist to Modules/Setup, and remove
  the necessity to copy the former manually to the latter when
  updating the local source tree.

* bpo-30345: Add -g to LDFLAGS when compiling with LTO to get debug
  symbols.

* bpo-5755: Move "-Wstrict-prototypes" option to "CFLAGS_NODIST" from
  "OPT". This option emitted annoying warnings when building extension
  modules written in C++.

* bpo-33614: Ensures module definition files for the stable ABI on
  Windows are correctly regenerated.

* bpo-33648: The --with-c-locale-warning configuration flag has been
  removed. It has had no effect for about a year.

* bpo-33522: Enable CI builds on Visual Studio Team Services at
  https://python.visualstudio.com/cpython

* bpo-33512: configure's check for "long double" has been simplified

* bpo-33483: C compiler is now correctly detected from the standard
  environment variables. --without-gcc and --with-icc options have
  been removed.

* bpo-33394: Enable the verbose build for extension modules, when GNU
  make is passed macros on the command line.

* bpo-33393: Update config.guess and config.sub files.

* bpo-33377: Add new triplets for mips r6 and riscv variants (used in
  extension suffixes).

* bpo-32232: By default, modules configured in "Modules/Setup" are no
  longer built with "-DPy_BUILD_CORE". Instead, modules that
  specifically need that preprocessor definition include it in their
  individual entries.

* bpo-33182: The embedding tests can once again be built with clang
  6.0

* bpo-33163: Upgrade pip to 9.0.3 and setuptools to v39.0.1.

* bpo-33012: gcc 8 has added a new warning heuristic to detect invalid
  function casts and a stock python build seems to hit that warning
  quite often.  The most common is the cast of a METH_NOARGS function
  (that uses just one argument) to a PyCFunction. Fix this by adding a
  dummy argument to all functions that implement METH_NOARGS.

* bpo-32898: Fix the python debug build when using COUNT_ALLOCS.

* bpo-29442: Replace optparse with argparse in setup.py


Windows
-------

* bpo-35890: Fix API calling consistency of GetVersionEx and wcstok.

* bpo-32560: The "py" launcher now forwards its "STARTUPINFO"
  structure to child processes.

* bpo-35854: Fix EnvBuilder and --symlinks in venv on Windows

* bpo-35811: Avoid propagating venv settings when launching via py.exe

* bpo-35797: Fix default executable used by the multiprocessing module

* bpo-35758: Allow building on ARM with MSVC.

* bpo-29734: Fix handle leaks in os.stat on Windows.

* bpo-35596: Use unchecked PYCs for the embeddable distro to avoid
  zipimport restrictions.

* bpo-35596: Fix vcruntime140.dll being added to embeddable distro
  multiple times.

* bpo-35402: 更新 Windows 构建以使用 Tcl 和 Tk 8.6.9

* bpo-35401: 将Windows内部版本更新到OpenSSL 1.1.0j

* bpo-34977: venv on Windows will now use a python.exe redirector
  rather than copying the actual binaries from the base environment.

* bpo-34977: Adds support for building a Windows App Store package

* bpo-35067: Remove _distutils_findvs module and use vswhere.exe
  instead.

* bpo-32557: Allow shutil.disk_usage to take a file path on Windows

* bpo-34770: Fix a possible null pointer dereference in
  pyshellext.cpp.

* bpo-34603: Fix returning structs from functions produced by MSVC

* bpo-34581: Guard MSVC-specific code in socketmodule.c with "#ifdef
  _MSC_VER".

* bpo-34532: Fixes exit code of list version arguments for py.exe.

* bpo-34062: Fixed the '--list' and '--list-paths' arguments for the
  py.exe launcher

* bpo-34225: Ensure INCLUDE and LIB directories do not end with a
  backslash.

* bpo-34011: A suite of code has been changed which copied across DLLs
  and init.tcl from the running Python location into a venv being
  created. These copies are needed only when running from a Python
  source build, and the copying code is now only run when that is the
  case, rather than whenever a venv is created.

* bpo-34006: Revert line length limit for Windows help docs. The line-
  length limit is not needed because the pages appear in a separate
  app rather than on a browser tab.  It can also interact badly with
  the DPI setting.

* bpo-31546: Restore running PyOS_InputHook while waiting for user
  input at the prompt. The restores integration of interactive GUI
  windows (such as Matplotlib figures) with the prompt on Windows.

* bpo-30237: Output error when ReadConsole is canceled by
  CancelSynchronousIo instead of crashing.

* bpo-33895: GIL is released while calling functions that acquire
  Windows loader lock.

* bpo-33720: Reduces maximum marshal recursion depth on release
  builds.

* bpo-29097: Fix bug where "datetime.fromtimestamp()" erroneously
  throws an "OSError" on Windows for values between 0 and 86400. Patch
  by Ammar Askar.

* bpo-33316: PyThread_release_lock always fails

* bpo-33184: 在Windows安装程序中将OpenSSL更新为1.1.0h.

* bpo-32890: Fix usage of GetLastError() instead of errno in
  os.execve() and os.truncate().

* bpo-33016: Fix potential use of uninitialized memory in
  nt._getfinalpathname

* bpo-32903: Fix a memory leak in os.chdir() on Windows if the current
  directory is set to a UNC path.

* bpo-32901: Update Tcl and Tk versions to 8.6.8

* bpo-31966: Fixed WindowsConsoleIO.write() for writing empty data.

* bpo-32409: Ensures activate.bat can handle Unicode contents.

* bpo-32457: Improves handling of denormalized executable path when
  launching Python.

* bpo-32370: Use the correct encoding for ipconfig output in the uuid
  module. Patch by Segev Finer.

* bpo-29248: Fix "os.readlink()" on Windows, which was mistakenly
  treating the "PrintNameOffset" field of the reparse data buffer as a
  number of characters instead of bytes. Patch by Craig Holmquist and
  SSE4.

* bpo-1104: Correctly handle string length in
  "msilib.SummaryInfo.GetProperty()" to prevent it from truncating the
  last character.


macOS
-----

* bpo-35401: 在MacOS安装程序中将OpenSSL更新为1.1.0j。

* bpo-35025: Properly guard the use of the "CLOCK_GETTIME" et al.
  macros in "timemodule" on macOS.

* bpo-24658: On macOS, fix reading from and writing into a file with a
  size larger than 2 GiB.

* bpo-34405: 在MacOS安装程序中将OpenSSL更新为1.1.0i 。

* bpo-33635: In macOS stat on some file descriptors (/dev/fd/3 f.e)
  will result in bad file descriptor OSError. Guard against this
  exception was added in is_dir, is_file and similar methods.
  DirEntry.is_dir can also throw this exception so
  _RecursiveWildcardSelector._iterate_directories was also extended
  with the same error ignoring pattern.

* bpo-13631: The .editrc file in user's home directory is now
  processed correctly during the readline initialization through
  editline emulation on macOS.

* bpo-33184: 在MacOS安装程序中将OpenSSL更新为1.1.0h。

* bpo-32726: Build and link with private copy of Tcl/Tk 8.6 for the
  macOS 10.6+ installer. The 10.9+ installer variant already does
  this.  This means that the Python 3.7 provided by the python.org
  macOS installers no longer need or use any external versions of
  Tcl/Tk, either system-provided or user-installed, such as ActiveTcl.

* bpo-32901: Update macOS 10.9+ installer to Tcl/Tk 8.6.8.

* bpo-31903: In "_scproxy", drop the GIL when calling into
  "SystemConfiguration" to avoid deadlocks.


IDLE
----

* bpo-35770: IDLE macosx deletes Options => Configure IDLE. It
  previously deleted Window => Zoom Height by mistake. (Zoom Height is
  now on the Options menu).  On Mac, the settings dialog is accessed
  via Preferences on the IDLE menu.

* bpo-35769: 将 IDLE 的新文件名从 'Untitled' 更改为 'untitled'

* bpo-35660: Fix imports in idlelib.window.

* bpo-35641: 当函数没有文档字符串时正确地格式化 "calltip"。

* bpo-33987: Use ttk Frame for ttk widgets.

* bpo-34055: Fix erroneous 'smart' indents and newlines in IDLE Shell.

* bpo-35591: Find Selection now works when selection not found.

* bpo-35196: Speed up squeezer line counting.

* bpo-35598: Update config_key: use PEP 8 names and ttk widgets, make
  some objects global, and add tests.

* bpo-28097: Add Previous/Next History entries to Shell menu.

* bpo-35208: Squeezer now properly counts wrapped lines before
  newlines.

* bpo-35555: Gray out Code Context menu entry when it's not
  applicable.

* bpo-35521: Document the IDLE editor code context feature. Add some
  internal references within the IDLE doc.

* bpo-22703: The Code Context menu label now toggles between Show/Hide
  Code Context. The Zoom Height menu now toggles between Zoom/Restore
  Height. Zoom Height has moved from the Window menu to the Options
  menu.

* bpo-35213: Where appropriate, use 'macOS' in idlelib.

* bpo-34864: On macOS, warn if the system preference "Prefer tabs when
  opening documents" is set to "Always".

* bpo-34864: Document two IDLE on MacOS issues. The System Preferences
  Dock "prefer tabs always" setting disables some IDLE features.
  Menus are a bit different than as described for Windows and Linux.

* bpo-35202: Remove unused imports from lib/idlelib

* bpo-33000: Document that IDLE's shell has no line limit. A program
  that runs indefinitely can overfill memory.

* bpo-23220: Explain how IDLE's Shell displays output.

* bpo-35099: Improve the doc about IDLE running user code.   The
  section is renamed from "IDLE -- console differences" is renamed
  "Running user code". It mostly covers the implications of using
  custom sys.stdxxx objects.

* bpo-35097: Add IDLE doc subsection explaining editor windows. Topics
  include opening, title and status bar, .py* extension, and running.

* bpo-35093: Document the IDLE document viewer in the IDLE doc. Add a
  paragraph in "Help and preferences", "Help sources" subsection.

* bpo-35088: Update idlelib.help.copy_string docstring. We now use git
  and backporting instead of hg and forward merging.

* bpo-35087: Update idlelib help files for the current doc build. The
  main change is the elimination of chapter-section numbers.

* bpo-34548: Use configured color theme for read-only text views.

* bpo-1529353: Enable "squeezing" of long outputs in the shell, to
  avoid performance degradation and to clean up the history without
  losing it. Squeezed outputs may be copied, viewed in a separate
  window, and "unsqueezed".

* bpo-34047: Fixed mousewheel scrolling direction on macOS.

* bpo-34275: Make IDLE calltips always visible on Mac. Some MacOS-tk
  combinations need .update_idletasks(). Patch by Kevin Walzer.

* bpo-34120: Fix unresponsiveness after closing certain windows and
  dialogs.

* bpo-33975: Avoid small type when running htests. Since part of the
  purpose of human-viewed tests is to determine that widgets look
  right, it is important that they look the same for testing as when
  running IDLE.

* bpo-33905: Add test for idlelib.stackview.StackBrowser.

* bpo-33924: Change mainmenu.menudefs key 'windows' to 'window'. Every
  other menudef key is lowercase version of main menu entry.

* bpo-33906: Rename idlelib.windows as window Match Window on the main
  menu and remove last plural module name.

* bpo-33917: Fix and document idlelib/idle_test/template.py. The
  revised file compiles, runs, and tests OK.  idle_test/README.txt
  explains how to use it to create new IDLE test files.

* bpo-33904: IDLE: In rstrip, rename class RstripExtension as Rstrip

* bpo-33907: For consistency and clarity, rename an IDLE module and
  classes. Module calltips and its class CallTips are now calltip and
  Calltip. In module calltip_w, class CallTip is now CalltipWindow.

* bpo-33856: Add "help" in the welcome message of IDLE

* bpo-33839: IDLE: refactor ToolTip and CallTip and add documentation
  and tests

* bpo-33855: Minimally test all IDLE modules. Add missing files,
  import module, instantiate classes, and check coverage. Check
  existing files.

* bpo-33656: On Windows, add API call saying that tk scales for DPI.
  On Windows 8.1+ or 10, with DPI compatibility properties of the
  Python binary unchanged, and a monitor resolution greater than 96
  DPI, this should make text and lines sharper.  It should otherwise
  have no effect.

* bpo-33768: Clicking on a context line moves that line to the top of
  the editor window.

* bpo-33763: IDLE: Use read-only text widget for code context instead
  of label widget.

* bpo-33664: Scroll IDLE editor text by lines. Previously, the mouse
  wheel and scrollbar slider moved text by a fixed number of pixels,
  resulting in partial lines at the top of the editor box.  The change
  also applies to the shell and grep output windows, but not to read-
  only text views.

* bpo-33679: Enable theme-specific color configuration for Code
  Context. Use the Highlights tab to see the setting for built-in
  themes or add settings to custom themes.

* bpo-33642: Display up to maxlines non-blank lines for Code Context.
  If there is no current context, show a single blank line.

* bpo-33628: IDLE: Cleanup codecontext.py and its test.

* bpo-33564: IDLE's code context now recognizes async as a block
  opener.

* bpo-21474: Update word/identifier definition from ascii to unicode.
  In text and entry boxes, this affects selection by double-click,
  movement left/right by control-left/right, and deletion left/right
  by control-BACKSPACE/DEL.

* bpo-33204: IDLE: consistently color invalid string prefixes. A 'u'
  string prefix cannot be paired with either 'r' or 'f'. Consistently
  color as much of the prefix, starting at the right, as is valid.
  Revise and extend colorizer test.

* bpo-32984: Set "__file__" while running a startup file.  Like
  Python, IDLE optionally runs one startup file in the Shell window
  before presenting the first interactive input prompt.  For IDLE,
  "-s" runs a file named in environmental variable  "IDLESTARTUP" or
  "PYTHONSTARTUP"; "-r file" runs "file".  Python sets "__file__" to
  the startup file name before running the file and unsets it before
  the first prompt.  IDLE now does the same when run normally, without
  the "-n" option.

* bpo-32940: Simplify and rename StringTranslatePseudoMapping in
  pyparse.

* bpo-32916: Change "str" to "code" in pyparse.

* bpo-32905: Remove unused code in pyparse module.

* bpo-32874: Add tests for pyparse.

* bpo-32837: Using the system and place-dependent default encoding for
  open() is a bad idea for IDLE's system and location-independent
  files.

* bpo-32826: Add "encoding=utf-8" to open() in IDLE's test_help_about.
  GUI test test_file_buttons() only looks at initial ascii-only lines,
  but failed on systems where open() defaults to 'ascii' because
  readline() internally reads and decodes far enough ahead to
  encounter a non-ascii character in CREDITS.txt.

* bpo-32831: Add docstrings and tests for codecontext.

* bpo-32765: Update configdialog General tab docstring to add new
  widgets to the widget list.


工具/示例
---------

* bpo-35884: Add a benchmark script for timing various ways to access
  variables: "Tools/scripts/var_access_benchmark.py".

* bpo-34989: python-gdb.py now handles errors on computing the line
  number of a Python frame.

* bpo-20260: Argument Clinic now has non-bitwise unsigned int
  converters.

* bpo-32962: python-gdb now catches "UnicodeDecodeError" exceptions
  when calling "string()".

* bpo-32962: python-gdb now catches ValueError on read_var(): when
  Python has no debug symbols for example.

* bpo-33189: **pygettext.py** now recognizes only literal strings as
  docstrings and translatable strings, and rejects bytes literals and
  f-string expressions.

* bpo-31920: Fixed handling directories as arguments in the
  "pygettext" script. Based on patch by Oleg Krasnikov.

* bpo-29673: Fix pystackv and pystack gdbinit macros.

* bpo-25427: Remove the pyvenv script in favor of "python3 -m venv" in
  order to lower confusion as to what Python interpreter a virtual
  environment will be created for.

* bpo-32885: Add an "-n" flag for "Tools/scripts/pathfix.py" to
  disable automatic backup creation (files with "~" suffix).

* bpo-32222: Fix pygettext not extracting docstrings for functions
  with type annotated arguments. Patch by Toby Harradine.

* bpo-31583: Fix 2to3 for using with --add-suffix option but without
  --output-dir option for relative path to files in current directory.


C API
-----

* bpo-35713: The "PyByteArray_Init()" and "PyByteArray_Fini()"
  functions have been removed. They did nothing since Python 2.7.4 and
  Python 3.2.0, were excluded from the limited API (stable ABI), and
  were not documented.

* bpo-33817: Fixed "_PyBytes_Resize()" for empty bytes objects.

* bpo-35322: Fix memory leak in "PyUnicode_EncodeLocale()" and
  "PyUnicode_EncodeFSDefault()" on error handling.

* bpo-35059: The following C macros have been converted to static
  inline functions: "Py_INCREF()", "Py_DECREF()", "Py_XINCREF()",
  "Py_XDECREF()", "PyObject_INIT()", "PyObject_INIT_VAR()".

* bpo-35296: "make install" now also installs the internal API:
  "Include/internal/*.h" header files.

* bpo-35081: Internal APIs surrounded by "#ifdef Py_BUILD_CORE" have
  been moved from "Include/*.h" headers to new header files
  "Include/internal/pycore_*.h".

* bpo-35259: 基于 Py_LIMITED_API 有条件地声明 "Py_FinalizeEx()" (3.6
  中新增)。 补丁作者 Arthur Neufeld。

* bpo-35081: The "_PyObject_GC_TRACK()" and "_PyObject_GC_UNTRACK()"
  macros have been removed from the public C API.

* bpo-35134: Creation of a new "Include/cpython/" subdirectory.

* bpo-34725: Adds _Py_SetProgramFullPath so embedders may override
  sys.executable

* bpo-34910: Ensure that "PyObject_Print()" always returns "-1" on
  error.  Patch by Zackery Spytz.

* bpo-34523: Py_DecodeLocale() and Py_EncodeLocale() now use the UTF-8
  encoding on Windows if Py_LegacyWindowsFSEncodingFlag is zero.

* bpo-34193: Fix pluralization in TypeError messages in getargs.c and
  typeobject.c: '1 argument' instead of '1 arguments' and '1 element'
  instead of '1 elements'.

* bpo-34127: Return grammatically correct error message based on
  argument count. Patch by Karthikeyan Singaravelan.

* bpo-23927: Fixed "SystemError" in "PyArg_ParseTupleAndKeywords()"
  when the "w*" format unit is used for optional parameter.

* bpo-32455: Added "PyCompile_OpcodeStackEffectWithJump()".

* bpo-34008: Py_Main() can again be called after Py_Initialize(), as
  in Python 3.6.

* bpo-32500: Fixed error messages for "PySequence_Size()",
  "PySequence_GetItem()", "PySequence_SetItem()" and
  "PySequence_DelItem()" called with a mapping and "PyMapping_Size()"
  called with a sequence.

* bpo-33818: "PyExceptionClass_Name()" will now return "const char *"
  instead of "char *".

* bpo-33042: Embedding applications may once again call
  PySys_ResetWarnOptions, PySys_AddWarnOption, and PySys_AddXOption
  prior to calling Py_Initialize.

* bpo-32374: Document that m_traverse for multi-phase initialized
  modules can be called with m_state=NULL, and add a sanity check

* bpo-30863: "PyUnicode_AsWideChar()" and
  "PyUnicode_AsWideCharString()" no longer cache the "wchar_t*"
  representation of string objects.


Python 3.7.0 正式版
===================

*发布日期: 2018-06-27*


库
--

